;Source code of TR-DOS 6.11Q for SjASMPlus

;16.1.2013 - modified memory paging routines for more ZX clones VELESOFT ( version 6.11Q )
;   "H H + H P  TR-DOS 5.04T (5.03)  ,    ,    ."
; :   , 04.04.1996.
;     , : Spectre, 19.10.2005
;   6.11: 1999 CompoWellcome, 2006 Alone Coder
;, ,  : Keeper, 2009 - 2010 :)
;: CP-1251

            DEVICE  ZXSPECTRUM48

;=========================================== SETUP ==================================================

;------- select only one memory model ------
       DEFINE RAM_ZX_PROFI_1024
;       DEFINE RAM_PENTAGON_1024
;       DEFINE RAM_SCORPION_1024
;       DEFINE RAM_ZXM_PHOENIX


;------- select for autoboot tr-dos ------
;       DEFINE RUN_BOOT_B_ON_DOS_START
;       BOOT_ON_CMD_8


;------- select for enable testing drives -------
;       DEFINE TEST_DRIVES


;------- select for madrom support -------
;       DEFINE COMPILE_FOR_MADROM


;------- select for active patch for fix HL' register -------
       DEFINE FIX_HL

;------- select for enable NMI code -------
;       DEFINE NMI_ENABLE

;------- number of ramdisc drive -------
RMD_DRIVE   EQU     #03     ;ramdisc on drive A(#00),B(#01),C(#02),D(#03)

;------- ramdisc size (free space) --------
RMD_SIZE    EQU     #09F0   ;ramdisc size(only free sectors = full capacity - 16 sectors)
;( #0DF0=896kB / #0BF0=768kB / #09F0=640kB / #07F0=512kB / #05F0=384kB / #03F0=256kB / #01F0=128kB )

;====================================================================================================



            ORG     0
            

            IFDEF   COMPILE_FOR_MADROM
F_PAGE          EQU     #5C81
            ELSE
F_PAGE          EQU     #5B5C
            ENDIF
            
            
; 0.   .

x0000       DI
            LD      DE,#FFFF
            LD      A,7
            JR      x0009

; 8.  .  DE    ,  A - 7   .     9.

x0008       NOP
x0009       OUT     (#FE),A
            LD      A,#3F
            JR      x0013
x000F       NOP

; #10.        A.

x0010       JP      x3D82

; #13.  .  DE    ,   ,   A        .

x0013       LD      I,A
            JP      x001B

; #18.     .

x0018       JP      x2707

; #1B.  ,   #24.

x001B       NOP
            NOP
            NOP
            JR      x0024

; #20.        .          RST #20. :

x0020       JP      x2F72
x0023       RET

; #24.  .  DE    ,   ,   A        .

x0024       LD      H,D         ;     HL
            LD      L,E
            JR      x002B       ; 

; #28.       ,    C.

x0028       JP      x2323

; #2B.  .  DE  HL    ,   ,   A        .

x002B       XOR     A
            LD      B,A
            LD      C,A
            LD      SP,HL
            JR      x003A

            DISPLAY "Free space at ",$,": ",/D,#0038-$," byte(s)"
            DS      #0038-$, #FF

; #38.   .

x0038       EI
            RET

; #3A.  .  DE      HL -  ,   ,      2   .

x003A       PUSH    BC,BC,BC,BC
            PUSH    BC,BC,BC,BC
            LD      HL,#A500
            ADD     HL,SP
            JR      C,x003A
            LD      (#5CB4),HL  ; P_RAMT
            LD      DE,#3EAF    ;   UDG
            LD      BC,#A8      ; UDG - #A8 
            LD      A,E
            EX      DE,HL       ;    UDG  HL
            LD      SP,#6000    ;  
            LD      (#5F00),HL  ;    UDG
            LD      HL,#79      ;  #79
            PUSH    HL          ;   
            LD      HL,x3D2F    ;    TR-DOS
            PUSH    HL          ;   
            LD      HL,#B8ED    ;  LDDR
            JR      x0069       ; UDG

; #66.    .

x0066
            IFDEF   NMI_ENABLE
                JP      x2A56
                ELSE
                RETN
                NOP
            ENDIF

; #69.    .   HL  ,   (#5F00  HL)    HL  .

x0069       LD      (#5F10),HL  ;    
            PUSH    AF          ; AF
            LD      A,#C9       ;  RET
            LD      (#5F12),A   ;   
            POP     AF          ; AF
            LD      HL,(#5F00)  ;    UDG
            JP      #5F10       ;   

; #79.  .  P_RAMT,  ,  ,   DE     1   .

x0079       EX      DE,HL       ;  UDG  HL
            INC     HL
            LD      (#5C7B),HL  ;  UDG
            DEC     HL          ; 
            LD      BC,#0540    ; RASP  PIP
            LD      (#5C38),BC
            LD      (#5CB2),HL  ; RAMTOP
            LD      HL,#3C00    ; CHARS
            LD      (#5C36),HL
            LD      HL,(#5CB2)  ;  RAMTOP
            LD      (HL),#3E    ;   GO SUB
            DEC     HL          ; 
            LD      SP,HL       ;  
            DEC     HL          ; ERR_SP
            DEC     HL
            LD      (#5C3D),HL
            LD      DE,#1303    ;   
            PUSH    DE          ; 
            IM      1           ;   
            LD      IY,#5C3A    ;  IY
            LD      HL,#5CB6    ; CHANS
            LD      (#5C4F),HL
            LD      DE,#15AF    ;      
            LD      BC,#15      ;  - #15 
            EX      DE,HL
            CALL    x0117       ;     
            EX      DE,HL
            DEC     HL          ; DATADD
            LD      (#5C57),HL
            INC     HL          ; 
            LD      (#5C53),HL  ; PROG
            LD      (#5C4B),HL  ; VARS
            LD      (HL),#80    ; 
            INC     HL          ; 
            LD      (#5C59),HL  ; E_LINE
            LD      (HL),#D     ; 
            INC     HL          ; 
            LD      (HL),#80    ; 
            INC     HL          ; 
            LD      (#5C61),HL  ; WORKSP
            LD      (#5C63),HL  ; STKBOT
            LD      (#5C65),HL  ; STKEND
            LD      A,#38       ; 
            LD      (#5C8D),A   ; ATTR_P
            LD      (#5C8F),A   ; ATTR_T
            LD      (#5C48),A   ; BORDER
            LD      HL,#0223    ; REPDEL  REPPER
            LD      (#5C09),HL
            DEC     (IY-#3A)    ;  
            DEC     (IY-#36)
            LD      HL,#15C6    ;  STRMS   
            LD      DE,#5C10    ;  STRMS
            LD      BC,#0E      ;  - #18 
            CALL    x0117       ;   
            SET     1,(IY+1)    ;  3
            LD      HL,#5CC2    ;  RET  
            LD      (HL),#C9
            
            RST     #20         ;    
            DW      #0EDF
            LD      HL,#5C6B    ;  
            LD      (HL),2
            LD      HL,#128B    ;  #128B
            PUSH    HL
            
            IFDEF   RUN_BOOT_B_ON_DOS_START
                LD      A,#AA       ;  RUN "boot"
            ELSE
                LD      A,#00
            ENDIF

            IFDEF   COMPILE_FOR_MADROM
                LD      (#5B00),A
            ELSE
                LD      (#5C81),A
            ENDIF
            
            EI                  ; 
            JP      x3D31       ;  TR-DOS

; #117.   LDIR.  HL, DE  BC    #C9   #5F12.

x0117       LD      (#5F00),HL  ; HL
            LD      HL,x3D2F    ;    TR-DOS
            PUSH    HL          ;   
            LD      HL,#B0ED    ;  LDIR
            LD      (#5F10),HL  ;   
            LD      HL,(#5F00)  ; HL
            JP      #5F10       ;   

; #12A.       .  #5D10   .

x012A       CALL    x20E5       ;    
            CALL    x1D97       ; 
            LD      HL,(#5C59)  ; ,    
            INC     HL          ;  
            LD      E,(HL)      ;  
            INC     HL
            LD      D,(HL)
            LD      A,D         ; 0?
            OR      E
            EX      DE,HL       ;   HL
            JR      Z,x0140     ;   0,   
            XOR     A
            LD      (#5D10),A
x0140       PUSH    HL          ;   
            CALL    x0232       ;     
            POP     HL          ;   
            LD      (#5C42),HL  ; 
            XOR     A           ;    
            LD      (#5C44),A
            RST     #20         ;   ,     
            DW      #16B0
            LD      HL,(#5C53)  ; RESTORE
            DEC     HL
            LD      (#5C57),HL
            LD      SP,(#5C3D)  ; 
            LD      A,(#5D10)   ; ?
            OR      A
            LD      HL,#1B76    ;     
            JR      Z,x0166     ; ,   
            RST     #20         ; O.K.
            DW      #1BB0
x0166       PUSH    HL          ;        
            LD      HL,#5CC2    ;       
            PUSH    HL
            RET                 ;      

; #16C.  ,   #3D1A,     .

x016C       CALL    x20F1       ; 
            CALL    x294A       ; 
            LD      A,#FF       ;  
            LD      (#5D15),A
            XOR     A           ; #5CF7
            LD      (#5CF7),A
            LD      A,#AA       ;  
            LD      (#5D17),A
            LD      HL,#201     ;  
            LD      (#5D1A),HL
            LD      HL,0        ; SP
            ADD     HL,SP
            LD      (#5D1C),HL
            DEC     HL          ;    
            DEC     HL          ; 
            LD      SP,HL
            CALL    x021D       ;    
            LD      HL,(#5CB2)  ;    RAMTOP?
            LD      DE,(#5C5D)
            SBC     HL,DE
            EX      DE,HL
            JR      NC,x01A5    ; ,      
            OR      A           ;
            LD      DE,#101
            SBC     HL,DE
x01A5       LD      (#5C5D),HL
x01A8       CALL    x01C7       ;   ENTER?
x01AB       JP      Z,x01D3     ; ,  
            CP      #EA         ; REM?
            INC     HL          ; 
            JR      NZ,x01A8    ; ,   
            CALL    x01C7       ;   ENTER?
            JR      Z,x01AB     ; ,  
            CP      ":"         ; ?
            JP      NZ,x01D3    ; ,  
            INC     HL          ; 
            CALL    x3048       ; 
            LD      HL,(#5D11)
            JP      x030A       ; 

; #1C7.      HL        Z   0, #D  #80,  NZ.

x01C7       LD      A,(HL)      ;    
            CP      #D          ; #D?
            RET     Z           ; ,  
            CP      #80         ; #80?
            RET     Z           ; ,  
            OR      A           ;   
            RET                 ;

x01D0       CALL    x1E43

; #1D3.  . :  #5CB6, #5D0C, #5D0F, #5D11, #5D18, #5D1A, #5D1C  #5D1F. :  SP   #5D1C,   BC  .

x01D3       LD      HL,0        ; ,  
            LD      (#5CF8),HL
            CALL    x20E5       ;  ,   
            CALL    x1D63       ; ,     
            LD      HL,#5D17    ;  
            LD      (HL),#AA
            LD      HL,#5D1F    ;    ?
            LD      A,(HL)
            OR      A
            LD      (HL),0      ;      
            JR      NZ,x01F3    ;      , 
            CALL    x1E1C       ;   5- 
            CALL    x0212       ;     
x01F3       LD      SP,(#5D1C)  ;  SP   #5D1C
            LD      HL,(#5D1A)  ;     
            LD      BC,(#5D0F)  ;  BC  
            LD      B,0
            JP      (HL)        ;   

; #201.   . :  #5C3A  #5D13.

x0201       CALL    x0232       ;  #5C3D   #5D13
            BIT     7,(IY+0)    ; ?
            RET     NZ          ; ,  
            LD      DE,#5CC2    ;  RET  
            LD      SP,(#5C3D)  ; SP   
            PUSH    DE          ;   
            RET

; #212.     .   #5C5D     .       .

x0212       CALL    x1D8C       ;   
            CP      #D          ; ENTER?
            RET     Z           ; ,  
            CALL    x1E2A       ;   
            JR      x0212       ;

; #21D.    . :  #5D1C     2  ,       . :   #5C3D   #5D13,   #5C3D  ,     .

x021D       LD      HL,(#5C3D)  ;   #5C3D
            LD      (#5D13),HL
            LD      HL,(#5D1C)  ;   #5D12
            DEC     HL          ;   
            DEC     HL
            LD      (#5C3D),HL  ; #5C3D
            LD      DE,x3D16    ;   
            LD      (HL),E      ;    
            INC     HL
            LD      (HL),D
            RET                 ;

; #232.   #5C3D   #5D13.  #5D13.

x0232       LD      HL,(#5D13)
            LD      (#5C3D),HL
            RET

; #239.    .     #27B (  "boot").

x0239       LD      HL,0        ; #5CF7  #5CF8
            LD      (#5CF7),HL
            ADD     HL,SP       ; SP
            LD      (#5D1C),HL
            DEC     HL          ;    
            DEC     HL          ; 
            LD      SP,HL
            CALL    SETERRAD    ;    
            LD      HL,#5D17    ; ?
            LD      A,(HL)
            CP      #AA
            LD      A,0         ; 
            LD      (#5D0F),A
            JP      Z,x02CB     ;   ,     
            LD      (HL),#AA    ;     
            CALL    x1D97       ; 
            CALL    x1D88       ;  2
            LD      HL,x0360    ;  
            RST     #18

;            CALL    TCH4        ;#399C (VELESOFT - removed to new code...)
            CALL    SHOW_TXT    ;(VELESOFT - show new text + jump to TCH4)

            NOP
            CALL    TEST_R      ;#3837
            EI
            JR      NZ,$+6
            LD      HL,TfndRD   ;#1000 ;"Found R/D"
            RST     #18
x0271                           ;???? "boot" ??????????
            IFDEF   COMPILE_FOR_MADROM
                LD      A,(#5B00)
            ELSE
                LD      A,(#5C81)    ; "boot" ?
            ENDIF
  
            CP      #AA
            JR      NZ,x02CB    ; ,     
            CALL    x20F1       ; 
x027B       LD      HL,(#5C59)  ;   
            LD      A,#FE       ;   "boot"
            LD      (#5D0E),A
            LD      (HL),#F7    ;  RUN "boot"
            INC     HL
            LD      (HL),#22
            INC     HL
            LD      (HL),"b"
            INC     HL
            LD      (HL),"o"
            INC     HL
            LD      (HL),"o"
            INC     HL
            LD      (HL),"t"
            INC     HL
            LD      (HL),#22
            INC     HL
            LD      (#5C5B),HL  ;  
            LD      (HL),#D     ;ENTER
            INC     HL
            LD      (HL),#80    ; 
            INC     HL
            LD      (#5C61),HL  ;  WORKSP
            LD      (#5C63),HL  ;    
            LD      (#5C65),HL
            SET     3,(IY+1)    ;  L
            JR      x02EF       ; 

; #2B0.      HL   DE.

x02B0       LD      B,3         ; 
x02B2       LD      A,(HL)      ; 
            LD      (DE),A
            INC     HL          ;  
            INC     DE
            DJNZ    x02B2       ;  
            RET                 ;

; #2B9.  .  A    .

x02B9       LD      B,#20       ;#20 
x02BB       PUSH    BC          ;  
            XOR     8           ;  3
            OUT     (#FF),A     ;  
            PUSH    AF          ;   
            LD      A,5         ;  #462A 
            CALL    x3DFF
            POP     AF          ;   
            POP     BC          ;  
            DJNZ    x02BB       ;  
            RET                 ;

; #2CB.  .    :
;#2EF -  .       ;
;#30A -  .    #1D3, #5D11    #5D11 HL.

x02CB       LD      HL,(#5D1C)  ; 
            DEC     HL
            DEC     HL
            LD      SP,HL
            CALL    x20F1       ; 
            CALL    x1D83       ;  0
            LD      A,(#5D16)   ;  D:
            OR      3
            CALL    x02B9       ; 
            LD      A,(#5D16)   ;  
            CALL    x02B9
            XOR     A           ;   
            LD      (#5D15),A
            CALL    x2135       ; 
            CALL    x3032       ;  
x02EF       CALL    x1D9F       ;  
            LD      HL,x02CB    ;   
            LD      (#5D1A),HL
            XOR     A           ;  
            LD      (#5D0F),A
            LD      HL,(#5C59)  ;   
            PUSH    HL          ; 
            LD      DE,#5D20    ; 
            CALL    x02B0       ;    
            POP     HL          ;  
            LD      (#5D11),HL  ;   
x030A       LD      A,(HL)      ;   
            LD      B,A         ; 
            AND     #80         ;   #80?
            LD      A,B         ; 
            JR      Z,x031A     ;    #80,    
            CP      #FE         ; RETURN?
            JR      Z,x031A     ; ,    
            PUSH    AF          ; 
            CALL    x3DC8       ;   
            POP     AF          ; 
x031A       LD      HL,x2FF3    ;  
            DEC     HL
            LD      C,0         ;  
x0320       INC     C
            LD      D,A         ; 
            LD      A,#15       ;  ?
            CP      C
            JP      C,x1D1A     ; ,    "*ERROR*"
            LD      A,D         ; 
            INC     HL          ;    
            CP      (HL)        ; ?
            JR      NZ,x0320    ; ,  
            CP      #FE         ;  RETURN?
            CALL    NZ,x294A    ; ,   
            LD      A,9         ;    9 
            LD      (#5D06),A
            XOR     A           ;  
            LD      (#5D0F),A
            LD      (#5CD6),A   ;  
            LD      (#5D10),A   ;     
            LD      HL,#5C3B    ;   
            RES     7,(HL)
            LD      B,0         ;     
            LD      HL,x3008    ;   
            DEC     C           ;   
            SLA     C           ;    2
            ADD     HL,BC       ;   
            LD      E,(HL)      ;  
            INC     HL
            LD      D,(HL)
            EX      DE,HL       ;   HL
            PUSH    HL          ; 
            LD      DE,x0359    ;   #359
            PUSH    DE
            JP      (HL)        ; 
x0359       LD      HL,#5C3B    ; 
            SET     7,(HL)
            POP     HL          ;  
            JP      (HL)        ; 

; #360.   TR-DOS.

x0360       DB      #16,1,#5
            DB      "* TR-DOS Ver 6.11Q*"
            DB      #D,#D
            DB      "2006 Alone,2013 Keeper,Velesoft"
            DB      #16,5,#B
            DB      "Kharkiv"
            DB      #16,7,5
            DB      "       "
            DB      0

; #3AC.   .

x03AC       CALL    x03FD       ;    8  0
            CALL    x3D80       ; 
            CALL    x3D80       ; 
            LD      BC,(#5E0A)  ;     
            CALL    x1DA9       ; 
            LD      HL,x29D2    ; FREE
            RST     #18

; #3C0.    .

x03C0       JP      x01D3

; #3C3.    .  HL   ,  A -  .

x03C3       PUSH    AF          ;  
            LD      A,(#5D0E)   ;   ?
            CP      #FE
            JR      NZ,x03CD    ; ,    
            POP     AF          ;    
            RET                 ;
x03CD       POP     AF          ;  
            LD      (#5D0F),A   ;  
            LD      A,(#5D15)   ;  ?
            OR      A
            CALL    Z,x2707     ; ,   

;!!!      0    .

            RET                 ;

x03D9       LD      HL,x2A28
            LD      A,1
            JP      x1C4A

; #3E1.   O.K.

x03E1       LD      HL,x2766    ;  O.K.
            XOR     A           ;  - 0
            JP      x1C4A       ;   

; #3E8.   0  0  .  #5CCC.    :
;#3EC -    0  .  #5CCC.
;#3F2 -    ,    E,  ?  D).

x03E8       XOR     A           ;  0
            LD      (#5CCC),A
x03EC       LD      DE,(#5CCC)  ;  
            LD      D,0         ; 0
x03F2       CALL    x294A       ; 
            LD      HL,#5D25    ;  
            LD      B,1         ;1 
            JP      x1E3D       ; 

; #3FD.     8  0.  #5D0C.

x03FD       CALL    x294A       ; ,   
            LD      DE,8        ; 0,  8
            JR      x03F2       ;   

; #405.   .     .

x0405       CALL    x03FD       ;    8  0
            LD      A,(#5E0C)   ;  TR-DOS?
            CP      #10
            JR      Z,x0415     ; ,    
x040F       LD      HL,x29E2    ;  DISC ERROR
            RST     #18         ; 
            JR      x03C0       ;

;, !!!   .     :
;    LD HL,#29E2
;    LD A,7
;    JP #1C4A
;         ,         DISC ERROR.

x0415       CALL    x3E11       ;  
            RES     0,(HL)      ;     
            RES     1,(HL)      ; 
            LD      A,(#5E08)
            BIT     0,A
            JR      NZ,x0425
            SET     0,(HL)
x0425       BIT     3,A
            RET     NZ
            SET     1,(HL)
            RET

;!!!          .

; #42B.     . :  #5D11.      Z,   ENTER  ,  .

x042B       LD      HL,(#5D11)  ;    
            INC     HL          ;    
            LD      A,(HL)      ;  
            CP      #D          ;   ENTER
            RET                 ;

; #433.   CAT.  #5D11  #5C3B.    :
;#479 (  ;  A -  ,   -  8  0).

x0433       CALL    x042B       ;    ENTER?
            LD      BC,2        ;    2
            LD      (#5CDB),BC
            JR      Z,x046A     ;    ENTER,   
            CP      "#"         ;   "#"?
            JR      NZ,x045D    ; ,      
            LD      (#5C5D),HL  ; CH_ADD    
            CALL    x1E0B       ;  
            CALL    x1D8C       ;  
            CP      #D          ; ENTER?
            JR      Z,x046A     ; ,   
            CP      ","         ; ?
            JP      NZ,x1D1A    ; ,   
            CALL    x1E2A       ;  
            CALL    x1DBD       ;     
            JR      x0460       ;    
x045D       CALL    x1DDF       ; CH_ADD       
x0460       CALL    x1D75       ;    ,  
            CALL    x1DB5       ;     
            EX      DE,HL
            CALL    x1C81       ; 
x046A       CALL    x1D75       ;   ,  
            LD      A,(#5CF6)   ;    #5CF9
            LD      (#5CF9),A
            CALL    x0405       ;  
            LD      A,(#5CDB)   ;  
x0479       CP      2           ;   2?
            PUSH    AF          ;  
            CALL    Z,x1D97     ;   2,   
            POP     AF          ;  
            CP      #10         ;  #10?
            JP      NC,x1D1A    ; ,  
            CALL    x1D84       ; 
            LD      A,#FF       ; #5CF8  #FF
            LD      (#5CF8),A
            LD      HL,x29F7    ; TITLE:
            RST     #18
            LD      HL,#5E1A    ;  
            RST     #18
            CALL    x3D80       ; 
            LD      A,(#5E09)   ;     
            LD      HL,#5E19
            SUB     (HL)
            PUSH    HL
            CALL    x1DA3       ; 
            LD      HL,x2A2B    ; FILES
            RST     #18
            POP     HL
            LD      C,(HL)      ;   
            CALL    x1DA4       ; 
            LD      HL,x2A1D    ; DEL.FILES
            RST     #18
            CALL    x03E8       ;    0  0
            LD      HL,#5D25    ;  
x04B6       CALL    x04F6       ;   
            CALL    x3D80       ; 
            LD      A,(#5CF6)   ;  
            ADD     A,"A"
            RST     #10
            LD      B,2         ;  2   
x04C4       CALL    x04F6       ;  ,   
            PUSH    BC          ;     
            LD      A,":"       ; 
            RST     #10
            PUSH    HL          ;      
            CALL    x2938       ;    
            LD      BC,#D       ; ,   
            POP     HL          ;   
            PUSH    HL
            ADD     HL,BC
            LD      C,(HL)      ;  
            PUSH    BC          ; 
            LD      A,C         ;   A
            LD      B,2         ;    
            CP      #A
            JR      C,x04DF
            DEC     B
x04DF       CP      #64
            JR      NC,x04E8
x04E3       LD      A," "       ; 
            RST     #10
            DJNZ    x04E3
x04E8       POP     BC          ;  
            CALL    x1DA9       ; 
            POP     HL          ;    
            POP     BC          ;     
            LD      DE,#10      ; 
            ADD     HL,DE
            DJNZ    x04C4       ;   1 ,   
            JR      x04B6       ; 

; #4F6.   #5CF9        .

x04F6       PUSH    HL          ; HL  BC
            PUSH    BC
            LD      A,(#5CF9)   ;     
            LD      HL,#5CF6    ;  ?
            CP      (HL)
            CALL    NZ,x3DCB
            POP     BC          ; HL  BC
            POP     HL
            JP      x2FC6       ;     

; #507.  #10  HL.

x0507       LD      DE,#10
            ADD     HL,DE
            RET

; #50C.          .  #5CCC    HL   .    ,   HL           .

x050C       PUSH    HL          ; HL  BC
            PUSH    BC
            LD      BC,#A1DB    ;  ?
            ADD     HL,BC
            JR      C,x0517     ; ,    
            POP     BC          ; HL  BC
            POP     HL
            RET                 ;
x0517       LD      HL,#5CCC    ; 
            INC     (HL)
            CALL    x03EC       ;   
            POP     BC          ; BC  HL
            POP     HL
            LD      HL,#5D25    ;  HL   
            RET                 ;

; #524.      .    ,     .

x0524       AND     #DF         ; 
            SBC     A,#41       ;  
            JP      C,x1D1A     ;     "A",  
            CP      4           ;   3?
            JP      NC,x1D1A    ; ,  
            RET                 ;

x0531       CALL    x1DB5
            LD      A,C
            CP      B
            JP      Z,x1D1A
            RET

; #53A.   NEW.  #5D11  #5C3B.     #569 (   ;      C).

x053A       JP      NEWER
L53D        CALL    x1D75       ;    ,  
            CALL    x102E       ;  
            CALL    x1CB0       ;   
            LD      A,(#5CF6)   ;  
            LD      (#5CF8),A   ; 
            JP      NZ,x03D9    ;   ,  
            PUSH    BC          ;  
            CALL    x165D       ;  
            CALL    x1CB0       ;   
            PUSH    AF          ;    
            LD      A,(#5CF8)   ;      
            LD      HL,#5CF6
            CP      (HL)
            JP      NZ,x1D1A    ; ,  
            CALL    x0405       ;  
            POP     AF          ;    
            JP      Z,x1C50     ;    ,  
            POP     BC          ;  
x0569       CALL    x166B       ;       
            CALL    x1E43       ; 
            JP      x03E1       ; O.K.

; #572.   #5D10.      Z,      .

x0572       LD      A,(#5D10)
            OR      A
            RET

; #577.    .  #5D11.   0,    NO FILE,  O.K.

x0577       LD      A,(#5D07)   ;   
            OR      A           ;  0?
            JP      Z,x03D9     ; ,  NO FILE
            JP      x03E1       ; O.K.

; #581.    .  #5CDD  #5CF6,    C   .   Y       Z,    .

x0581       PUSH    BC          ;  
            CALL    x1D97       ;     0.
            LD      A,(#5CF6)   ;  
            ADD     A,"A"       ;  
            CALL    x3D82       ; 
            LD      A,":"       ; 
            CALL    x3D82
            LD      HL,#5CDD    ;      
            CALL    x2938       ;    
            LD      HL,x2820    ; FILE EXISTS. OVERWRITE?
            CALL    x2707
            CALL    x1052       ; 
            CP      "Y"         ; "Y"?
            PUSH    AF          ;  
            CALL    x1D97       ; 
            POP     AF          ; AF   
            POP     BC
            RET     NZ          ;   N,  
            PUSH    BC          ;  
            CALL    x1D97       ; 
            POP     BC          ;  
            CALL    x0781       ; 
            XOR     A           ;  Z
            RET                 ;

; #5B4.        #.  #5CDD, #5CE5  #5CE6.        ,    Z,    .

x05B4       LD      A,(#5CE5)   ;  
            CP      "#"         ; "#"?
            JR      Z,x05BD     ; , 
            XOR     A           ;  Z
            RET                 ; 
x05BD       LD      A,#A        ;   #A 
            LD      (#5D06),A
            CALL    x1CB3       ; 
            LD      A,9         ;   9 
            LD      (#5D06),A
            RET                 ;

; #5CB.   COPY "*","*".     #5CDD,  -      #5CF8, #5D23  #5CCF.

x05CB       LD      A,(#5CDD)   ;    
            CP      "*"         ; "*"?
            JP      NZ,x03D9    ; ,  NO FILE
            CALL    x1DB5       ;    
            EX      DE,HL
            CALL    x1C81       ; -
            LD      A,(HL)      ;   
            CP      "*"         ; "*"?
            JP      NZ,x1D1A    ; ,  
            LD      A,(#5CF6)   ;  -
            LD      (#5CF9),A
            LD      A,(#5CF9)   ; -
            CALL    x3DCB
            CALL    x0405       ;  
            LD      A,#FF       ;   0
            LD      (#5D0D),A
x05F4       LD      A,(#5CF8)   ; -
            CALL    x3DCB
            CALL    x0405       ;  
            LD      A,(#5D0D)   ; 
            INC     A
            LD      (#5D0D),A
            LD      C,A
            CALL    x165D       ;  
            LD      A,(#5CDD)   ;    
            CP      0           ;  ?
            JP      Z,x03E1     ; ,  O.K.
            CP      1           ; ?
            JR      Z,x05F4     ; ,   
            LD      HL,#5CE6    ;   
            LD      DE,#5CED
            LD      BC,7
            LDIR
            LD      A,(#5CF9)   ; -
            CALL    x3DCB
            CALL    x1CB3       ; 
            JR      NZ,x0634    ;  ,   
            CALL    x05B4       ;    "#"
            JR      NZ,x0634    ;   ,   
            CALL    x0581       ; OVERWRITE?
            JR      NZ,x05F4    ;   N,   
x0634       CALL    x063C       ; 
            CALL    x1E43       ;    
            JR      x05F4       ;   

; #63C.     .     #5CDD     #5CED.

x063C       CALL    x03FD       ;    8  0
            LD      A,(#5E09)   ;    
            CP      #80         ;  #80 ?
            JP      Z,x2723     ; ,  DIRECTORY FULL
            LD      HL,#5CED    ;  
            LD      DE,#5CE6
            LD      BC,7
            LDIR
            LD      DE,(#5CEA)  ;    
            LD      D,0
            OR      A
            LD      HL,(#5E0A)  ;     
            SBC     HL,DE       ;  
            JP      C,x1C45     ;   ,  NO SPACE
            LD      (#5E0A),HL  ;    
            LD      HL,(#5E06)  ;     
            LD      (#5CEB),HL  ;    
            PUSH    HL          ; 
            CALL    x072F       ; 
            POP     HL          ;    
            LD      (#5CEB),HL  ; 
            LD      HL,(#5CF4)  ;      
            LD      (#5E06),HL  ; 
            LD      HL,#5E09    ; 1 
            INC     (HL)
            LD      C,(HL)      ;   
            DEC     C
            LD      B,0
            PUSH    BC          ; 
            LD      DE,9        ;  8  0
            LD      (#5CF4),DE
            CALL    x1E43       ; 
            POP     BC          ;  
            CALL    x166B       ;  
            RET                 ;

; #690.   COPY.  #5D11  #5C3B.

x0690       LD      HL,(#5D11)  ;     
            INC     HL
            LD      A,(HL)      ;  
            AND     #DF         ; 
            CP      "S"         ; "S"?
            JP      Z,x1360     ; ,   1    
            CP      "B"         ; "B"?
            JP      Z,x152C     ; ,       
            CALL    x1DCD       ;  
            CALL    x1D75       ;    ,  
            CALL    x166F       ;   
            CALL    x102E       ;  
            CALL    x1CB0       ;   
            LD      A,(#5CF6)   ;   - 
            LD      (#5CF8),A
            JP      NZ,x05CB    ;   ,   COPY "*","*"

;!!! COPY "*","*"   ,         "*"    ,       :
;LD (#5CF8),A
;PUSH AF
;CALL #5CB
;POP AF
;JP NZ,#3D9
;   #5CB  JP NZ,#3D9   RET NZ.

            CALL    x165D       ;  
            LD      HL,#5CE6    ;  
            LD      DE,#5CED
            LD      BC,7
            LDIR
            CALL    x1CB0       ;   
            PUSH    AF          ;  
            PUSH    BC          ;  
            LD      A,(#5CF6)   ;   - 
            LD      (#5CF9),A
            LD      A,(#5CF8)   ;  - 
            CALL    x3DCB
            CALL    x0405       ;  
            LD      A,(#5CF9)   ;  - 
            CALL    x3DCB
            CALL    x0405       ;  
            POP     BC          ;  
            POP     AF          ;     
            JR      NZ,x06F3    ;   ,   
            CALL    x05B4       ;    "#"
            JR      NZ,x06F3    ;   ,   
            CALL    x0581       ; OVERWRITE?
            JP      NZ,x03E1    ;   N,  O.K.
x06F3       CALL    x063C       ; 
            CALL    x1E43       ;    
            LD      A,(#5CE5)   ;  
            CP      "#"         ; "#"?
            JP      NZ,x03E1    ; ,  O.K.
            LD      A,#A        ;   #A 
            LD      (#5D06),A
            LD      HL,#5CE6    ; 
            INC     (HL)
            LD      A,(#5CF8)   ;  - 
            CALL    x3DCB
            CALL    x05B4       ; 
            JP      NZ,x03E1    ;  ,  O.K.
            CALL    x165D       ;  
            LD      HL,#5CE6    ;  
            LD      DE,#5CED
            LD      BC,7
            LDIR
            LD      A,(#5CF9)   ;  - 
            CALL    x3DCB
            CALL    x0405       ;  
            JR      x06F3       ;

; #72F.     . 
;#5CF1, #5D23, #5CF8, #5CF9, #5CF2, #5CCF  #5CEB.

x072F       LD      A,(#5CF1)   ;  
            OR      A           ; ?
            RET     Z           ; ,  
            PUSH    HL          ; HL
            LD      HL,#5D23    ;      
            SUB     (HL)        ; ?
            POP     HL          ; HL
            JR      NC,x0775    ;    ,    
            LD      A,(#5CF1)   ;  
            LD      B,A
            XOR     A           ; 
            LD      (#5CF1),A
x0744       PUSH    BC          ;   p
            LD      A,(#5CF8)   ; -
            CALL    x3DCB
            POP     BC          ;   
            PUSH    BC          ;   
            LD      HL,(#5CCF)  ;    
            PUSH    HL          ; 
            LD      DE,(#5CF2)  ;     -
            CALL    x1E3D       ; 
            LD      HL,(#5CF4)  ;    
            LD      (#5CF2),HL  ; -
            LD      A,(#5CF9)   ; -
            CALL    x3DCB
            POP     HL          ;    
            POP     BC          ;   
            LD      DE,(#5CEB)  ;     -
            CALL    x1E4D       ; 
            LD      HL,(#5CF4)  ;    
            LD      (#5CEB),HL  ; -
            JR      x072F       ;
x0775       LD      (#5CF1),A   ;   
            PUSH    HL          ; HL
            LD      HL,#5D23    ;  , 
            LD      B,(HL)      ;   
            POP     HL          ; HL
            XOR     A           ; 
            JR      x0744       ; 

; #781.  . :  #5CDD, #5CE5,    .   #5D08  #5D07.

x0781       XOR     A           ;   
            LD      (#5D07),A
            JR      x07A0       ; 

; #787.   ERASE.  #5D11  #5C3B.

x0787       CALL    x1DDF       ;     
            CALL    x1D75       ;    ,  
            CALL    x102E       ;  
            XOR     A           ;   
            LD      (#5D07),A
            CALL    x292F       ;     
            CALL    x07A0       ; 
            JP      NZ,x0577    ;      ,  ,   
            JP      x03E1       ; O.K.

; #7A0.  . :  #5CDD, #5CE5,  #5D07    .   #5D08     #5D07.

x07A0       LD      A,(#5CDD)   ;    
            LD      (#5D08),A
            RET     NZ          ;    ,  
            LD      HL,#5D07    ;   
            INC     (HL)
            PUSH    BC          ;  
            CALL    x03FD       ;    8  0
            LD      A,(#5E09)   ;    
            POP     BC          ;  
            INC     C           ;  ?
            CP      C
            JR      NZ,x07BC    ; ,    
            DEC     A           ;    1  
            LD      (#5E09),A
            XOR     A           ;    
x07BC       PUSH    AF          ;   
            JR      Z,x07C3     ;     ,
            LD      HL,#5E19    ;   1   
            INC     (HL)
x07C3       PUSH    BC          ;   
            CALL    x1E43       ;  8  0
            POP     BC          ;   
            DEC     C
            CALL    x165D       ;  
            POP     AF          ;   
            JP      Z,x07D2     ;    ,      CHR$ 0
            LD      A,1         ;   CHR$ 1
x07D2       LD      (#5CDD),A   ;   
            PUSH    AF          ;  
            CALL    x1E40       ;  
            LD      A,(#5D08)   ;    
            LD      (#5CDD),A
            POP     AF          ;  
            JR      Z,x07E7     ;     ,       
            CALL    x1CB3       ;     
            JR      x07A0       ; ,   
x07E7       CALL    x03FD       ;  8  0
            LD      HL,(#5CEB)  ;    
            LD      (#5E06),HL
            LD      DE,(#5CEA)  ;    
            LD      HL,(#5E0A)
            LD      D,0
            ADD     HL,DE
            LD      (#5E0A),HL
            JP      x1E43       ;  8  0  

; #800.      .       ,    -  .

x0800       AND     #FC         ;   
            JP      x3D9A       ;    INTRQ

DOSSYM      PUSH    HL          ;jp  #3D82
            PUSH    BC          ;,    #3D82
            PUSH    DE
            PUSH    AF
            CALL    x20F1
            POP     AF
            CALL    x3D94
            CALL    x20F1
            POP     DE
            POP     BC
            POP     HL
            RET

ASKREPFORM  LD      A,(#5CF6)   ;jp  #1FB6
            CP      RMD_DRIVE;#03         ; #326B
            JR      Z,LLc848
            LD      A,#0D
            RST     #10
            LD      HL,TPressR  ;#335E
            RST     #18
            CALL    x1052       ;   
            CP      #52
            JR      Z,LLc84b
LLc848      JP      x01D3
LLc84b      RST     #20
            DW      #0D6E       ;CLS  -
LLc84e      RST     #20
            DW      #028E       ;KEY_SCAN
            JR      NZ,LLc84e
            RST     #20
            DW      #31E        ;K_TEST
            JR      C,LLc84e
            JP      wFORMAT     ;...

            DISPLAY "Free space at ",$,": ",/D,#900-$," byte(s)"
            DS      #900-$,#FF
x900        DS      257,#FF     ;  

MAGSTOPDISK LD      A,#3C       ;call  #2A6F
            OUT     (#FF),A     ; out (#ff),#3c
            LD      A,#D0       ; JP #2FC1
            OUT     (#1F),A
            RET

MAGregR     LD      (#5C01),A   ;jp  #2EBF ; 5C01?   ?
            POP     AF
            JP      x2EC2

MAGsetR     LD      A,(#5C01)   ;jp  #2F03
            LD      R,A
            POP     AF
            JP      #5C00

MAGICER     PUSH    AF          ;jp  #2A56 ; push af,bc,de
            LD      A,R
            BIT     7,A
            JR      Z,LL8a27
            SUB     #1F
            SET     7,A
            JR      LL8a2b
LL8a27      SUB     #1F
            RES     7,A
LL8a2b      PUSH    AF
LL8a45      LD      A,#F7
            IN      A,(#FE)
            RRCA
            JR      NC,MAG1
            RRCA
            JR      NC,MAG2
            RRCA
            JR      NC,MAG3
            RRCA
            JR      C,LL8a45
            POP     AF          ;MAGIC+"4"=EXIT
            BIT     7,A         ; RLCA:ADD A,#17*2:RRCA
            JR      Z,LL8a60
            ADD     A,#17
            SET     7,A
            JR      LL8a64
LL8a60      ADD     A,#17
            RES     7,A
LL8a64      LD      R,A
            POP     AF
            RETN

MAG1        POP     AF          ;MAGIC+"1"=
            LD      R,A
            POP     AF
            JR      LL8a78

MAG2        POP     AF          ;MAGIC+"2"=  
            POP     AF
            LD      (#57FE),SP
            LD      SP,#5800
LL8a78      PUSH    AF
            PUSH    BC
            PUSH    DE
            JP      x2A59

MAG3        POP     AF          ;MAGIC+"3"=STS#57
            LD      R,A
            PUSH    HL
            LD      HL,0
            ADD     HL,SP
            INC     HL
            INC     HL
            LD      A,H
            POP     HL
            CP      #C0
            JR      NC,LL8ac4
            LD      A,R
            BIT     7,A         ; RLCA:SUB 9*2:RRCA
            JR      Z,LL8a9a
            SUB     9
            SET     7,A
            JR      LL8a9e
LL8a9a      SUB     9
            RES     7,A
LL8a9e      LD      R,A
            PUSH    BC
            LD      BC,#FFFD
            LD      A,#07
            OUT     (C),A
            LD      B,#BF
            LD      A,#FF
            OUT     (C),A       ; AY
            LD      A,#57
            LD      BC,#7FFD
            OUT     (C),A
            POP     BC
            POP     AF
            EX      (SP),HL
            LD      (#FEE4),HL
            LD      (#FEFE),HL
            EX      (SP),HL
LL8abf      INC     SP
            INC     SP
            JP      #DB00
LL8ac4      LD      A,R
            BIT     7,A         ; RLCA:SUB #15*2:RRCA
            JR      Z,LL8ad0
            SUB     #15
            SET     7,A
            JR      LL8ad4
LL8ad0      SUB     #15
            RES     7,A
LL8ad4      LD      R,A
            POP     AF
            LD      (#5800),SP
            EX      (SP),HL
            LD      (#5802),HL
            EX      (SP),HL
            LD      SP,#5808
            PUSH    AF
            PUSH    BC
            LD      BC,#FFFD
            LD      A,#07
            OUT     (C),A
            LD      B,#BF
            LD      A,#FF
            OUT     (C),A       ; AY
            LD      A,#57
            LD      BC,#7FFD
            OUT     (C),A
            POP     BC
            POP     AF
            LD      SP,(#5800)
            LD      (#C000),HL
            LD      HL,(#5802)
            LD      (#FEE4),HL
            LD      (#FEFE),HL
            LD      HL,(#C000)
            JR      LL8abf

            IFDEF   BOOT_ON_CMD_8

bootkus1
                DISP    #F500
                DI                  ;  #344D  #3AE7
                PUSH    AF
                PUSH    HL
                PUSH    DE
                PUSH    BC
                EXX
                PUSH    HL
                LD      HL,(#5C3D)
                LD      (#F632),HL
                LD      A,(#5D19)
                LD      (#5CF6),A
                ADD     A,#3C
                LD      (#5D16),A
                LD      HL,#3C00
                LD      DE,#8000
                PUSH    DE
                LD      (#5C36),DE
                LD      BC,#0400
                LDIR
                LD      (IY+#47),#00
                POP     HL
                LD      BC,#0080
LL0e30          PUSH    BC
                INC     HL
                INC     HL
                INC     HL
                LD      B,#03
LL0e36          LD      D,(HL)
                LD      A,D
                RLA
                OR      D
                LD      (HL),A
                INC     HL
                DJNZ    LL0e36
                POP     BC
                DEC     BC
                INC     HL
                INC     HL
                LD      A,B
                OR      C
                JR      NZ,LL0e30
                XOR     A
                OUT     (#FE),A
                LD      A,#44
                LD      (#5C48),A
                DEC     A
                DEC     A
                LD      (#5C8D),A
                CALL    #0D6B
LL0e56          DI
                XOR     A
                LD      (#F86E),A
                LD      HL,#FA09
                PUSH    HL
                LD      (#5C3D),SP
                LD      (IY+#00),#FF
                LD      A,(#5D19)
                LD      C,#01
                CALL    #3D13
                LD      HL,#9000
                LD      DE,#0000
                LD      BC,#0805
                CALL    #3D13
                LD      A,(IY+#00)
                CP      #FF
                JR      NZ,LL0e56
                LD      HL,#F556
                LD      (#F55C),HL
                EXX
                LD      DE,#A000
                EXX
                LD      HL,#9000
                LD      DE,#0008
                LD      A,(HL)
                OR      A
                JP      Z,#F887
LL0e98          LD      DE,#0008
                ADD     HL,DE
                LD      A,(HL)
                CP      #42
                CALL    Z,#F836
                ADD     HL,DE
                LD      A,(HL)
                OR      A
                JR      NZ,LL0e98
                LD      A,(#F86E)
                OR      A
                JP      Z,#F887
                LD      B,#3F
                SBC     A,B
                JP      NC,#F8A6
                LD      A,(#F86E)
                DEC     A
                LD      (#F86F),A
                CALL    #F9BB
                LD      (#F653),A
                CALL    #0D6B
                DI
                CALL    #F870
                LD      A,#02
                CALL    #F8CB
                LD      A,#02
                CALL    #1601
                LD      (IY+#47),#00
                LD      DE,#A000
                LD      HL,#0008
LL0edc          LD      A,#20
                RST     #10
                LD      A,#20
                RST     #10
                LD      BC,#0008
                PUSH    DE
                CALL    #203C
                POP     DE
                EXD
                ADC     HL,DE
                EXD
                LD      A,(#F86E)
                DEC     A
                LD      (#F86E),A
                JR      Z,LL0f35
                LD      A,#20
                RST     #10
                LD      A,#20
                RST     #10
                LD      BC,#0008
                PUSH    DE
                CALL    #203C
                POP     DE
                EXD
                ADC     HL,DE
                EXD
                LD      A,(#F86E)
                DEC     A
                LD      (#F86E),A
                JR      Z,LL0f35
                LD      A,#20
                RST     #10
                LD      A,#20
                RST     #10
                LD      BC,#0008
                PUSH    DE
                CALL    #203C
                POP     DE
                EXD
                ADC     HL,DE
                EXD
                LD      A,(#F86E)
                DEC     A
                LD      (#F86E),A
                JR      Z,LL0f35
                LD      A,#06
                RST     #10
                JR      LL0edc
                NOP
                NOP
                NOP
LL0f35          LD      HL,#5802
                CALL    #F816
                LD      DE,#000A
                LD      IX,#F634
                LD      (IX+#00),#00
LL0f46          EI
                RES     5,(IY+#01)
                HALT
                PUSH    HL
                PUSH    IX
                CALL    #F9BB
                CP      #40
                JP      NZ,#F792
                CALL    #F989
                POP     IX
                POP     HL
                BIT     5,(IY+#01)
                JR      Z,LL0f46
                LD      A,(#5C08)
                CP      8
                JP      Z,#F6ED
                CP      "o"
                JR      Z,LL0fed
                CP      "6"
                JR      Z,LL0fed
                CP      9
                JP      Z,#F70C
                CP      "p"
                JP      Z,#F70C
                CP      "7"
                JP      Z,#F70C
                CP      11
                JP      Z,#F72E
                CP      "q"
                JP      Z,#F72E
                CP      "9"
                JP      Z,#F72E
                CP      10
                JP      Z,#F764
                CP      "a"
                JP      Z,#F764
                CP      "8"
                JP      Z,#F764
                CP      "d"
                JP      Z,#FA1B
                CP      "1"
                JR      Z,LL0fd0
                CP      "2"
                JR      Z,LL0fd0
                CP      "3"
                JR      Z,LL0fd0
                CP      "4"
                JR      Z,LL0fd0
                PUSH    AF
                LD      A,#FE
                IN      A,(#FE)
                RRA
                JR      NC,LL0f46
                POP     AF
                CP      13
                JP      Z,#F79D
                CP      "0"
                JP      Z,#F79D
                CP      32
                JP      Z,#F79D
                JP      #F646
LL0fd0          PUSH    AF
                CALL    #0D6B
                LD      A,#03
                CALL    #F8CB
                POP     AF
                SUB     #31
                LD      C,#01
                LD      (#5CF8),A
                LD      (#5CF9),A
                LD      (#5D19),A
                CALL    #3D13
                JP      #F556
LL0fed          CALL    #F870
                CALL    #F826
                DEC    (IX)
bootst2
                ENT
bootln1=$-bootkus1
            ENDIF


;            DISPLAY "Free space at ",$,": ",/D,#1018-$," byte(s)"
;            DS      #1018-$,#FF

            DISPLAY "Free space at ",$,": ",/D,#1000-$," byte(s)"
            DS      #1000-$,#FF

TfndRD      DB      #16,#0A,5
            DB      "Found RAMDISK memory",0


; #1018.   "*".  #5D11  #5C3B.

x1018       CALL    x1DDF       ; CH_ADD       
            CALL    x1D75       ;    ,  
            CALL    x0531       ;     
            LD      A,(DE)      ;   
            CALL    x0524       ;  
            LD      (#5D19),A   ;   
            CALL    x3DCB       ; 
            JP      x03E1       ; O.K.

; #102E.   .  #5C5D  #5CD6.

x102E       LD      B,"C"       ; C
            LD      A,(#5CD6)   ; ?
            OR      A
            JR      NZ,x104D    ; ,    
            CALL    x1D8C       ;  
            CP      #AF         ; CODE?
            LD      B,"C"       ; C
            JR      Z,x104D     ; ,    
            CP      #E4         ; DATA?
            LD      B,"D"       ; D
            JR      Z,x104D     ; ,    
            CP      "#"         ; #?
            LD      B,"#"       ; #
            JR      Z,x104D     ; ,    
            LD      B,"B"       ; B
x104D       LD      HL,#5CE5    ;    
            LD      (HL),B      ; 
            RET                 ;

; #1052.    .

x1052       DI                  ; 
            PUSH    HL          ; 
            PUSH    BC
            PUSH    DE
x1056       RST     #20         ;   
            DW      #028E
            LD      C,0         ;  - C  L
            JR      NZ,x1056    ;    ,  
            RST     #20         ;   
            DW      #031E
            JR      NC,x1056    ;   ,  
            DEC     D           ;  - C  L
            LD      E,A         ;     E
            RST     #20         ;  CAPS SHIFT  SYMBOL SHIFT
            DW      #0333
            POP     DE          ; 
            POP     BC
            POP     HL
            AND     #DF         ;  
            EI                  ; 
            RET                 ;

; #106E.     .

x106E       LD      HL,#58E5    ;  

;            LD      B,#A        ; 
            LD      B,#E        ;(VELESOFT - black attributes size)

x1073       LD      (HL),7
            INC     HL
            DJNZ    x1073
            LD      (HL),2
            INC     HL
            LD      (HL),#16
            INC     HL
            LD      (HL),#34
            INC     HL
            LD      (HL),#25
            INC     HL
            LD      (HL),#28
            INC     HL
            LD      (HL),7

;            LD      HL,#40EE    ;   
            LD      HL,#40F2    ;(VELESOFT - new position for rainbow)

            LD      B,8         ;8    
            XOR     A           ; 
x108F       PUSH    BC          ;  
            SCF                 ; 
            RLA
            PUSH    HL          ;   
            PUSH    AF          ;   
            LD      B,5         ;  5 
x1096       INC     HL          ; 
            LD      (HL),A
            DJNZ    x1096
            POP     AF          ;    ,
            POP     HL          ; 
            POP     BC          ;  
            LD      DE,#100     ;   
            ADD     HL,DE
            DJNZ    x108F       ;  
            RET                 ;

x10A4       RET

; #10A5.   LIST.

x10A5       DB      " Del."
x10AA       DB      " File(s)"
            DB      0
x10B3       DB      "Title:"
            DB      #A0
x10BA       DB      #17,#11
            DB      " Disk Drive: "
            DB      0
x10CA       DB      #17,#10," ",0
x10CE       DB      #17,#10," 40 Track S. Side"
            DB      0
x10E2       DB      #17,#10," 80 Track S. Side"
            DB      0
x10F6       DB      #17,#10," 40 Track D. Side"
            DB      0
x110A       DB      #17,#10," 80 Track D. Side"
            DB      0
x111E       DB      #17,#10
            DB      " Free Sector "
            DB      0
x112E       DB      #D,#D
            DB      "  File Name    Start Length Line"
            DB      0

; #1151.  #222    .  #5CCF.

x1151       LD      HL,(#5C61)  ;   
            LD      (#5CCF),HL  ;  
            LD      BC,#222     ; #222 
            JP      x1E23       ;   

; #115D.    HL  .

x115D       XOR     A           ;  0  
            LD      DE,#2710
x1161       SBC     HL,DE       ;   10000
            JR      C,x1168     ;    10000,   
            INC     A           ;  
            JR      x1161       ;
x1168       ADD     A,"0"       ;  
            CALL    x11A8
            ADD     HL,DE       ;  
            XOR     A           ;  0 
x116F       LD      DE,#3E8
x1172       SBC     HL,DE       ;   1000
            JR      C,x1179     ;    1000,   
            INC     A           ; 
            JR      x1172       ;
x1179       ADD     A,"0"       ; 
            CALL    x11A8
            ADD     HL,DE       ;  
            XOR     A           ;  0 
            LD      DE,#64
x1183       SBC     HL,DE       ;   100
            JR      C,x118A     ;    100,   
            INC     A           ; 
            JR      x1183       ;
x118A       ADD     A,"0"       ; 
            CALL    x11A8
            ADD     HL,DE       ;  
            XOR     A           ;  0 
            LD      DE,#A
x1194       SBC     HL,DE       ;   10
            JR      C,x119B     ;    10,   
            INC     A           ; 
            JR      x1194       ;
x119B       ADD     A,"0"       ; 
            CALL    x11A8
            ADD     HL,DE       ;  
            LD      A,L         ; 
            ADD     A,"0"
            CALL    x11A8
            RET                 ;

; #11A8.  ,   #3D82.

x11A8       PUSH    HL          ; HL  DE
            PUSH    DE
            CALL    x3D82       ; 
            POP     DE          ; DE  HL
            POP     HL
            RET                 ;

; #11B0.        .  #5CF9  #5CCC,   HL    .    ,       ,   HL  #5D25.

x11B0       PUSH    HL          ; HL  BC
            PUSH    BC
            LD      A,(#5CF9)   ;    #5CF9
            LD      HL,#5CF6    ;   
            CP      (HL)        ;  ?
            CALL    NZ,x3DCB    ; ,    
            POP     BC          ; HL  BC
            POP     HL
            CALL    x050C       ;   
            LD      A,(HL)      ;    
            OR      A           ; ?
            JP      Z,x01D3     ; ,  
            CP      1           ; ?
            CALL    Z,x0507     ; ,   
            RET     NZ          ; 
            JR      x11B0       ;   ,  

; #11CE.   LIST.  #5D11  #5C3B.

x11CE       CALL    x042B       ;   
            LD      BC,2        ;     2
            LD      (#5CDB),BC
            JR      Z,x1205     ;    ENTER,   
            CP      "#"         ;    "#"?
            JR      NZ,x11F8    ; ,   
            LD      (#5C5D),HL  ; CH_ADD
            CALL    x1E0B       ;  
            CALL    x1D8C       ;  
            CP      #D          ; ENTER?
            JR      Z,x1205     ; ,   
            CP      ","         ; ","?
            JP      NZ,x1D1A    ; ,  
            CALL    x1E2A       ; 
            CALL    x1DBD       ;     
            JR      x11FB       ; 
x11F8       CALL    x1DDF       ; CH_ADD       
x11FB       CALL    x1D75       ;    ,  
            CALL    x1DB5       ;     
            EX      DE,HL       ;    HL
            CALL    x1C81       ; 
x1205       CALL    x1D75       ;    ,  
            LD      A,(#5CF6)   ;    #5CF9
            LD      (#5CF9),A
            CALL    x0405       ;  
            LD      A,(#5CDB)   ;  
            CP      2           ; 2?
            PUSH    AF          ; 
            CALL    Z,x1D97     ; ,   
            POP     AF          ;  
            CP      #11         ;  #10?
            JP      NC,x1D1A    ; ,  
            CALL    x1D84       ; 
            LD      A,#FF       ;  ,   
            LD      (#5CF8),A
            CALL    x1151       ;    
            LD      HL,#5E06    ;    
            LD      DE,(#5CCF)  ;  WORKSP
            LD      BC,#20      ;  
            LDIR                ;  
            CALL    x03E8       ;    0  0
            LD      HL,#5D25    ; 
            PUSH    HL          ; 
x123E       LD      HL,x10B3    ;  TITLE:
            PUSH    BC          ; BC
            RST     #18         ; TITLE:
            LD      HL,(#5CCF)  ;  WORKSP
            LD      BC,#14      ;#14- 
            ADD     HL,BC
            RST     #18         ;  
            LD      HL,x10BA    ; DISC DRIVE:
            RST     #18
            LD      A,(#5CF6)   ;  
            ADD     A,"A"       ;  
            CALL    x3D82       ; 
            CALL    x3D80       ; 
            LD      HL,(#5CCF)  ;3-   
            LD      BC,3
            ADD     HL,BC
            LD      A,(HL)      ;    
            LD      HL,(#5CCF)        ;#13- 
            LD      BC,#13
            ADD     HL,BC
            SUB     (HL)        ;   
            PUSH    HL          ;  #13-   
            CALL    x1DA3       ;   
            LD      HL,x10AA    ; FILE(S)
            RST     #18
            LD      HL,(#5CCF)  ;2-   
            LD      BC,2
            ADD     HL,BC
            LD      A,(HL)      ;  
            LD      HL,x10CE    ;  40 TRACKS, S.SIDE
            CP      #19         ; #19?
            JR      Z,x1292     ; ,   
            LD      HL,x10E2    ;  80 TRACKS, S.SIDE
            CP      #18         ; #18?
            JR      Z,x1292     ; ,   
            LD      HL,x10F6    ;  40 TRACKS, D.SIDE
            CP      #17         ; #17?
            JR      Z,x1292     ; ,   
            LD      HL,x110A    ;p  80 TRACKS, D.SIDE
x1292       RST     #18         ; 
            POP     HL          ;  #13-   
            LD      C,(HL)      ;   
            CALL    x1DA4       ; 
            LD      HL,x10A5    ; DEL.FILES
            RST     #18
            LD      HL,x111E    ; FREE SECTORS:
            RST     #18
            LD      HL,(#5CCF)  ;4- 
            LD      BC,4
            ADD     HL,BC
            LD      C,(HL)      ;   
            INC     HL
            LD      B,(HL)
            CALL    x1DA9       ; 
            LD      HL,x112E    ; FILE NAME, START, LENGTH, LINE
            RST     #18
            POP     BC          ; BC     p
            POP     HL
            LD      B,#10       ;   #10 
x12B5       CALL    x11B0       ;   
            CALL    x3D80       ; 
            PUSH    BC          ;   
            PUSH    HL          ;    p
            CALL    x2938       ;    
            LD      BC,#D       ;#D-   
            POP     HL          ;    
            PUSH    HL
            ADD     HL,BC
            LD      C,(HL)      ;    
            PUSH    BC          ; 
            LD      A,C         ;   C
            LD      B,2         ; 2   
            CP      #A          ;   10 ?
            JR      C,x12D0     ; ,   
            DEC     B           ;  
x12D0       CP      #64         ;   100 p?
            JR      NC,x12D9    ; ,    
x12D4       LD      A," "       ; 
            RST     #10
            DJNZ    x12D4
x12D9       POP     BC          ;    
            CALL    x1DA9       ; 
            LD      HL,x10CA    ;#10 
            RST     #18
            POP     HL          ;     
            PUSH    HL          ;   
            LD      BC,9        ;9-  
            ADD     HL,BC
            LD      E,(HL)      ;   
            INC     HL
            LD      D,(HL)
            PUSH    HL          ;     
            EX      DE,HL       ;     HL
            CALL    x115D       ; 
            LD      A," "       ;
            CALL    x3D82
            POP     HL          ;     
            INC     HL          ; 
            LD      E,(HL)      ;  
            INC     HL
            LD      D,(HL)
            EX      DE,HL       ;   HL
            CALL    x115D       ; 
            POP     HL          ;   
            PUSH    HL          ;   
            LD      BC,8        ;8- 
            ADD     HL,BC
            LD      A,(HL)      ;  
            CP      "B"         ; "B"?
            CALL    Z,x131B     ; ,    
            POP     HL          ;   
            POP     BC          ;  
            LD      DE,#10      ;   
            ADD     HL,DE
            DJNZ    x12B5       ;  
            PUSH    HL          ;   
            CALL    x3D80       ;2   
            CALL    x3D80
            JP      x123E       ;   

; #131B.    p  .  HL      8   #5CCF.

x131B       LD      BC,5        ;     
            ADD     HL,BC
            LD      B,(HL)      ;  
            INC     HL          ;   
            LD      E,(HL)      ;    
            INC     HL
            LD      D,(HL)
            DEC     B           ;  2 p
            JR      Z,x1335
            DEC     B
            JR      Z,x1335     ;     2- ,   
            LD      A,#10       ;  #10 
x132C       INC     E           ; 
            CP      E           ; ?
            JR      NZ,x1333    ; , 
            LD      E,0         ;  0
            INC     D           ;   
x1333       DJNZ    x132C       ;  
x1335       LD      HL,(#5CCF)  ;   
            LD      BC,#21      ;#21   
            ADD     HL,BC
            LD      B,2         ; 2 
            PUSH    HL          ;   
            CALL    x1E3D       ; 
            LD      A,#80       ;   
            POP     HL          ;    
            LD      BC,#200     ;  - #200 
            CPIR                ;  
            LD      A,(HL)      ;  
            CP      #AA         ; #AA?
            RET     NZ          ; ,  
            INC     HL          ;   
            LD      C,(HL)
            INC     HL
            LD      B,(HL)
            LD      A,B         ; 0?
            OR      C
            RET     Z           ; ,  
            PUSH    BC          ;   
            LD      A," "       ; 
            CALL    x3D82
            POP     BC          ;   
            CALL    x1DA9       ; 
            RET                 ;

; #1360.   COPY S.  #5D11  #5C3B.

x1360       CALL    x1DC5       ; CH_ADD
            CALL    x1E2A       ; 
            CALL    x1DBD       ;     
            CALL    x1D75       ;    ,  
            CALL    x166F       ;   
            LD      HL,x27AA    ; INSERT SOURCE DISC
            CALL    x2707
x1375       CALL    x1052       ;   
            CP      "Y"         ; "Y"?
            JR      NZ,x1375    ; ,  
            CALL    x1D9F       ;  
            CALL    x102E       ;  
            CALL    x1CB0       ;  
            JP      NZ,x03D9    ;   ,  
            CALL    x13B7       ; 
            LD      A,(#5CE5)   ;  #?
            CP      "#"
            JP      NZ,x03E1    ; ,  O.K.
x1393       LD      A,#A        ;   #A 
            LD      (#5D06),A
            LD      HL,#5CE6    ; 
            INC     (HL)
            CALL    x1D97       ; 
            LD      HL,x27AA    ; INSERT SOURCE DISC
            CALL    x2707
x13A5       CALL    x1052       ; 
            CP      "Y"         ; "Y"?
            JR      NZ,x13A5    ; ,  
            CALL    x1CB3       ; 
            JP      NZ,x03E1    ;  ,  O.K.
            CALL    x13B7       ; 
            JR      x1393       ;

; #13B7.     .      C.

x13B7       CALL    x165D       ;  
            LD      HL,#5CE6    ;  
            LD      DE,#5CED
            LD      BC,7
            LDIR
            LD      A,(#5CF1)   ;    
            LD      (#5D10),A
            CALL    x0405       ;  
            CALL    x3E11       ;  
            LD      (#5CD9),A
            LD      A,#FF       ; 

            LD      (#5D21),A   ;!!!    .     3   .

            CALL    x1451       ; 
            LD      HL,(#5D1F)  ;     - 
            LD      (#5CEB),HL  ; 
            LD      HL,(#5CF4)  ;      
            LD      (#5E06),HL  ; 
            LD      HL,#5E09    ; 1 
            INC     (HL)
            LD      C,(HL)      ;  
            DEC     C
            LD      B,0         ;    
            PUSH    BC          ; 
            LD      DE,9        ;  8  0
            LD      (#5CF4),DE
            CALL    x1E43       ; 
            POP     BC          ;  
            CALL    x166B       ;    
            CALL    x1E43       ;   
            RET                 ;

; #1403.      -   COPY S.     #5CDD     #5CED   #5D10.     -.   #5CEA, #5CEB  #5D1F.

x1403       XOR     A           ;  
            LD      (#5D21),A
            CALL    x0405       ;  
            CALL    x3E11       ;  
            LD      (#5CDA),A   ; 
            CALL    x1CB3       ; 
            JP      Z,x1C50     ; ,  FILE EXISTS
            CALL    x03FD       ;    8  0
            LD      A,(#5E09)   ;    
            CP      #80         ; 128?
            JP      Z,x2723     ; ,  DIRECTORY FULL
            LD      HL,#5CED    ;  
            LD      DE,#5CE6
            LD      BC,7
            LDIR
            CALL    x03FD       ;    8  0
            LD      A,(#5D10)   ;    
            LD      (#5CEA),A
            LD      DE,(#5CEA)  ;    
            LD      D,0
            OR      A           ;  C
            LD      HL,(#5E0A)  ;    
            SBC     HL,DE
            JP      C,x1C45     ;   ,  NO SPACE
            LD      (#5E0A),HL  ;      
            LD      HL,(#5E06)  ;     
            LD      (#5CEB),HL  ;    -
            LD      (#5D1F),HL  ; 
            RET                 ;p

; #1451.     .     #5CDD     #5CED   #5CF1, #5D21, #5D23  #5CCF.   #5CBB, #5CD9, #5CDA  #5C92.

x1451       LD      A,(#5CF1)   ; ?
            OR      A
            RET     Z           ; ,  
            LD      A,(#5D21)   ; ?
            OR      A
            JR      NZ,x146F    ; ,   -    
            CALL    x1D97       ; 
            LD      HL,x27AA    ; INSERT SOURCE DISC
            CALL    x2707
x1465       CALL    x1052       ;  "Y"
            CP      "Y"
            JR      NZ,x1465
            CALL    x1D9F       ;  
x146F       LD      A,(#5CF1)   ; ?
            OR      A
            RET     Z           ; ,  
            PUSH    HL          ; HL
            LD      HL,#5D23    ;  
            SUB     (HL)
            POP     HL          ; HL
            JR      NC,x14CB    ;   ,    
            LD      A,(#5CF1)   ; 
            LD      B,A
            XOR     A           ; 
            LD      (#5CF1),A
x1484       PUSH    BC          ;   
            LD      (#5CCE),A   ; #5CCE
            LD      HL,(#5CCF)  ;   
            PUSH    HL          ; 
            LD      DE,(#5CF2)  ;    
            CALL    x14D8       ;   -
            CALL    x1E3D       ; 
            LD      HL,(#5CF4)  ;     
            LD      (#5CF2),HL
            CALL    x1D97       ; 
            LD      HL,x2785    ; INSERT DESTINATION DISC
            CALL    x2707
x14A5       CALL    x1052       ;  "Y"
            CP      "Y"
            JR      NZ,x14A5
            CALL    x1D9F       ;  
            LD      A,(#5D21)   ; ?
            OR      A
            CALL    NZ,x1403    ; ,      
            POP     HL          ;   
            POP     BC          ;   
            LD      DE,(#5CEB)  ;    
            CALL    x14E4       ;   -
            CALL    x1E4D       ; 
            LD      HL,(#5CF4)  ;     
            LD      (#5CEB),HL
            JP      x1451       ;
x14CB       LD      (#5CF1),A   ;    
            PUSH    HL          ; HL
            LD      HL,#5D23    ;   
            LD      B,(HL)
            POP     HL          ; HL
            XOR     A           ; 
            JP      x1484       ;

; #14D8.   #5CD9    .  #5CD9.

x14D8       PUSH    HL          ; DE  HL
            PUSH    DE
            CALL    x3E11       ;     
            LD      A,(#5CD9)   ;    #5CD9
            LD      (HL),A      ;  
            POP     DE          ; DE  HL
            POP     HL
            RET                 ;

; #14E4.   #5CDA    .  #5CDA.

x14E4       PUSH    HL          ; DE  HL
            PUSH    DE
            CALL    x3E11       ;     
            LD      A,(#5CDA)   ;    #5CD9
            LD      (HL),A      ;  
            POP     DE          ; DE  HL
            POP     HL
            RET                 ;

; #14F0.     -   COPY B.  #5CDF     -.  #5CDA, #5CE7, #5CDD   #5D21.

x14F0       XOR     A           ; #5D21
            LD      (#5D21),A
            CALL    x0405       ;  
            CALL    x3E11       ;  
            LD      (#5CDA),A   ; 
            LD      A,(#5E08)   ;  
            LD      (#5CE7),A
            LD      HL,#280     ;   
            CP      #19         ;-
            JR      Z,x151F
            LD      HL,#500
            CP      #18
            JR      Z,x151F
            CP      #17
            JR      Z,x151F
            LD      HL,#A00
            CP      #16
            JR      Z,x151F
            JP      x1D1A       ;       ,     *ERROR*

; DISC ERROR.

x151F       LD      (#5CDD),HL  ;    -
            LD      BC,(#5CDF)  ;   
            SBC     HL,BC       ; ?
            JP      C,x1C45     ; ,  NO SPACE
            RET                 ;

; #152C.   COPY B.  #5C3B.

x152C       CALL    x1D75       ;    ,  
            CALL    x166F       ;   
            LD      HL,x2779    ; BACKUP DISC
            CALL    x2707
            LD      HL,x27AA    ; INSERT SOURCE DISC
            CALL    x2707
x153E       CALL    x1052       ; 
            CP      "Y"         ; "Y"?
            JR      NZ,x153E    ; ,  
            CALL    x1D9F       ;  
            LD      A,#FF       ; 
            LD      (#5D21),A

;!!!    .     3   .

            CALL    x0405       ;  
            CALL    x3E11       ;  
            LD      (#5CD9),A   ; 
            LD      A,(#5E08)   ;  
            CP      #19         ; 40- ?
            LD      HL,#280     ;   #280 
            JR      Z,x1575     ; ,  
            LD      HL,#500     ;   #500 
            CP      #18         ; 80- ?
            JR      Z,x1575     ; ,  
            CP      #17         ; 40- ?
            JR      Z,x1575     ; ,  
            LD      HL,#A00     ;   #A00 
            CP      #16         ; 80- ?
            JR      Z,x1575     ; ,  
            JP      x040F       ; "Disk Error"
x1575       LD      BC,(#5E0A)  ;   
            SBC     HL,BC       ;   
            LD      (#5CE5),HL  ;  
            LD      (#5CDF),HL
            LD      HL,0        ; 0 
            LD      (#5CE1),HL
            LD      (#5CE3),HL
            CALL    x15B8       ; 
            CALL    x0405       ;  
            LD      A,(#5CE7)   ;   -
            LD      (#5E08),A
            LD      HL,(#5CDD)  ;     -
            LD      BC,(#5CDF)  ;   
            SBC     HL,BC       ;      - 
            LD      (#5E0A),HL  ; 
            CALL    x14E4       ;   -
            LD      DE,9        ;  8  0
            LD      (#5CF4),DE
            CALL    x1E43       ; 
            JP      x03E1       ;O.K.

; #15B2.   #5CE5.      Z,      HL.

x15B2       LD      HL,(#5CE5)  ;   #5CE5
            LD      A,H         ;   0
            OR      L
            RET                 ;

; #15B8.  .  #5CD9, #5CCF, #5CE5, #5D21, #5D23  #5CDB

x15B8       CALL    x15B2       ; ?
            RET     Z           ; ,  
            LD      A,(#5D21)   ; ?
            OR      A
            JR      NZ,x15DB    ; ,  -   
            CALL    x1D97
            LD      HL,x2779    ; BACKUP DISC
            CALL    x2707
            LD      HL,x27AA    ; INSERT SOURCE DISC
            CALL    x2707
x15D1       CALL    x1052       ;  "Y"
            CP      "Y"
            JR      NZ,x15D1
            CALL    x1D9F       ;  

x15DB       CALL    x15B2       ; ?
            RET     Z           ; ,  
            PUSH    BC          ; BC   
            PUSH    HL
            LD      HL,#5D23    ;     
            LD      C,(HL)
            LD      B,0
            POP     HL          ;  
            SBC     HL,BC       ;  
            POP     BC          ; BC
            JP      NC,x1644    ;   ,     
            LD      BC,(#5CE5)  ;   
            LD      HL,0        ; 
            LD      (#5CE5),HL
x15F8       PUSH    BC          ;  
            LD      HL,(#5CCF)  ;   
            PUSH    HL          ; 
            CALL    x14D8       ;   -
            LD      DE,(#5CE1)  ;     -
            LD      B,C
            CALL    x1E3D       ; 
            LD      HL,(#5CF4)  ;    
            LD      (#5CE1),HL  ; -
            CALL    x1D97       ; 
            LD      HL,x2779    ; BACKUP DISC
            CALL    x2707
            LD      HL,x2785    ; INSERT DESTINATION DISC
            CALL    x2707
x161D       CALL    x1052       ;  "Y"
            CP      "Y"
            JR      NZ,x161D
            CALL    x1D9F       ;  
            LD      A,(#5D21)   ; ?
            OR      A
            CALL    NZ,x14F0    ; ,      
            POP     HL          ;   
            POP     BC          ;   
            LD      DE,(#5CE3)  ;     -
            LD      B,C
            CALL    x14E4       ;   -
            CALL    x1E4D       ; 
            LD      HL,(#5CF4)  ;    
            LD      (#5CE3),HL  ; -
            JP      x15B8       ;
x1644       LD      (#5CE5),HL  ;   
            PUSH    HL          ; 
            LD      HL,#5D23    ;   
            LD      C,(HL)      ;   
            LD      B,0
            POP     HL          ;   
            XOR     A           ; 
            JP      x15F8       ;

; #1653.   .      A.  Z,     NZ,  ,   A     .

x1653       CALL    x165D       ;  
            LD      A,(#5CDD)   ;    
            CP      1           ;  
            RET                 ;

; #165C.   .     A   .      #5CE5.    :
;#165D -  ,   #165C,      C.
;#165E -  ,   #17E9,    .

x165C       LD      C,A         ;    . C
x165D       XOR     A           ;     
x165E       PUSH    BC          ;  
            CALL    x17E9       ;      
            POP     BC          ;  
            RET                 ;

; #1664.    . :     #5CDD,      .

x1664       LD      C,A         ;  C  
x1665       CALL    x166B       ;       
            JP      x1E43       ; 

; #166B.          .     #5CDD.

x166B       LD      A,#FF       ;     
            JR      x165E       ; ,   #17E9,    BC

; #166F.    .  #5CCF  #5D23.

x166F       LD      A,#FF       ;WORKSP 
            LD      (#5D0E),A
            CALL    x1680       ;   
            LD      HL,(#5C61)  ;   
            LD      (#5CCF),HL
            JP      x1E23       ;     

; #1680.      .        BC,    ?  #5D23.

x1680       RST     #20         ;     
            DW      #1F1A
            LD      HL,#FFFF
            SBC     HL,BC
            LD      A,H         ;  16 ?
            CP      #10
            JR      NC,x168F    ; , 
            LD      A,#11       ;  16 
x168F       DEC     A           ;1    
            LD      (#5D23),A   ;     
            LD      B,A         ;     
            LD      C,0
            RET                 ;

; #1697.  HL  #5CD7  #5CDB   #5CEA (1 )  #5CD9 (2 ).

x1697       LD      (#5CD7),HL  ; #5CD7  #5CD9
            LD      (#5CDB),HL
            LD      DE,(#5CEA)  ; #5CEA  #5CD9
            LD      HL,(#5CD9)
            LD      D,0
            ADD     HL,DE
            LD      (#5CD9),HL
            RET                 ;

; #16AB.   MOVE.  #5C3B. ; MOVE

x16AB       CALL    x042B       ; 2-  
            JP      NZ,LL1775   ; ENTER (   ???) ;: , ,  Z
            CALL    x1D75       ;,  
            CALL    x166F       ;   WORKSP
            LD      HL,(#5CCF)
            LD      (#5CE1),HL
            LD      DE,#0900
            ADD     HL,DE
            LD      (#5CCF),HL
            LD      A,(#5D23)
            SUB     D
            LD      (#5D23),A
            LD      HL,(#5CE1)
            LD      B,D
            LD      D,E
            CALL    x1E3D       ;LOAD SECTORS
            LD      HL,(#5CE1)
            LD      (#5CDF),HL
            LD      HL,#0100
            LD      (#5CD7),HL
            LD      (#5CDD),HL  ;???
            XOR     A
            LD      (#5CE3),HL
            LD      (#5CE4),A
            CALL    MOVEPP      ;#3B00
            LD      HL,(#5CE1)
            LD      DE,(#5CDF)
            LD      BC,#0800
            ADD     HL,BC
            SCF
            SBC     HL,DE
            LD      C,L
            LD      B,H
            LD      H,D,L,E
            INC     DE
            LD      (HL),#00
            LDIR
            LD      HL,(#5CE1)
            LD      DE,#08E1
            ADD     HL,DE
            LD      E,(HL)
            INC     HL
            LD      D,(HL)
            LD      BC,(#5CD7)
            LD      (HL),B
            DEC     HL
            LD      (HL),C
            INC     HL
            INC     HL
            INC     HL
            INC     HL
            LD      C,(HL)
            INC     HL
            LD      B,(HL)
            EXD
            LD      A,L
            AND     #0F
            LD      L,H
            LD      H,#00
            ADD     HL,HL
            ADD     HL,HL
            ADD     HL,HL
            ADD     HL,HL
            ADD     A,L
            LD      L,A
            ADD     HL,BC
            LD      BC,(#5CD7)
            LD      (#5CD7),HL
            LD      L,B
            LD      H,#00
            ADD     HL,HL
            ADD     HL,HL
            ADD     HL,HL
            ADD     HL,HL
            LD      A,C
            AND     #0F
            ADD     A,L
            LD      C,A
            LD      B,H
            LD      HL,(#5CD7)
            AND     A
            SBC     HL,BC
            EXD
            LD      (HL),D
            DEC     HL
            LD      (HL),E
            DEC     HL
            LD      A,(#5CE3)
            LD      (HL),A
            LD      DE,#0010
            ADD     HL,DE
            LD      (HL),D
            LD      HL,(#5CE1)
            LD      E,D
            LD      B,#09
            CALL    x1E4D
            LD      A,(#5D23)
            ADD     A,#09
            LD      B,A
            LD      C,#00
            LD      HL,(#5CCF)
            CALL    x1E2E       ; . HL=beg,BC=len
            JP      x03E1       ;"O.K."
LL1775      CALL    x1DDF       ;MOVE   ( ) ;.CH_ADD  .   -
            CALL    x1D75       ;,  
            CALL    x1C57       ;  
            CALL    x03FD       ; t0s8  
            LD      HL,#5CDD
            LD      DE,#5E1A
            LD      BC,#0008
            LDIR                ;  
            CALL    x1E43       ;      
            JP      x03E1       ;"O.K."

            DISPLAY "Free space at ",$,": ",/D,#17A5-$," byte(s)"
            DS      #17A5-$,#FF

; #17A5.  .  #5CD3, #5D23, #5CCF, #5CD5  #5CD7.

x17A5       LD      A,(#5CD3)   ;  ?
            OR      A
            RET     Z           ; ,  
            PUSH    HL          ; HL
            LD      HL,#5D23    ;   ?
            SUB     (HL)
            POP     HL          ; HL
            JR      NC,x17DD    ;   ,    
            LD      A,(#5CD3)   ;   
            LD      B,A
            XOR     A           ; 
            LD      (#5CD3),A
x17BA       PUSH    BC          ;   
            LD      HL,(#5CCF)  ;   
            PUSH    HL          ; 
            LD      DE,(#5CD5)  ;       
            CALL    x1E3D       ; 
            LD      HL,(#5CF4)  ;    
            LD      (#5CD5),HL
            POP     HL          ;   
            POP     BC          ;   
            LD      DE,(#5CD7)  ;       
            CALL    x1E4D       ; 
            LD      HL,(#5CF4)  ;    
            LD      (#5CD7),HL
            JR      x17A5       ;
x17DD       LD      (#5CD3),A   ;   
            PUSH    HL          ; HL
            LD      HL,#5D23    ;     
            LD      B,(HL)
            POP     HL          ; HL
            XOR     A           ; 
            JR      x17BA       ; 

; #17E9.          .   C -  ,  A -   (0 -  ,  -   ).

x17E9       PUSH    AF          ;  
            LD      HL,#5CCC    ;   - 0
            LD      (HL),0
            LD      A,C         ;     
x17F0       SUB     #10
            JR      C,x17F7
            INC     (HL)
            JR      x17F0
x17F7       ADD     A,#10       ;    
            LD      C,A
            PUSH    BC          ; 
            CALL    x03EC       ;     
            POP     BC          ;    
            POP     AF          ;  
            CALL    x1CA4       ;     
            LD      DE,#5CDD    ;    LDIR
            LD      BC,#10      ;  
            OR      A           ;  
            JR      Z,x180D
            EX      DE,HL
x180D       LDIR                ;  
            RET                 ;

; #1810.   VERIFY.  #5D11  #5C3B.    :
;#1815 -   LOAD.  #5D11  #5C3B;
;#1818 -   LOAD, PEEK  POKE;  #5D11, #5C3B  #5D10.

x1810       LD      A,#FF       ; 
            LD      (#5CF9),A
x1815       CALL    x1852       ; #5D10
x1818       CALL    x1836       ;    
            CALL    x1D75       ;    ,  
            LD      A,#FF       ;  LOAD
            LD      (#5D10),A
            LD      A,(#5CF9)   ; VERIFY?
            CP      #FF
            JP      Z,x03E1     ; ,  O.K.
            LD      A,(#5CE5)   ;  B?
            CP      "B"

;!!!       ,      .

            JP      Z,x012A     ; ,    
            JP      x03E1       ; O.K.

; #1836.     LOAD   .  #5D11, #5C3B, #5CF9  #5D10.

x1836       CALL    x187A       ; 
            CALL    x1D75       ;    ,  
            CALL    x18AB       ; 
            JP      x1921       ;   

; #1842.     LOAD...CODE.  #5C5D   .    #5CD6, #5CD9  #5CDB.

x1842       LD      HL,(#5C5D)  ;   ENTER?
            INC     HL
            LD      A,(HL)
            CP      #D
            RET     Z           ; ,  
            LD      A,1         ;  
            LD      (#5CD6),A
            CALL    x1DEB       ;    
x1852       XOR     A           ; #5D10
            LD      (#5D10),A
            RET                 ;

x1857       CALL    x102E       ;  
            LD      A,"B"       ; "B"?
            CP      B
            JR      NZ,x1866    ; ,   CH_ADD,   
            LD      HL,(#5C5D)  ;    
            DEC     HL          ;
            LD      (#5C5D),HL
x1866       CALL    x1DEB       ; 
            LD      HL,(#5CD9)  ;  / 
            LD      (#5CD7),HL
            LD      HL,(#5CDB)  ;  
            LD      (#5CD9),HL
            XOR     A           ; #5CD6
            LD      (#5CD6),A
            RET                 ;

; #187A.     LOAD. :  #5D11  #5C3B. :  #5CD2, #5CD7, #5CD9, #5CE5  #5CD6    .

x187A       CALL    x042B       ;    ENTER?
            JP      Z,x027B     ; ,         RUN "boot"

;!!!  ,          TR-DOS,     .

            CALL    x1DDF       ;     
            CALL    x0572       ;   ?
            CALL    NZ,x1857    ; ,      
            CALL    x1D8C       ;   
            CP      #AF         ; CODE?
            CALL    Z,x1842     ; ,   ,   
            CP      #E4         ; DATA?
            PUSH    AF          ;  
            CALL    x0572       ;   ?
            CALL    Z,x102E     ; ,   
            POP     AF          ;  
            CALL    Z,x1BFC     ;  DATA,    
            CALL    x1D75       ;    ,  
            CALL    x292F       ;     

; #18A4.   ,    .  #5CDD, #5CE5   Z:  Z=1   ,   NO FILE.

x18A4       JP      NZ,x03D9    ;   ,  NO FILE
            CALL    x165D       ;  
            RET                 ;

; #18AB.      .    #5CD6, #5CD9  #5CDB    ;     .    #5CDB     ,  #5CD6 0,   ,  3.  HL    ,  DE -    ,  B -    .             .

x18AB       CALL    PARAMZAG    ;#33CE
            OR      A           ;     ?
            LD      HL,(#5CE6)  ;    
            JR      Z,x18B7     ;     , 
            LD      HL,(#5CD9)  ;  ,  
x18B7       LD      DE,(#5CEB)  ;    
            CP      3           ;   ?
            LD      A,(#5CEA)   ;    
            PUSH    DE          ;    
            LD      DE,(#5CE8)  ;    
            JR      NZ,x18CB    ;     ,  
            LD      DE,(#5CDB)  ; ,  
x18CB       LD      B,A         ;    
            LD      (#5CDB),DE  ;    
            LD      A,(#5CE5)   ;  C?
            CP      "C"
            LD      A,B         ;    
            JR      NZ,x18FD    ;   C,    
            LD      A,B         ;      
            CP      D           ;  ,     
            JR      Z,x18F6
            DEC     A
            CP      D
            LD      A,B
            JR      Z,x18F6
            LD      A,(#5CD6)   ;  ?
            CP      3
            LD      A,B         ;    
            JR      Z,x18F6     ;     ,    
            XOR     A           ;    
            LD      (#5CD6),A
            LD      D,B         ;       
            LD      E,0         ; 
            LD      (#5CDB),DE  ;  
            JR      x18F9
x18F6       CALL    x191B       ;  
x18F9       LD      A,B         ;    
            CALL    x1EAC       ;    
x18FD       LD      B,A         ; 
            LD      A,(#5CE5)   ;  C?
            CP      "C"
            POP     DE          ;    
            RET     Z           ;   C,  

;!!!       ,     . -           B  D.

            PUSH    DE          ;    
            CP      "B"         ; B?
            PUSH    AF          ;  
            CALL    Z,x1A01     ;  B,       
            POP     AF          ; 
            CP      "D"         ; D?
            CALL    Z,x1A4C     ; ,     
            CALL    x191B       ;   
            LD      A,(#5CDC)   ;    
            LD      B,A
            POP     DE          ;    
            RET                 ;

; #191B.   3   #5CD6.

x191B       LD      A,3
            LD      (#5CD6),A
            RET

; #1921. / ,   /  . :  #5CF9, #5D10, #5CD7, #5CDB,  HL -  ,  DE -    ,  B -    .

x1921       CALL    x0572       ;   ?
            JR      Z,x192D     ; ,      
            PUSH    AF          ;  
            CALL    x1A94       ;    
            POP     AF          ;  
            CP      #FF         ;  ?
x192D       PUSH    AF
            CALL    Z,x195C     ; ,       
            POP     AF
            JR      Z,x1937     ;    
            JP      x1E4D       ;    
x1937       LD      A,(#5CD6)   ;  ?
            CP      3

;   !!!  :
;LD A,(#5D10)
;OR A
; PEEK   .       .    #5CD6  0,       0  #1946   .

            CALL    Z,x1946     ; ,      
            LD      HL,(#5C59)  ;    
            DEC     HL
            LD      (HL),#80
            RET                 ;

; #1946.     .  #5CF4, #5CDB  #5CF9.

x1946       LD      A,(#5CF9)   ;?
            CP      #FF
            JP      NZ,x2FDE    ; ,    
            LD      A,(#5CDB)   ;    ?
            OR      A
            RET     Z           ; ,  
            LD      C,A         ;  
            LD      B,1         ;1 
            LD      DE,(#5CF4)  ;  
            JR      x196A       ;    

; #195C. / ,     .  #5CF9 , DE     ,  HL -    ,  B -    .     #196A      (  #195C,  #5CF9   B ?  ).

x195C       LD      A,(#5CF9)   ;?
            CP      #FF
            JP      NZ,x1E3D    ; ,     
            LD      (#5CF4),DE  ;    
            LD      C,0         ;  #100 
x196A       LD      A,B         ; 0 ?
            OR      A
            RET     Z           ; ,  
            LD      (#5CD7),HL  ;    
            LD      (#5CD9),DE  ;    
x1974       PUSH    BC          ;  
            LD      B,1         ; 1 
            LD      DE,(#5CD9)  ;   
            LD      HL,#5D25    ; 
            CALL    x1E3D       ; 
            LD      HL,(#5CF4)  ;    
            LD      (#5CD9),HL
            POP     BC          ;  
            LD      HL,(#5CD7)  ;    
            LD      DE,#5D25    ;   
x198E       LD      A,(DE)      ; 
            CP      (HL)
            JR      NZ,x199D    ; ,  VERIFY ERROR
            INC     HL          ; 
            INC     DE
            DEC     C
            JR      NZ,x198E    ;  
            LD      (#5CD7),HL  ;  
            DJNZ    x1974       ;  
            RET                 ;
x199D       LD      HL,x276B    ;  VERIFY ERROR
            LD      A,#D        ;  - #D
            JP      x1C4A       ; 

; #19A5.   PEEK.  #5D11  #5C3B.

x19A5       LD      A,#FF       ;  PEEK
            JR      x19AB       ; 

; #19A9.   POKE.  #5D11  #5C3B.     #19AB (  LOAD, PEEK  POKE;  #5D11  #5C3B,      ).

x19A9       LD      A,#EE       ;  POKE
x19AB       LD      (#5D10),A   ;  
            JP      x1818       ; 

; #19B1.   MERGE.  #5D11  #5C3B.

x19B1       LD      A,#FF       ;  
            LD      (#5D15),A   ; ..
            CALL    x187A       ; 
            CALL    x1D75       ;    ,  
            LD      A,(#5CE5)   ;  B?
            CP      "B"
            JP      NZ,x1D1A    ; ,  
            LD      BC,(#5CE6)  ;    
            LD      (#5CDB),BC
            PUSH    BC          ; 
            INC     BC          ;    #80
            RST     #20         ;    
            DW      #0030
            LD      (HL),#80    ;  
            EX      DE,HL       ;    HL
            POP     DE          ;    
            PUSH    HL          ;  
            LD      DE,(#5CEB)  ;    
            CALL    x191B       ;  
            LD      A,(#5CDC)   ;    
            LD      B,A
            CALL    x1852       ;   
            CALL    x1921       ; 
            POP     HL          ;  
            LD      DE,(#5C53)  ;    
            RST     #20         ; 
            DW      #08D2
            JP      x03E1       ; O.K.

; #19F2.          .  HL -  ,  DE - .    :
;#19FD (    ;      DE).

x19F2       EX      DE,HL
            SCF                 ;  
            SBC     HL,DE
            RET     C           ;    ,  
            LD      DE,#A       ;   #A 
            ADD     HL,DE
            LD      B,H         ;    BC
            LD      C,L
x19FD       RST     #20         ;    
            DW      #1F05
            RET                 ;

; #1A01.      .

x1A01       LD      DE,(#5C53)  ;     
            LD      HL,(#5C59)  ;     
            DEC     HL
            PUSH    HL          ;    
            PUSH    DE
            SBC     HL,DE       ;    
            LD      DE,(#5CE6)  ;    
            PUSH    DE          ; 
            PUSH    HL          ;   
            LD      HL,0        ; ?
            LD      A,(#5CF9)
            CP      #FF
            JR      Z,x1A20     ; ,    
            LD      HL,5        ;    5 
x1A20       ADD     HL,DE
            LD      (#5CDB),HL  ;  
            POP     HL          ;   
            LD      A,(#5CF9)   ;?
            CP      #FF
            JR      NZ,x1A31    ; ,   
            POP     DE          ;   
            POP     DE
            POP     HL
            JR      x1A48       ;
x1A31       CALL    x19F2       ;    
            POP     BC          ;    
            POP     DE          ;  
            POP     HL          ;  
            PUSH    BC          ;  
            RST     #20         ;  
            DW      #19E5
            POP     BC          ;  
            CALL    x1E32       ;    
            INC     HL          ;  VARS
            LD      BC,(#5CE8)
            ADD     HL,BC
            LD      (#5C4B),HL
x1A48       LD      HL,(#5C53)  ;   
            RET                 ;

; #1A4C.     .  #5CE8, #5CD7, #5CD9  #5CF9.

x1A4C       LD      DE,(#5CE8)  ;  
            LD      (#5CDB),DE
            LD      HL,(#5CD7)  ;    
            LD      A,(#5CF9)   ;?
            CP      #FF
            RET     Z           ; ,  
            LD      HL,(#5CD9)  ;   
            PUSH    HL          ; 
x1A61       CALL    x19F2       ;    
            POP     HL          ;   
            LD      A,H         ;  0?
            OR      L
            JR      Z,x1A79     ; ,     
            LD      HL,(#5CD7)  ;   
            DEC     HL
            DEC     HL
            DEC     HL
            LD      BC,(#5CD9)  ;  
            INC     BC
            INC     BC
            INC     BC
            CALL    x1E2E       ;  
x1A79       LD      HL,(#5C59)  ;   
            DEC     HL
            LD      BC,(#5CE8)  ;  
            PUSH    BC          ; 
            INC     BC
            INC     BC
            INC     BC
            CALL    x1E32       ;    
            INC     HL          ;  
            LD      A,(#5CD2)
            LD      (HL),A
            INC     HL          ;    
            POP     DE
            LD      (HL),E
            INC     HL
            LD      (HL),D
            INC     HL          ;   
            RET                 ;

; #1A94.           . :  #5CD7  #5CD9     B    ,   DE -    . :  DE     ,   B  1.

x1A94       LD      A,(#5CD9)   ;    
            LD      C,B
            LD      B,A
            LD      A,C
            CP      B           ; ,     ?
            JR      C,x1AB6     ; ,  

;, !!!       , ..       .

            LD      A,B         ;  0?
            OR      A
            JP      Z,x1D1A     ; ,   
            DEC     B           ;   1?
            JR      Z,x1AB0     ; ,      
            LD      A,#10       ;  16 
x1AA7       INC     E           ;    
            CP      E
            JR      NZ,x1AAE
            LD      E,0
            INC     D
x1AAE       DJNZ    x1AA7
x1AB0       LD      B,1         ;  1 
            LD      HL,(#5CD7)  ;   
            RET                 ;
x1AB6       LD      HL,x29ED    ;  REC.O/F
            LD      A,5         ;  - 5
            JP      x1C4A       ; 

; #1ABE.        .      .     #1AC4 (      ).

x1ABE       CALL    x292F       ;    
            CALL    Z,LL3343    ; . . . .Overwr=ON
x1AC4       CALL    x03FD       ;    8  0
            LD      A,(#5E09)   ;  128 ?
            CP      #80
            JP      Z,x2723     ; ,   DIRECTORY FULL
            RET                 ; 

; #1AD0.   SAVE.  #5C3B  #5D11.    :
;#1B27 -    .  #5CDD  #5CE5.
;#1B53 -  .  #5CDD, #5CE5, #5CD7, #5CD9  #5CDB.

x1AD0       CALL    x1852       ; #5D10
            LD      HL,0        ;   
            LD      (#5CD1),HL
            CALL    x1DDF       ;     
            CALL    x1D8C       ;  
            CP      #AF         ; CODE?
            JR      Z,x1B39     ; ,     
            CP      #CA         ; LINE?
            JR      NZ,x1AF8    ; ,    
            CALL    x1E0B       ;   
            CALL    x1D75       ;   ,  
            LD      HL,(#5CDB)  ;   
            LD      (#5CD1),HL
            LD      HL,#5CE5
            JR      x1B1F       ;   
x1AF8       CP      #AA         ;  SCREEN$?
            JR      NZ,x1B0D    ; ,    DATA
            LD      HL,#4000    ;  - #4000
            LD      (#5CD7),HL
            LD      HL,#1B00    ;  - #1B00 
            LD      (#5CD9),HL
            LD      (#5CDB),HL
            JR      x1B48       ;    C
x1B0D       CALL    x1D75       ;   ,  
            CALL    x1D8C       ;  
            LD      HL,#5CE5
            CP      #E4         ; DATA?
            JR      Z,x1B2C     ; ,   
            CP      #D          ; ENTER?
            JP      NZ,x1D1A    ; ,  
x1B1F       LD      (HL),"B"    ; B
            CALL    x1ABE       ;        
            CALL    x1E1C       ;     
x1B27       CALL    x1BDE       ;    
            JR      x1B53       ; 
x1B2C       LD      (HL),"D"    ; D
            CALL    x1ABE       ;      
            CALL    x1C0F       ;    
            JR      NC,x1B53    ;   ,   
            JP      C,x1D1A     ; 
x1B39       CALL    x1DE5       ;    
            LD      HL,(#5CD9)  ;  
            LD      (#5CD7),HL
            LD      HL,(#5CDB)  ;  
            LD      (#5CD9),HL
x1B48       CALL    x1D75       ;   ,  
            LD      A,"C"       ; C
            LD      (#5CE5),A
            CALL    x1ABE       ;      
x1B53       CALL    SAVER       ;#33F5 ; 
            JP      x0569       ;   

; #1B59.  .  #5CD1, #5CD7, #5CD9  #5CDB,      8  0.

x1B59       LD      HL,(#5CD7)  ;  
            LD      (#5CE6),HL
            EX      DE,HL       ;   DE
            LD      HL,(#5CD9)  ;  
            LD      A,L         ;  0?
            OR      H
            JP      Z,x1D1A     ; ,  
            LD      A,L         ;    
            OR      A
            JR      Z,x1B6D
            INC     H
x1B6D       LD      A,H         ;    
            LD      (#5CEA),A
            LD      E,A         ;    
            LD      D,0
            LD      HL,(#5E0A)
            SBC     HL,DE
            JP      C,x1C45     ;    ,  
x1B7B       PUSH    HL          ;    
            LD      HL,(#5C59)  ;      #AA
            LD      (HL),#AA
            INC     HL
            LD      DE,(#5CD1)  ;   
            LD      (HL),E
            INC     HL
            LD      (HL),D
            LD      HL,(#5CDB)  ;  
            LD      (#5CE8),HL
            LD      HL,(#5E06)  ;    
            LD      (#5CEB),HL
            EX      DE,HL       ;   DE
            LD      HL,(#5CE6)  ;  
            LD      A,(#5CEA)   ;    
            LD      B,A
            CALL    x1E4D       ; 
            LD      HL,(#5CF4)  ;    
            PUSH    HL          ; 
            CALL    x03FD       ;    8  0
            POP     HL          ;     
            LD      (#5E06),HL  ; 
            POP     HL          ;   
            LD      (#5E0A),HL  ; 
            LD      HL,#5E09    ;  
            LD      A,(HL)
            LD      (#5D1E),A   ; 
            INC     (HL)        ;  1 
            PUSH    HL          ;   -   
            CALL    x1E43       ;  8  0
            POP     HL          ;   - 
            LD      C,(HL)      ;   
            DEC     C
x1BBF       LD      A,(#5CE5)   ;  B?
            CP      "B"
            CALL    Z,x1BC8     ; ,      
            RET                 ;

; #1BC8.       .       #5CE6,    -  #5CE8.

x1BC8       LD      HL,(#5C59)  ;    
            LD      DE,(#5C53)
            SCF
            SBC     HL,DE
            LD      (#5CE6),HL  ; 
            LD      HL,(#5C4B)  ;   
            SBC     HL,DE
            LD      (#5CE8),HL  ; 
            RET                 ;

; #1BDE.          .

x1BDE       LD      HL,(#5C4B)  ;    
            LD      DE,(#5C53)
            SBC     HL,DE
            LD      (#5CDB),HL  ;    
            LD      HL,(#5C53)  ;  
            LD      (#5CD7),HL
            LD      HL,(#5C59)  ;     
            INC     HL
            INC     HL
            INC     HL
            SBC     HL,DE
            LD      (#5CD9),HL  ;   
            RET                 ;

; #1BFC.      LOAD...DATA. :  #5C5D      #5CF9. :  #5CD2, #5CD7, #5CD9  #5CDB.     #1C0F ( ,   #1C1B,    ).

x1BFC       CALL    x1C1B       ; 
            RET     NC          ;  ,  
            LD      HL,0        ;  
            LD      (#5CD9),HL
            LD      A,(#5CF9)   ; ?
            CP      #FF
            RET     NZ          ; ,  
            JP      x1C13       ;
x1C0F       CALL    x1C1B       ; 
            RET     NC          ;  ,  
x1C13       LD      A,#E        ;  - #E
            LD      HL,x27DD    ;  ARRAY NOT FOUND
            JP      x1C4A       ; 

; #1C1B.     .   #5CD2, #5CD7, #5CD9  #5CDB.    C  ,  .

x1C1B       CALL    x1E2A       ;  
            CALL    x1D9B       ; 
            SET     7,C         ;  7   
            LD      A,C         ;  
            LD      (#5CD2),A
            JR      NC,x1C2B    ;  ,    
x1C29       SCF                 ; 
            RET                 ;
x1C2B       JR      NZ,x1C29    ;  Z ,  
            INC     HL          ;  
            LD      E,(HL)      ;  
            INC     HL
            LD      D,(HL)
            INC     HL
            LD      (#5CD7),HL  ;   
            LD      (#5CDB),DE  ;  
            LD      (#5CD9),DE
            CALL    x1E2A       ; 
            CP      ")"         ; ")"?
            JR      NZ,x1C2B    ; ,  
            RET                 ;

; #1C45.   NO SPACE.     #1C4A ( ;  A -  ,  HL -  ).

x1C45       LD      HL,x29BB    ;  NO SPACE
            LD      A,3         ;  - 3
x1C4A       CALL    x03C3       ; ,   
            JP      x01D3       ;

; #1C50.   FILE EXISTS.

x1C50       LD      HL,x29C5    ;  FILE EXISTS
            LD      A,2         ;  - 2
            JR      x1C4A       ; 

; #1C57.   .  #5C5D   .       #5CDD.

x1C57       LD      HL,#5CDD    ;    
            LD      B,8         ;  - 8 
x1C5C       LD      (HL)," "    ; 
            INC     HL
            DJNZ    x1C5C
            CALL    x0531       ;    
            EX      DE,HL
            CALL    x1C81       ; 
            LD      A,C         ;  -  ?
            OR      B           ; BC=0
            JP      Z,x1D1A     ; ,  
            CP      9           ;    8 
            JR      C,x1C73     ; ,   
            LD      C,8

;!!!          #FF .

x1C73       LD      A,(HL)      ;    
            CP      " "         ;   #20?
            JP      C,x1D1A     ; ,  
            LD      DE,#5CDD    ;    
            PUSH    BC          ;  
            LDIR                ; 
            POP     BC          ;  
            RET                 ;

; #1C81.      .  HL      ASCII ,   BC ?  . HL      ,   BC   .

x1C81       INC     HL          ;    
            LD      A,(HL)      ;  
            CP      ":"         ; ?
            JR      NZ,x1C98    ; ,     
            DEC     HL          ;   
            LD      A,(HL)      ;  
            CALL    x0524       ;     
            PUSH    BC          ;   
            PUSH    HL          ;   
            CALL    x3DCB       ; 
            POP     HL          ;   
            POP     BC          ;   
            DEC     BC          ; 2 
            DEC     BC
            INC     HL          ;     
            INC     HL
            RET                 ;
x1C98       DEC     HL          ;   
            LD      A,(#5D19)   ;   
            PUSH    BC          ;     
            PUSH    HL
            CALL    x3DCB       ; 
            POP     HL          ;     
            POP     BC
            RET                 ;

; #1CA4.           .  C      .    HL   .

x1CA4       LD      L,C         ;     
            LD      H,0         ;
            ADD     HL,HL       ;   #10
            ADD     HL,HL
            ADD     HL,HL
            ADD     HL,HL
            LD      BC,#5D25    ;   
            ADD     HL,BC
            RET                 ;

; #1CB0.     .        . :      ,     Z,   . C   #5D1E   ,     ,   Z .    :
;#1CB3 ( ,  #5CDD  #5CE5,     #1CB0).

x1CB0       CALL    x1C57       ;  
x1CB3       CALL    x03E8       ;   0
            LD      B,#80       ; 128 
            LD      C,0         ;     
x1CBA       PUSH    BC          ;    
            CALL    x1CA4       ;    
            CALL    x050C       ;     
            POP     BC          ;     
            PUSH    BC          ;    
            LD      A,C         ;  ?
            CP      #10
            JR      NZ,x1CCD    ; , 
            POP     BC          ;      
            LD      C,0         ;   
            JR      x1CBA       ; 
x1CCD       LD      DE,#5CDD    ;     
            LD      A,(#5D06)   ;   
            LD      B,A
            XOR     A           ; ?
            CP      (HL)
            JR      NZ,x1CDB    ; ,     
            POP     BC          ;      
            JR      x1CE4       ;   NZ
x1CDB       CALL    x2713       ;  
            POP     BC          ;    
            JR      Z,x1CE7     ;   ,   
            INC     C           ; 
            DJNZ    x1CBA       ;  
x1CE4       OR      #FF         ;  Z
            RET                 ;
x1CE7       LD      A,#80       ;  
            SUB     B
            LD      C,A
            LD      (#5D1E),A   ;   #5D1E
            XOR     A           ;  Z
            RET     Z           ;

; #1CF0.  .  ,  ,    #5CDD   #5D06.    ,     Z   #5D0F  #FF,   ,    Z,      . C    #5D0F  #5D1E.

x1CF0       CALL    x1CB3       ; 
            LD      HL,#5D0F
            LD      (HL),C      ;  C  #5D0F
            RET     Z           ;  ,  
            LD      (HL),#FF    ;  #5D0F #FF
            RET                 ;

;p #1CFB.   RETURN.  #5C3B, #5D1C  #5D13.

x1CFB       CALL    x1D75       ;    ,  
            CALL    x20E5       ; 
            RES     3,(IY+1)    ;   "K"
            CALL    x0232       ;  ERR_SP
            LD      SP,(#5D1C)  ; 
            LD      HL,(#5C3D)  ;     ERR_SP
            DEC     HL
            LD      A,#12       ;  #12?
            CP      (HL)

            IFDEF   FIX_HL
                JP  PATCH_HL       ;(VELESOFT) - jump to new patch for fix value of register HL'
                ELSE
                JR      NZ,x1D19    ; ,  
                DEC     HL          ; ERR_SP   
            ENDIF
 
                
            LD      (#5C3D),HL
x1D19       RET                 ;

; #1D1A.   .  #5C3A, #5D0E, #5D15,     #1D3.    :
;#1D29 ( ;  A -  ,  HL ?  ).

x1D1A       BIT     7,(IY+0)    ;    ?
            JR      Z,x1D25     ; ,   
            LD      A,#B        ;NONSENCE IN BASIC
            LD      (#5C3A),A
x1D25       INC     A           ;   DOS
            LD      HL,x29B2    ;  ERROR
x1D29       CALL    x03C3       ; ,  
            JP      x01D3       ;

; #1D2F.  ,       .  #5C3A.

x1D2F       LD      A,(#5C3A)   ;   
            LD      HL,x27CA    ;  *BREAK*
            CP      #14         ;BREAK INTO PROGRAM?
            JR      Z,x1D29     ; ,   
            CP      #C          ;BREAK - CONT REPEATS?
            JR      Z,x1D29     ; ,   
            LD      HL,x27D2    ;  OUT OF RAM
            CP      3           ;OUT OF MEMORY?
            JR      Z,x1D29     ; ,   
            LD      HL,x27DD    ;  ARRAY NOT FOUND
            CP      1           ;VARIABLE NOT FOUND?
            JR      Z,x1D29     ; ,   
            JR      x1D1A       ;  *ERROR*

; #1D4D.   RUN.  #5D11  #5C3B.

x1D4D       CALL    x1852       ;  
            CALL    x1836       ;    
            CALL    x1D75       ;    ,  
            LD      HL,(#5CE6)  ;     

;!!!        .   #18AB    #5D20    ,    .

            LD      A,(#5CE5)   ;  B?
            CP      "B"
            JP      Z,x012A     ; ,     
            PUSH    HL          ;   
            RET

;!!!    !!! -,        BC; -,     TR-DOS,      #3D13;  ,    ?;  ...  ,   ( CALL #1D75):
;    LD A,(#5CE5)
;    CP "D"
;    JP Z,#1D1A
;    CP "B"
;    JP Z,#12A
;    LD HL,START
;    LD (#5D1A),HL
;    JP #1D3
;
;START    CALL #232
;    LD BC,(#5D20)
;    PUSH BC
;    RET

; #1D63.    .

x1D63       LD      HL,#5D0E    ;  ?
            LD      A,(HL)
            CP      #FF
            LD      (HL),0      ;  
            RET     NZ          ;   ,  
            RST     #20         ;  
            DW      #16BF
            RET                 ;

; #1D70. ,         .   ,   Z  ,  .

x1D70       BIT     7,(IY+1)
            RET

; #1D75.     ,    ,   .  #5C3B.

x1D75       CALL    x1D70       ;,  
            RET     NZ          ;  ,  
            POP     HL          ;     
            RET                 ;   

; #1D7B.     .  #5C5D    .     ,     Z,     .

x1D7B       CALL    x1E2A       ;   
            CALL    x1DC1       ;    
            JR      x1D70       ;,      

; #1D83.   0.     #1D84 ( ;    A).

x1D83       XOR     A           ;  - 0
x1D84       RST     #20         ; 
            DW      #1601
            RET                 ;

; #1D88.   2.

x1D88       LD      A,2         ;  - 2
            JR      x1D84       ; 

; #1D8C.    .     #5C5D.

x1D8C       RST     #20
            DW      #0018
            RET

; #1D90.  .

x1D90       CALL    x1D83       ;  0
            RST     #20         ;  
            DW      #0F2C
            RET                 ;

; #1D97.      0.

x1D97       RST     #20
            DW      #0D6B
            RET

; #1D9B.  .  #5C5D   .   ,   HL   .

x1D9B       RST     #20
            DW      #28B2
            RET

;p #1D9F.   .

x1D9F       RST     #20
            DW      #0D6E
            RET

; #1DA3.     A.    :
;#1DA4 (    C),
;#1DA9 (    BC).

x1DA3       LD      C,A         ;   C
x1DA4       LD      B,0         ;    
            JP      x1DA9       ; !
x1DA9       PUSH    BC          ; 
            CALL    x20F1       ; 
            POP     BC          ; 
            RST     #20         ; 
            DW      #1A1B
            CALL    x20F1       ; 
            RET                 ;

; #1DB5.     .  DE   ,  BC -  .

x1DB5       RST     #20
            DW      #2BF1
            RET

x1DB9       RST     #20
            DW      #1E99
            RET

; #1DBD.     .  #5C5D   .

x1DBD       RST     #20
            DW      #1C8C
            RET

; #1DC1.    BC   .

x1DC1       RST     #20
            DW      #1C82
            RET

; #1DC5.  CH_ADD    .  #5D11.

x1DC5       LD      HL,(#5D11)  ;   
            INC     HL          ;    
            LD      (#5C5D),HL  ;   CH_ADD
            RET                 ;

; #1DCD.  2-    .   #5D11   .

x1DCD       CALL    x1DDF       ;     
x1DD0       CALL    x1D8C       ;  
            CP      ","         ; ?
            JP      NZ,x1D1A    ; ,  
            CALL    x1E2A       ; 
            CALL    x1DBD       ;     
            RET                 ;

; #1DDF.  CH_ADD      .  #5D11.

x1DDF       CALL    x1DC5       ; CH_ADD
            JP      x1DBD       ;    

; #1DE5.        CODE.     #5CD9,  -  #5CDB.    ,      .   2 ,   #5CD6  3.    #5C5D  #5C3B.    :
;#1E0B ( ;  #5C5D  #5C3B;    #5CDB,   #5CD6  3).

x1DE5       CALL    x1D8C       ;   
            CP      #AF         ; CODE?
            RET     NZ          ; ,  
x1DEB       CALL    x1D7B       ;    
            JR      Z,x1DFB     ;    ,   
            CALL    x1DB9       ;    
            LD      (#5CD9),BC  ;  
            LD      (#5CDB),BC
x1DFB       CALL    x1D8C       ;  
            CP      ","         ; ?
            JR      Z,x1E0B     ; ,    
            CP      #D          ; ENTER?
            JP      NZ,x1D1A    ; ,  
            CALL    x1D75       ;    ,  
            RET                 ;
x1E0B       CALL    x1D7B       ;     
            RET     Z           ;   ,  
            CALL    x1DB9       ;    
            LD      (#5CDB),BC  ;   #5CDB
            LD      A,3         ; 2 
            LD      (#5CD6),A
            RET                 ;

; #1E1C.    p  

x1E1C       LD      HL,(#5D11)  ;   
            RST     #20         ;    
            DW      #11A7
            RET                 ;

; #1E23.     .  BC    .

x1E23       LD      HL,(#5C61)  ; HL  #5C61
            RST     #20         ; 
            DW      #0030
            RET                 ;

; #1E2A.    .  #5C5D.

x1E2A       RST     #20
            DW      #0020
            RET

; #1E2E.   .  HL   ,  BC - .

x1E2E       RST     #20
            DW      #19E8
            RET

x1E32       RST     #20
            DW      #1655
            RET

; #1E36.   .  #5CD1.      #5D17  #FF.    :
;#1E3A      #3F.

x1E36       CALL    x3EB2       ;  ,    
            LD      A,H         ;  
x1E3A       OUT     (#3F),A
            RET                 ;

; #1E3D.  . :  HL -  ,  D -  ,  E -  ,  B - - .

x1E3D       XOR     A           ; 
            JR      x1E64       ;   / 

; #1E40.    .    C    .    :
;#1E43 -    . :  #5CF4   +1,   #5CF5 -  .
;#1E4D -  .  HL - ,  D -  ,  E -  ,  B - - .
;#1E64 - / .          A  0    -   .

x1E40       CALL    x166B       ;       
x1E43       LD      DE,(#5CF4)  ;    
            DEC     DE
            LD      B,1         ; 1 
            LD      HL,#5D25    ;   
x1E4D       PUSH    HL          ;       
            PUSH    DE
            CALL    x3E11       ;  
            BIT     7,(HL)      ; 40-?
            JR      Z,x1E60     ; ,   
            BIT     0,(HL)      ; 40   80-?
            JR      NZ,x1E60    ; ,   
            LD      HL,x29D8    ;  READ ONLY
            JP      x1D29       ;   

;, !!!      .

x1E60       POP     DE          ;  
            POP     HL
x1E62       LD      A,#FF       ; 
x1E64       LD      (#5CCE),A   ;  
x1E67       LD      (#5CF4),DE  ;    
            PUSH    BC          ;  
            PUSH    HL          ;   / 
            JP      TCH1        ;#3800
TCH1Q       POP     HL          ;   / 
            POP     BC          ;  
            XOR     A           ;   0?
            OR      B
            RET     Z           ; ,  
x1E75       PUSH    BC          ;   - 
            PUSH    HL
            CALL    x3F06       ;   /  
            LD      A,(#5CF4)   ;  
            CALL    x3F02
            LD      A,(#5CF5)   ;   
            CALL    x3E63
            LD      A,(#5CCE)   ;  
            OR      A           ;?
            PUSH    AF
            CALL    Z,x3F0E     ; ,   
            POP     AF
            CALL    NZ,x3F0A    ;  
            POP     HL          ;   
            LD      DE,#100
            ADD     HL,DE
            PUSH    HL          ; 
            LD      A,#10       ;  16 
            LD      HL,#5CF4
            INC     (HL)        ; 
            CP      (HL)        ; ?
            JR      NZ,x1EA7    ; ,     0
            LD      (HL),0
            LD      HL,#5CF5    ;   
            INC     (HL)
x1EA7       POP     HL          ;   
            POP     BC          ;  
            DJNZ    x1E75       ;  ,  
            RET                 ;

; #1EAC.          .  A     ,   DE -    .

x1EAC       PUSH    HL          ; HL
            LD      H,A         ;   
            LD      L,0
            PUSH    HL          ; 
            SBC     HL,DE       ;   ?
            CALL    C,x1EBC     ; ,    
            POP     HL          ;   
            LD      A,H         ;       
            POP     HL          ; HL
            RET     C           ;      ,
            LD      A,D         ;       
            RET                 ;

; #1EBC.  #5CD6    C.

x1EBC       XOR     A
            LD      (#5CD6),A
            SCF
            RET

; #1EC2.   FORMAT.  #5D11  #5C3B.     #1EDD ( ;  #5CDD).

x1EC2       LD      HL,#FFFF
            LD      (#5CD7),HL  ;  
            LD      (#5CD9),HL  ;   
            LD      (#5CD1),HL  ;     
            CALL    x042B       ;  ENTER?
            JP      Z,x1D1A     ; ,  
            CALL    x1DDF       ;     
            CALL    x1D75       ;    ,  
            CALL    TCH3        ;#3921
wFORMAT     CALL    SELFORMAT   ;#3378
            AND     #80         ; 40-?
            LD      A,#28       ; 40 
            JR      Z,x1EE8     ;  80-,
            LD      A,#50       ;  80 
x1EE8       LD      (#5CD7),A   ;  
            CALL    x3D98       ;
            CALL    x1FF6       ;   
            CALL    x3EA0       ;  3135098 
            CALL    x1EBC       ;SCF:(23766),0(   -)
            LD      A,(#5CDD)
            CP      #24
            JR      Z,x1F1B
            JR      x1F16

            DISPLAY "Free space at ",$,": ",/D,#1F16-$," byte(s)"
            DS      #1F16-$,#FF

x1F16       LD      A,#80       ;   
            LD      (#5CDA),A
x1F1B       CALL    FORMDISK    ;#334C
            LD      HL,#5D25    ;  
            LD      (HL),0      ;  
            LD      DE,#5D26    ;   
            LD      BC,#FF      ;  #FF 
            LDIR                ; 
            LD      BC,#5CD7    ;    
            LD      DE,#5CDA    ;    
            LD      A,(BC)      ; 80 ?
            CP      #50
            JR      Z,x1F49     ; ,   80-
            LD      A,(DE)      ; 2 p?
            CP      #80
            JR      Z,x1F42     ; ,   40- p
            LD      A,#19       ; 40- 
            LD      HL,#270     ; #270 
            JR      x1F55       ;  
x1F42       LD      A,#17       ; 40- 
x1F44       LD      HL,#4F0     ; #4F0 
            JR      x1F55       ;  
x1F49       LD      A,(DE)      ; 2 ?
            CP      #80
            LD      A,#18       ; ,   80- 
            JR      NZ,x1F44
            LD      A,#16       ;  80- 
            LD      HL,#9F0     ; #9F0 
x1F55       LD      (#5E08),A   ;  
            LD      (#5E0A),HL  ;   
            LD      A,1         ;   - 1
            LD      (#5E07),A
            LD      A,#10       ;    TR-DOS
            LD      (#5E0C),A
            LD      HL,#5E0F    ;9  #20   #5E0F
            LD      DE,#5E10
            LD      BC,8
            LD      (HL),#20
            LDIR
            LD      HL,#5CDD    ;  
            LD      DE,#5E1A
            LD      BC,8
            LDIR
            CALL    x1FEB       ;   
            LD      B,1         ; 1 
            LD      DE,8        ; 8  0
            LD      HL,#5D25    ; 
            CALL    x1E62       ; 
            LD      A,(#5CD6)   ;   
            PUSH    AF          ; 
            XOR     A           ; - CHR$ 0
            LD      (#5CE5),A
            LD      HL,(#5E0A)  ;   
            LD      (#5CD7),HL  ; 
            LD      HL,#5CDD    ;  
            RST     #18
            LD      A,#D        ; 
            RST     #10
            LD      HL,(#5CD7)  ;   
            POP     AF          ;   
            PUSH    HL          ;   
            LD      D,0         ;    
            LD      E,A         ; 
            SBC     HL,DE       ;   
            LD      B,H         ;   BC
            LD      C,L
            CALL    x1DA9       ; 
            LD      A,"/"       ; "/"
            RST     #10
            POP     BC          ;   
            CALL    x1DA9       ; 
            JP      ASKREPFORM  ;#833

; #1FB9.      .     #1FBA   .

x1FB9       DB      1
x1FBA       DB      9,2,#A,3,#B,4,#C,5,#D,6,#E,7,#F,8,#10,1

; #1FCA.    . :     . :  #5CD7   A    .

x1FCA       CALL    x3E08       ;   
            OR      #11         ;   #32
            LD      B,A
            LD      A,#32
            CALL    x3E44
            LD      A,2         ;   2
            CALL    x3E44
            CALL    x3DFD       ;  725779 
            IN      A,(#1F)     ;   ?
            AND     4
            LD      A,#50       ; ,    80 
            JR      Z,x1FE7
            LD      A,#28       ; 40
x1FE7       LD      (#5CD7),A   ;  
            RET                 ;

; #1FEB.    .  #5D16.     #1FF0 (  ,  -  ).      :
;#1FF3      #FF.

x1FEB       LD      A,(#5D16)   ;   
            OR      #3C         ; MFM,  ,    
x1FF0       LD      (#5D16),A   ;   
x1FF3       OUT     (#FF),A     ;  
            RET                 ;

; #1FF6.    .  #5D16.

x1FF6       LD      A,(#5D16)   ;   
            AND     #6F         ; MFM,  ,    
            JR      x1FF0       ;  

; #1FFD.  .          .    #5CD8, #5CE6, #5CE8   #5CD6.     #1FC9 ( ;  #5CD8, #5CE8   #5CD6   ).

x1FFD       DI                  ; 
            LD      A,#F4       ; 
            OUT     (#1F),A
            LD      HL,(#5CE6)  ;     
            LD      C,#7F       ;  
x2007       LD      B,#A        ;#A  #4E ( )
            LD      D,#4E
            CALL    x20B1       ;    
            LD      B,#C        ;
            LD      D,0
            CALL    x20B1
            LD      B,3         ;
            LD      D,#F5
            CALL    x20B1
            LD      D,#FE       ;1  #FE (  )
            CALL    x20AF       ;  1 
            LD      D,E         ; 
            CALL    x20AF
            LD      D,0         ;  ( TR-DOS  0)
            CALL    x20AF
            LD      D,(HL)      ;   
            CALL    x20AF
            LD      D,1         ;  - #100 
            CALL    x20AF
            LD      D,#F7       ;  
            CALL    x20AF
            LD      B,#16       ; 
            LD      D,#4E
            CALL    x20B1
            LD      B,#C        ;
            LD      D,0
            CALL    x20B1
            LD      B,3         ;
            LD      D,#F5
            CALL    x20B1
            LD      D,#FB       ;  
            CALL    x20AF
            LD      B,0         ; (#100 )
            LD      D,0
            CALL    x20B1
            LD      D,#F7       ;  
            CALL    x20AF
            LD      B,#32       ; 
            LD      D,#4E
            CALL    x20B1
            LD      A,(HL)      ;    
            INC     HL
            CP      #10         ; ?
            JR      NZ,x2007    ; ,    
            LD      B,0         ;   
            CALL    x20B1
            JP      M,x2076
            CALL    x20B1
x2076       IN      A,(#1F)     ;  
            AND     #40         ; ?
            JP      NZ,x3F39    ; ,   READ ONLY
x207D       LD      A,(#5CD8)   ; ?
            OR      A
            RET     NZ          ; ,  

;!!!         .

            LD      C,#7F       ;  
            LD      A,E         ;  
            OUT     (#3F),A
            CALL    SUB14       ;#33BE ;HL=HL-14 (???)
x208A       LD      B,3         ;3 
            LD      A,(HL)      ;    
            OUT     (#5F),A     ; 
            PUSH    HL          ;   
x2090       DI                  ; 
            LD      A,#80       ; 
            OUT     (#1F),A
            PUSH    BC          ;  
            CALL    x3FE5       ;     HL ( ,  )
            IN      A,(#1F)     ;  ?
            AND     #7F
            POP     BC          ;  
            JR      Z,x20A6     ;   ,   
            DJNZ    x2090       ; 
            LD      HL,#5CD6    ; 1  
            INC     (HL)
x20A6       POP     HL          ;   
            LD      A,(HL)      ;   
            INC     HL          ;    
            CP      1           ; ?
            JR      NZ,x208A    ; ,  
            EI                  ; 
            RET                 ;

; #20AF.   1 p.   D  ,  C - #7F      -#5D.     #20B1 (   ;   #20AF   B  ).

x20AF       LD      B,1         ; 1 
x20B1       IN      A,(#FF)     ; DRQ  INTRQ
            AND     #C0
            JR      Z,x20B1
            RET     M           ;  INTRQ,  
            OUT     (C),D       ; 
            DJNZ    x20B1       ;  
            RET                 ;

; #20BD.  .  #5CDA, #5CD7, #5CE6  #5CE8.

x20BD       LD      HL,#5CD7    ;   
            LD      B,(HL)
            CALL    CHECKON     ;#32EA ;XOR A:(+HL)=(#5CE8)
            LD      E,#FF       ;   0
x20C6       PUSH    BC          ;  
            INC     E           ; 
            LD      A,E
            LD      B,#1B       ;
            CALL    POSIT       ;#3224
            CALL    x1FEB       ;   
            CALL    PRHD0       ;#32F6
            LD      A,(#5CDA)   ;   
            CP      #80         ; 2 ?
            JR      NZ,x20E1    ; , 
            CALL    x1FF6       ;   
            CALL    PRHD1       ;#32F1
x20E1       POP     BC          ;  
            DJNZ    x20C6       ;   ,  
            RET                 ;

; #20E5.     .     #5CB6, #5CF8, #5D0C  #5D18. :  #5D18  #FF,    #5D0C  0,     #FF.    :
;#20F1 ( ,    #5CB6  #5D18).

x20E5       PUSH    AF          ; AF
            LD      A,(#5CF8)   ;  ?
            CP      #FF
            JR      Z,x211C     ; ,  
            POP     AF          ; AF
            CALL    x2970       ; 
x20F1       PUSH    AF          ; AF
            LD      A,(#5CB6)   ; ?
            CP      #F4
            JR      Z,x211C     ; ,  
            XOR     A
            LD      HL,#5D18    ; ?
            OR      (HL)
            LD      (HL),#FF    ;    
            JR      Z,x211C     ;   ,  
            LD      A,(#5D0C)   ; ?
            OR      A
            LD      HL,#5CC3    ;  
            LD      DE,#5D33    ;  
            JR      NZ,x2111    ;  ,      #101
            LD      DE,#5E34    ;
x2111       LD      B,#2D       ;  - #2D 
x2113       LD      C,(HL)      ;  
            LD      A,(DE)
            LD      (HL),A
            LD      A,C
            LD      (DE),A
            INC     HL
            INC     DE
            DJNZ    x2113
x211C       POP     AF          ; AF
            RET                 ;

; #211E.   .

x211E       LD      HL,(#5C59)  ;   
            LD      (HL),#D     ;ENTER
            LD      (#5C5B),HL  ; 
            INC     HL          ; 
            LD      (HL),#80
            RET                 ;

; #212A.   .  #5D20.

x212A       LD      DE,(#5C59)  ;    
            LD      HL,#5D20    ; #5D20
            CALL    x02B0       ; 
            RET                 ;

; #2135.  .  #5D0F     0,   #5D20.

x2135       LD      A,(#5D0F)   ; ?
            OR      A
            PUSH    AF          ;  
            CALL    NZ,x212A    ; ,     

;   !!! COPY     #5D20,      .

            POP     AF          ;  
            CALL    Z,x211E     ;   ,    
            LD      HL,(#5C59)  ;    
            CALL    x3D80       ; 
            LD      A,(#5D19)   ;    
            ADD     A,"A"       ;  
            RST     #10
            LD      A,">"       ; ">"
            RST     #10
            LD      (IY),#FF
            EI
            JP      GETCOM      ;#3B80

; #2158.  . CH_ADD     . ,   1,    #5CD7,   #5CDB    #5CD9.     0.

x2158       CALL    x1E2A       ; 
            CALL    x1D8C
            CP      ","         ; ?
            JP      NZ,x1D1A    ; ,  
            LD      HL,(#5CDB)  ; #5CDB
            LD      (#5CD9),HL
            CALL    x1E0B       ;    
            CALL    x1D75       ;    ,  
            LD      HL,(#5CDB)  ; p 0?
            LD      A,H
            OR      A
            JP      NZ,x1D1A    ; ,  
            INC     HL          ;   ENTER
            LD      (#5CD7),HL  ; 
            LD      HL,(#5CD9)  ; #5CDB
            LD      (#5CDB),HL
            RET                 ;

; #2182.   OPEN#.  #5D11  #5C3B.

x2182       LD      HL,(#5D11)  ; CH_ADD
            LD      (#5C5D),HL
            CALL    x1E0B       ;  
            CALL    x1DD0       ;     
x218E       CALL    x1D8C       ;  
            CP      "A"         ;  "A"?
            JR      NC,x219A    ; ,    
            CALL    x1E2A       ; 
            JR      x218E       ;
x219A       CP      #A5         ; RND?
            PUSH    AF          ;    
            CALL    Z,x2158     ;  RND,    
            POP     AF          ;    
            JR      Z,x21AE     ;  RND,   
            AND     #DF         ; 
            CP      "R"         ; "R"?
            JR      Z,x21AE     ; ,   
            CP      "W"         ; "W"?
            JP      NZ,x1D1A    ; ,  
x21AE       LD      (#5D09),A   ;   
            CALL    x1D75       ;    ,  
            LD      A,"#"       ;  - "#"
            LD      (#5CE5),A
            LD      A,0         ;    0
            LD      (#5CE6),A
            CALL    x21DB       ;   
            PUSH    AF          ;   
            CALL    x220F       ; 
            POP     AF          ;   
            PUSH    AF          ;   
            CALL    NZ,x2288    ;    ,    0
            POP     AF          ;   
            CALL    x2242       ; 
            LD      HL,(#5D11)  ;     
            LD      BC,#124
            ADD     HL,BC
            LD      (#5D11),HL
            JP      x01D3       ;

; #21DB.    . :      ,  #5CDD  #5D09    #5CE6    . :   ,            #5D09       Z;   Z  ,       #5D09.

x21DB       LD      A,#A        ;    #A 
            LD      (#5D06),A
            CALL    x1CB0       ;     
            PUSH    AF          ;  
            CALL    x0405       ;  
            POP     AF          ;  
            JR      NZ,x2206    ;   ,    
            LD      A,(#5D09)   ;   ?
            CP      "R"
            JR      Z,x2201     ; ,  
x21F1       LD      HL,#5CE6    ; 
            INC     (HL)
            CALL    x1CB3       ; 
            JR      Z,x21F1     ;  ,   
            LD      HL,#5CE6
            DEC     (HL)        ;  
            CALL    x1CB3       ;    
x2201       CALL    x165D       ;  
            XOR     A           ;     Z
            RET                 ;
x2206       LD      A,(#5D09)   ;   ?
            CP      "R"
            RET     NZ          ; ,  
            JP      x03D9       ; NO FILE

; #220F.   . :  #5CDB. :  HL     STRMS,    .     #2225 ( ,   #1C4A).

x220F       LD      A,(#5CDB)   ;  
            RST     #20         ;    , 
            DW      #1727       ;  
            LD      A,B         ; ?
            OR      C
            JP      NZ,x221B    ; ,  
            RET                 ;
x221B       LD      A,#19       ;   PARAMETER ERROR

;!!!    INVALID STREAM.

            LD      (#5C3A),A
            LD      HL,x2804    ;  STREAM OPENED
            LD      A,#A        ;  TR-DOS - #A
x2225       JP      x1C4A       ; 

; #2228.   NOT DISC FILE.

x2228       LD      A,#B        ;  - #B
            LD      HL,x2812    ;  NOT DISC FILE
            JR      x2225       ; 

; #222F.     .  #5CD7     .    A #7F.

x222F       PUSH    HL          ; HL
            LD      C,#20       ;  #20-   
            RST     #28
            LD      A,(#5CD7)   ;  
            LD      (HL),A
            INC     HL
            XOR     A
            LD      (HL),A      ;    - 0
            INC     HL
            LD      (HL),A      ;   
            INC     HL
            LD      (HL),A      ; 
            LD      A,#7F       ; 
            POP     HL          ; HL
            RET                 ;

; #2242.           .  #5CDB.

x2242       PUSH    AF          ;   
            CALL    x220F       ;    STRMS,   
            EX      DE,HL       ; 
            LD      HL,(#5C53)  ;   
            LD      BC,(#5C4F)  ; 
            SBC     HL,BC
            EX      DE,HL       ;    STRMS
            LD      (HL),E      ;   
            INC     HL          ;
            LD      (HL),D
            CALL    x22B2       ;  
            LD      A,(#5D09)   ;   
            CP      #A5         ; RND?
            CALL    Z,x222F     ; ,      
            JR      Z,x226B     ;     
            LD      A,(#5D09)   ;   
            CP      "R"         ; R?
            LD      A,#FF       ; ,      -
            JR      NZ,x226B    ;#FF
            XOR     A           ;  0
x226B       LD      (HL),A      ;    
            POP     AF
            JP      x2270
x2270       PUSH    AF
            LD      BC,#14      ;     
            ADD     HL,BC       ;  1
            PUSH    HL          ; 
            CALL    x2423       ;      
            POP     HL          ;     1
            INC     HL
            LD      B,1         ; 1 p
            POP     AF          ;   
            OR      A           ;   ?
            PUSH    AF          ;  
            CALL    NZ,x1E4D    ;    ,   
            POP     AF          ;  
            CALL    Z,x1E3D     ;  ,   
            RET                 ;

; #2288.     .

x2288       LD      HL,(#5CD7)  ; #5CD7
            PUSH    HL
            LD      HL,#2000    ; 0
            LD      (#5CD7),HL
            CALL    x229A       ; 
            POP     HL          ; #5CD7
            LD      (#5CD7),HL
            RET                 ;

; #229A.    .  #5CD7  #5CDB, #5CDD  #5CE5.

x229A       LD      HL,#1000    ;  - #1000 
            LD      (#5CD9),HL
            CALL    x1AC4       ;     
            CALL    x1B59       ; 
            LD      HL,0        ; 0 
            LD      (#5CE8),HL
            CALL    x166B       ;  
            JP      x1E43       ;     

;!!!         ,       0.

; #22B2.      .

x22B2       LD      HL,(#5C53)  ; 
            DEC     HL
            LD      (#5C51),HL
            PUSH    HL          ;   
            LD      BC,#124     ;  - #124 
            CALL    x1E32       ;    
            LD      A,0         ;  
            LD      B,0         ;  - #100 
x22C4       LD      (DE),A      ; 
            DEC     DE          ; 
            DJNZ    x22C4       ;  
            POP     HL          ;   
            PUSH    HL          ;  
            LD      DE,x3D0E    ; p   
            LD      (HL),E
            INC     HL
            LD      (HL),D
            INC     HL
            LD      DE,x3D06    ;    
            LD      (HL),E
            INC     HL
            LD      (HL),D
            INC     HL
            LD      (HL),"D"    ;  - "D"
            INC     HL          ;  
            INC     HL
            INC     HL
            INC     HL
            INC     HL
            LD      (HL),#24    ; #24
            INC     HL
            LD      (HL),1      ; 1
            INC     HL
            LD      A,(#5CF6)   ; 
            LD      (HL),A
            INC     HL
            LD      A,(#5D1E)   ;   
            LD      (HL),A
            INC     HL
            LD      A,(#5D09)   ;   ?
            CP      "R"
            LD      (HL),0      ; ,   0 
            JR      Z,x22FC     ;     
            LD      A,(#5CE8)   ;    
            LD      (HL),A
x22FC       INC     HL
            LD      (HL),B
            JR      Z,x2304
            LD      A,(#5CE9)
            LD      (HL),A
x2304       INC     HL
            EX      DE,HL       ;  #F-   
            POP     HL          ;   
            PUSH    DE
            LD      DE,#10      ; #10-   
            ADD     HL,DE
            EX      DE,HL
            LD      HL,#5CDD    ;  
            LD      BC,#10
            LDIR
            POP     HL          ;  #F-   
            RET                 ;

;p #2317.         .  ,    .       HL.

x2317       LD      C,#D        ; #D-   
            RST     #28
            LD      C,(HL)      ;       
            RST     #28         ;   
            LD      BC,#24      ;   #24-   
            ADD     HL,BC       ;  
            RET                 ;

; #2321.       .  ,    .     #2323 (      ;        C;    HL   ).

x2321       LD      C,#24       ;   #24- 
x2323       LD      B,0         ;    2-  
            LD      HL,(#5C51)  ;    
            ADD     HL,BC       ;  
            RET                 ;

; #232A.       .  ,    .       .    ,   ,    .

x232A       LD      C,#D        ; #D-   
            RST     #28
            INC     (HL)        ; 
            RET     NZ          ;   ,  
            PUSH    HL          ;  #D-   
            CALL    x2443       ; 
            CALL    x23FC       ;  
            POP     HL          ;  #D-   
            INC     HL          ;#E- 
            INC     (HL)        ; 
            PUSH    HL          ;  #E-   
            CALL    x2418       ; 
            POP     HL          ;  #E-   
            LD      A,#10       ;  16 
            CP      (HL)        ; ?
            RET     NZ          ; ,  
            PUSH    HL          ;  #E-   
            LD      C,#F        ;#F- 
            RST     #28
            LD      A,(HL)      ;  ?
            CP      #7F
            POP     HL          ;  #E-   
            JR      Z,x2358     ;   ,     
            LD      HL,(#5C51)  ;   
            CALL    x26E1       ;  
            LD      C,#E        ;#E- 
            RST     #28
            JP      x2379       ;   
x2358       CALL    x23CF       ;   
            PUSH    AF          ;  
            CALL    Z,x2418     ;  ,     
            LD      C,#E        ;#E- 
            RST     #28
            POP     AF          ;   
            CALL    NZ,x2370    ;    ,   
            RET                 ;

; #2367.   D  #20,  E -  #19-        ,   HL.   .

x2367       LD      (HL),0      ; 
            LD      C,#19       ;  #19-   
            RST     #28
            LD      D,#20       ;   D  #20
            LD      E,(HL)      ;  E   #20-   
            RET                 ;

; #2370.    .  ,    .

x2370       CALL    x2367       ;   
            LD      (#5CD7),DE  ; 
            JR      x2381       ;  

; #2379. C   .  ,    , , ,   #2381 (   ;  #5CD7  #5CDB, #5CDD  #5CE5).

x2379       CALL    x2367       ;   
            INC     E           ; 
            LD      (#5CD7),DE  ;  
x2381       CALL    x229A       ; 
            CALL    x2970       ; 

;!!!    CAT#  LIST#,  p  .

            LD      C,#10       ;  #10-   
            RST     #28
            EX      DE,HL       ;   DE
            LD      HL,#5CDD    ;     
            LD      BC,#10
            LDIR
            LD      C,#C        ;#C- 
            RST     #28
            LD      A,(#5D1E)   ;    
            LD      (HL),A
            RET                 ;

; #239B.        .  ,    .

x239B       LD      C,#D        ; #10-   
            RST     #28
            INC     (HL)        ;  
            RET     NZ          ;   ,  
            INC     HL          ;#11- 
            INC     (HL)        ; 
            PUSH    HL          ;  #11-   
            CALL    x2443       ; 
            LD      C,#23       ;#23- 
            RST     #28
            LD      A,(HL)      ; 0?
            OR      A
            JR      Z,x23B6     ; ,    
            POP     HL          ;  #11-   
            PUSH    HL          ;   
            DEC     (HL)        ;   
            CALL    x23FC       ; 
            POP     HL          ;  #11-   
            PUSH    HL          ;   
            INC     (HL)        ; 
x23B6       CALL    x2418       ; 
            POP     HL          ;  #11-   
            LD      A,#10       ;  16 
            CP      (HL)        ; ?
            CALL    Z,x23C1     ; ,   
            RET                 ;

; #23C1.     .  ,    ,   HL  #E-      #5D06.

x23C1       CALL    x23CF       ;    
            PUSH    AF          ;  
            CALL    x2970       ; 

;!!! H  #5D16,      CAT#,  LIST#,    .

            POP     AF          ;   
            JP      NZ,x2492    ;   ,  END OF FILE
            JP      x2418       ;   

; #23CF.     .  ,    ,   HL p #E-      #5D06.   ,   Z  ,  .

x23CF       LD      (HL),0      ;   - 0
            LD      C,#19       ;#19-   
            RST     #28
            INC     (HL)        ; 
            LD      C,#10       ;#10- 
            RST     #28
            LD      DE,#5CDD    ;  
            LD      BC,#10
            LDIR
            CALL    x1CB3       ; 

;!!!       ,    ,        0.

            RET     NZ          ;   ,  

; #23E4.  .       A.

x23E4       CALL    x165D       ;  

;!!!       ,    ,        0.

            LD      C,#10       ;  #10-   
            RST     #28
            EX      DE,HL       ;   DE
            LD      HL,#5CDD    ;     
            LD      BC,#10
            LDIR
            LD      C,#C        ;#C- 
            RST     #28
            LD      A,(#5D1E)   ;    
            LD      (HL),A
            XOR     A           ; 
            RET                 ;

; #23FC.     .  ,   .

x23FC       CALL    x2423       ;      
            CALL    x2321       ;       
            LD      B,1         ; 1 
            CALL    x1E4D       ; 

;!!!       ,    ,        0.

            LD      C,#F        ;#F-   
            RST     #28
            LD      A,(HL)      ;  ?
            CP      #7F
            RET     Z           ; ,  
            CALL    x2321       ;       
            XOR     A           ;  
            LD      B,A         ;  - #100 
x2413       LD      (HL),A      ; 
            INC     HL          ; 
            DJNZ    x2413       ;  
            RET                 ;

; #2418.      .  ,    .

x2418       CALL    x2423       ;     
            CALL    x2321       ;     
            LD      B,1         ; 1 
            JP      x1E3D       ;   

;!!!       ,    ,       0.

; #2423.       .  ,    .    DE     .

x2423       LD      HL,(#5C51)  ;  #1E-   
            LD      BC,#1E
            ADD     HL,BC
            LD      E,(HL)      ;    
            INC     HL
            LD      D,(HL)
            LD      C,#E        ;#E- 
            RST     #28
            LD      B,(HL)      ;    
            DEC     B           ;  0?
            INC     B
            PUSH    AF          ; AF
            LD      A,#10       ;  #10 
            JR      Z,x2441     ;     p 0,  
x2438       INC     E           ; 
            CP      E           ; ?
            JR      NZ,x243F    ; , 
            LD      E,0         ; 0
            INC     D           ;  
x243F       DJNZ    x2438       ;  
x2441       POP     AF          ; AF
            RET                 ;

; #2443.       .  ,   .

x2443       LD      C,#B        ;  #B-   
            RST     #28
            LD      A,(HL)      ;  ,    
            JP      x3DCB       ; 

; #244A.     .       ,   .

x244A       LD      HL,#5CC2    ;    
            PUSH    HL          ;   
            LD      HL,x20F1    ;   
            PUSH    HL          ;   
            PUSH    AF          ; 
            CALL    x20F1       ; 
            LD      A,#A        ;   #A  
            LD      (#5D06),A
            POP     AF          ; 
            CALL    x24A2       ;    
            PUSH    AF          ; 
            CALL    x2650       ;   ?
            JP      Z,x249E     ; ,  
            POP     AF          ; 
            CALL    x2317       ;      
            LD      (HL),A      ; 
            JP      x232A       ;      

; #246E.    .    :
;#2492 -   END OF FILE   .
;#2494 -     .     .

x246E       LD      C,#D        ;  #D-   
            RST     #28
            LD      A,(HL)      ;      
            LD      BC,#E       ;#1B- 
            ADD     HL,BC
            CP      (HL)        ;        
            RET     NZ          ;   ,  
            LD      C,#E        ;   
            RST     #28
            LD      A,(HL)
            LD      BC,#E
            ADD     HL,BC
            CP      (HL)
            RET     NZ
            LD      HL,#5CB6    ;  p  
            LD      A,(HL)      ;  
            CP      #F4         ;-1 ?
            JR      Z,x2492     ; ,  
            BIT     4,(HL)      ;  LOAD -1?
            JR      Z,x2492     ; ,  
            OR      1           ;  C
            POP     HL          ;    
            RET                 ;   
x2492       LD      A,7         ;  END OF FILE
x2494       LD      (#5C3A),A   ;  
            CALL    x20E5       ; 
            RST     #20         ; 
            DW      #0058

; #249D.  RET.

x249D       RET

; #249E.   INVALID I/O DEVICE   .

x249E       LD      A,#17       ;  - #17
            JR      x2494       ;  p  

; #24A2.     .     A   ,    .        ,    ,     ,   .

x24A2       LD      D,A         ; 
            LD      C,#F        ;  #D-   
            RST     #28
            LD      A,(HL)      ;  ?
            CP      #7F
            LD      A,D         ; 
            RET     NZ          ;   ,  
            LD      BC,#13      ;#22- 
            ADD     HL,BC
            LD      A,(HL)      ;  ?
            OR      A
            LD      A,D         ; 
            JR      NZ,x24D5    ;   ,   
            DEC     HL          ;#21- 
            LD      A,(HL)      ; 0?
            OR      A
            JR      NZ,x24C2    ; ,     
            PUSH    BC          ;  #13,
            PUSH    HL          ; #21-    
            PUSH    DE          ;
            CALL    x24F8       ; #10    
            POP     DE          ; ,
            POP     HL          ; #21-    
            POP     BC          ; #13
x24C2       LD      C,(HL)      ;   
            LD      A,D         ; 
            EX      DE,HL
            LD      HL,(#5CCF)  ;   
            ADD     HL,BC       ;   
            CP      6           ; CHR$ 6?
            LD      (HL),A      ;    
            CALL    Z,x2504     ;  CHR$ 6,    
            LD      C,#21       ;#21- 
            RST     #28
            INC     (HL)        ; 1 
            POP     HL          ;    
            RET                 ;   
x24D5       DEC     HL          ;#21- 
            LD      A,(HL)      ;   
            DEC     HL          ;#20- 
            INC     A           ;   ENTER
            CP      (HL)        ; ?
            INC     HL          ;#21- 
            INC     (HL)        ; 1 
            PUSH    HL          ;  #21-  
            PUSH    AF          ;       
            LD      C,#23       ;#23- 
            RST     #28
            LD      (HL),#FF    ; 
            POP     AF          ;    
            POP     HL          ;    #21-   
            JR      C,x24EE     ;    ,   
            LD      A,D         ; 
            CP      #D          ; ENTER?
            JR      Z,x24F2     ; ,   
            POP     BC          ;    
            RET                 ;   
x24EE       LD      A,D         ; 
            CP      #D          ; ENTER?
            RET     NZ          ; ,  
x24F2       XOR     A           ;   - 0
            LD      (HL),A
            INC     HL          ;#22- 
            LD      (HL),A      ;   
            LD      A,D         ; 
            RET                 ;

; #24F8.  #10     .  #5CCF.

x24F8       LD      HL,(#5C61)  ;    
            LD      (#5CCF),HL  ; 
            LD      BC,#10      ; #10 
            JP      x1E23       ;   

;p #2504.   .              #5CCF,   HL        1.

x2504       LD      (HL),#D     ; 
            LD      HL,(#5C5D)  ; CH_ADD
            LD      (#5CD7),HL
            LD      HL,(#5CCF)  ; CH_ADD   
            LD      (#5C5D),HL
            LD      HL,#5C3B    ;  
            RES     7,(HL)
            CALL    x1DC1       ;   5- 
            LD      HL,#5C3B    ;
            SET     7,(HL)
            LD      HL,(#5CCF)  ; CH_ADD   
            LD      (#5C5D),HL
            CALL    x1DC1       ;    
            CALL    x1DB9       ;  
            PUSH    BC          ;   DE
            POP     DE
            LD      C,#20       ;  #D-   
            RST     #28
            LD      B,(HL)      ;  
            XOR     A
            LD      HL,0        ;    
            LD      (#5CDB),HL  ;,     
x2538       ADD     HL,DE       ;,  ,   p
            JR      NC,x2544
            PUSH    HL
            LD      HL,(#5CDB)
            INC     HL
            LD      (#5CDB),HL
            POP     HL
x2544       DJNZ    x2538
            LD      (#5CD9),HL
            LD      A,(#5CDB)   ;   16 
            LD      HL,#5CDA
            RRD
            AND     #F
            LD      (#5CDB),A
            LD      HL,(#5CD7)  ; CH_ADD
            LD      (#5C5D),HL
            CALL    x2568       ; 
            LD      C,#21       ;#21- 
            RST     #28
            LD      A,#FF       ;     0
            LD      (HL),A
            INC     HL          ;#22- 
            LD      (HL),A      ;  
            RET                 ;

; #2568.  .  #5CD7, #5CD9  #5CDB.

x2568       LD      C,#19       ;  #19-   
            RST     #28
            LD      A,(#5CDA)   ;   
            CP      (HL)        ;  ?
            JP      NZ,x2584    ; ,   
            LD      C,#E        ;#E- 
            RST     #28
            LD      A,(#5CDB)   ;     
            CP      (HL)        ;  ?
            JP      NZ,x25A7    ; ,   
x257C       LD      C,#D        ;#D- 
            RST     #28
            LD      A,(#5CD9)   ;    
            LD      (HL),A      ; 
            RET                 ;
x2584       CALL    x25CA       ;   #23- 
            CALL    NZ,x25C3    ; ,   
            LD      A,(#5CDA)   ;   
            LD      C,#19       ;#19- 
            RST     #28
            LD      (HL),A      ;  
            LD      C,#10       ;#10- 
            RST     #28
            LD      DE,#5CDD    ;  
            LD      BC,#10
            LDIR
            CALL    x1CB3       ; 

;!!!         ,        0.

            JP      NZ,x25D2    ;   ,   
            CALL    x23E4       ; 
            JR      x25AD       ;   
x25A7       CALL    x25CA       ;   #23- 
            CALL    NZ,x25C3    ; ,   
x25AD       LD      A,(#5CDB)   ;   
            LD      C,#E        ;#E- 
            RST     #28
            LD      (HL),A      ;  
            PUSH    HL          ;  #E- 
            CALL    x2443       ; 
            CALL    x2418       ; 
            POP     HL          ;  #E- 
            DEC     HL          ;#D- 
            LD      A,(#5CD9)   ;   
            LD      (HL),A      ;
            JR      x257C       ;

; #25C3.   .    .

x25C3       CALL    x2443       ; 
            CALL    x23FC       ; 
            RET                 ;

; #25CA.    #23-   .      Z,      .   .

x25CA       LD      C,#23       ;  #23-   
            RST     #28
            LD      A,(HL)      ;  
            OR      A           ; 
            LD      (HL),0      ; 
            RET                 ;

; #25D2.    .  #5CD7, #5CD9  #5CDB.

x25D2       LD      HL,(#5CDA)  ;  
            LD      H,#20
            LD      (#5CD7),HL  ; 
            LD      HL,(#5CD9)  ;   
            PUSH    HL          ;
            LD      HL,(#5CDB)  ;  
            PUSH    HL
            CALL    x2381       ; 
            POP     HL          ;  
            LD      (#5CDB),HL
            POP     HL          ;    
            LD      (#5CD9),HL
            JR      x25AD       ;   

; #25EF.    .  ,    .            ,       A.

x25EF       CALL    x20F1       ; 
            LD      HL,#5C3C    ;p  
            RES     3,(HL)
            LD      HL,(#5C3D)  ;    
            LD      E,(HL)
            INC     HL
            LD      D,(HL)
            OR      A           ; p #107F?
            LD      HL,#107F
            SBC     HL,DE
            JR      NZ,x2626    ; ,      
            LD      SP,(#5C3D)  ;  
            POP     DE          ;    
            POP     DE          ;   
            LD      (#5C3D),DE  ; 
x260F       CALL    x262B       ;   
            JR      C,x261D     ;   ,      
x2614       LD      HL,#5CC2    ;    
            PUSH    HL          ;   
            LD      HL,x20E5    ;      
            PUSH    HL          ;   
            RET                 ;   
x261D       CP      #D          ; ENTER?
            JR      Z,x2614     ; ,  
            RST     #20         ;    
            DW      #0F85
            JR      x260F       ;
x2626       CALL    x262B       ;   
            JR      x2614       ;

; #262B.     .      .  ,    .

x262B       LD      A,#A        ;   10  
            LD      (#5D06),A
            CALL    x2650       ;   ?
            JR      Z,x2642     ; , 
            CP      #7F         ;  ?
            JP      NZ,x249E    ; ,  
            LD      BC,#13      ;  #22-   
            ADD     HL,BC
            LD      (HL),0      ;     
            JR      x2645
x2642       CALL    x246E
x2645       CALL    x2317       ;   
            LD      A,(HL)      ;  
            PUSH    AF          ; 
            CALL    x239B       ;   
            POP     AF          ; 
            SCF                 ;  
            RET                 ;

; #2650.  #F-    .      Z,       A.

x2650       LD      C,#F        ;  #F-   
            RST     #28
            LD      A,(HL)      ;  
            OR      A           ;   0
            RET                 ;

; #2656.   CLOSE#.  #5D11  #5C3B.

x2656       LD      HL,(#5D11)  ; CH_ADD
            LD      (#5C5D),HL
            CALL    x1E0B       ;  
            CALL    x1D75       ;    ,  
            LD      A,(#5CDB)   ;  
            RST     #20         ;    
            DW      #1727
            LD      A,B         ; ?
            OR      C
            JP      Z,x01D3     ; ,  
            PUSH    HL          ;   STRMS
            LD      HL,(#5C4F)  ;    
            ADD     HL,BC       ;     
            LD      A,(HL)      ;     
            LD      HL,x3D0E    ;  #3D?
            CP      H
            POP     HL          ;   STRMS
            JP      NZ,x2228    ;        #3D,   NOT DISC FILE  !!!      !
            LD      (HL),0      ; 
            INC     HL
            LD      (HL),0
            LD      (#5CD9),BC  ;    
            LD      HL,(#5C4F)  ;   
            ADD     HL,BC
            DEC     HL
            LD      (#5CD7),HL  ; 
            CALL    x26CE       ;  ,  
            LD      HL,(#5CD7)  ;   
            LD      BC,#124     ;  - #124 
            CALL    x1E2E       ;   
            LD      HL,#5C10    ;   STRMS
            LD      B,#10       ; 16 
x269D       PUSH    BC          ;  
            LD      BC,(#5CD9)  ;    
            LD      E,(HL)      ;   
            INC     HL
            LD      D,(HL)
            EX      DE,HL       ;   HL
            SBC     HL,BC       ;   ?
            EX      DE,HL       ;   DE
            JR      C,x26BC     ;    ,   
            LD      D,(HL)      ;    
            DEC     HL
            LD      E,(HL)
            INC     HL
            PUSH    HL          ;    
            EX      DE,HL       ;     HL
            LD      BC,#124     ; 
            SBC     HL,BC
            EX      DE,HL       ;   DE
            POP     HL          ;    
            LD      (HL),D      ;  
            DEC     HL
            LD      (HL),E
            INC     HL
x26BC       INC     HL          ; 
            POP     BC          ;  
            DJNZ    x269D       ;  
            LD      HL,(#5D11)  ;   
            LD      BC,#124
            SBC     HL,BC
            LD      (#5D11),HL
            JP      x01D3       ;

; #26CE.     .    ,   .   HL  #5CD7   .

x26CE       LD      BC,#F       ;  #F-   
            ADD     HL,BC
            LD      A,(HL)      ;   ?
            OR      A
            RET     Z           ; ,  
            LD      HL,(#5CD7)  ; 
            LD      (#5C51),HL
            CALL    x26E1       ;  
            JP      x23FC       ;    

;p #26E1.      .  ,        HL   .

x26E1       LD      BC,#D       ;  #D-   
            ADD     HL,BC
            LD      E,(HL)      ;    
            INC     HL
            LD      D,(HL)
            LD      BC,#D       ;  #1A-   
            ADD     HL,BC
            LD      (HL),E      ;    
            INC     HL
            LD      (HL),D
            LD      C,#10       ;#10- 
            RST     #28
            LD      DE,#5CDD    ;  
            LD      BC,#10
            LDIR
            CALL    x2443       ; 
            LD      C,#C        ;#C- 
            RST     #28
            LD      C,(HL)      ;    
            CALL    x166B       ;  
            JP      x1E43       ;     

;!!!       ,    ,        0.

; #2707.  .  HL   .      CHR$ 0,     .

x2707       LD      A,(HL)      ;   
            OR      A           ; CHR$ 0?
            RET     Z           ; ,  
            AND     #7F         ;  7
            RST     #10         ; 
            BIT     7,(HL)      ; 7 ?
            RET     NZ          ; ,  
            INC     HL          ;   
            JR      x2707       ;

; #2713.   .  HL  DE    ,   B -  .    Z ,  .

x2713       LD      A,(DE)      ;   
            CP      (HL)
            RET     NZ          ;   ,  
            INC     DE          ; 
            INC     HL
            DJNZ    x2713       ;  
            RET                 ;

; #271B.   NO DISC   TAPE LOADING ERROR.

x271B       LD      HL,x27FC    ;  NO DISC
            LD      A,6         ;  - 6
            JP      x1C4A       ; 

; #2723.   DIRECTORY FULL.

x2723       LD      HL,x27ED    ;  DIRECTORY FULL
            LD      A,4         ;  - 4
            JP      x1C4A       ; 

; #272B.    TAPE LOADING ERROR   .

x272B       LD      A,#1A       ;  TAPE LOADING ERROR
            JR      x2731       ;  

; #272F.    INVALID I/O DEVICE   .    :
;#2731 (     ;     A).

x272F       LD      A,#12       ;  INVALID I/O DEVICE
x2731       LD      (#5C3A),A   ;  
            RET                 ;

; #2735.    OUT OF MEMORY   .

x2735       LD      A,3         ;  OUT IF RAM
            JR      x2731       ;  

; #2739.  .   D    .    #5CD6      .

x2739       XOR     A           ; 
            LD      (#5CD8),A
            LD      (#5CD6),A   ;    
            IN      A,(#1F)     ;   
            LD      (#5CCD),A
            LD      E,D         ;    E
            PUSH    DE          ;  
            LD      A,E         ;     
            OUT     (#7F),A
            LD      A,#18       ;
            CALL    x3D9A
            LD      A,(#5CCD)   ;    
            AND     #80         ;  ?
            CALL    NZ,x3EA0    ; ,    3135098 
            POP     DE          ;  
            CALL    x207D       ;.., (#5CD8)=0
            LD      A,(#5CD6)   ;  ?
            OR      A
            RET     Z           ; ,  
            LD      A,7         ; 
            LD      (#5D0F),A
            RET                 ;

; #2766.  TR-DOS.

x2766       DB      "O.K."
            DB      0
x276B       DB      "Verify Error."
            DB      #8D
x2779       DB      "BACKUP DISK"
            DB      #8D
x2785       DB      "Insert Destination disk"
            DB      #D
            DB      "then press Y"
            DB      0
x27AA       DB      "Insert Source disk then press Y"
            DB      0
x27CA       DB      "*BREAK*"
            DB      #8D
x27D2       DB      "Out of RAM"
            DB      #8D
x27DD       DB      "Array not found"
            DB      #8D
x27ED       DB      "Directory full"
            DB      #8D
x27FC       DB      "No disk"
            DB      #8D
x2804       DB      "Stream opened"
            DB      #8D
x2812       DB      "Not disk file"
            DB      #8D
x2820       DB      "File exists"
            DB      #D
            DB      "Over write?(Y/N"

x283B       XOR     C

; #283C.   TR-DOS   . :   C  ,   .     BC  .

x283C       PUSH    AF          ; 
            PUSH    BC
            LD      (#5D04),DE
            LD      (#5D02),HL
            CALL    x20F1       ; ,   
            LD      A,#FF
            LD      (#5D15),A   ;  
            LD      (#5D1F),A   ;    
            POP     BC          ; BC  AF
            POP     AF
            LD      HL,#201     ;      
            LD      (#5D1A),HL  ;
            LD      HL,0        ; SP
            ADD     HL,SP
            LD      (#5D1C),HL
            DEC     HL          ;     
            DEC     HL          ;   
            LD      SP,HL
            PUSH    AF          ; AF
            CALL    x021D       ;      
            LD      HL,x288C    ;    
x2869       LD      A,(HL)      ;  
            CP      C           ;   ?
            JR      NZ,x287F    ; ,     
            POP     AF          ; AF
            INC     HL          ; ,     
            LD      E,(HL)      ;  
            INC     HL
            LD      D,(HL)
            LD      HL,x01D3    ;   
            PUSH    HL          ;   
            PUSH    DE          ;    
            LD      HL,(#5D02)  ; HL  DE
            LD      DE,(#5D04)
            RET                 ;  
x287F       CP      #FF         ;  ?
            JR      NZ,x2887    ; ,      
            POP     AF          ; AF   (    )
            JP      x01D3       ;   
x2887       INC     HL          ;    
            INC     HL
            INC     HL
            JR      x2869       ;

x288C       DB      0           ;    
            DW      x3D98
            DB      1
            DW      x3DCB
            DB      2
            DW      x3E63
            DB      3
            DW      x3F02
            DB      4
            DW      x3F06
            DB      5
            DW      x1E3D
            DB      6
            DW      x1E4D
            DB      7
            DW      x28D8
            DB      8
            DW      x165C
            DB      9
            DW      x1664
            DB      #A
            DW      x1CF0
            DB      #B
            DW      x28FB
            DB      #C
            DW      x28F2
            DB      #D
            DW      OUTDE       ;#3C10 ;OUT (D),E
            DB      #E
            DW      x290F
            DB      #F
            DW      INED        ;#3C14 ;IN E,(D)
            DB      #10
            DW      JPWRITE     ;#3C18 ;C=#7F:16314(WRITE)
            DB      #11
            DW      JPREAD      ;#3C1D ;C=#7F:16341(READ)
            DB      #12
            DW      x2926
            DB      #13
            DW      x28E0
            DB      #14
            DW      x28E3
            DB      #15
            DW      x2739
            DB      #16
            DW      x1FEB
            DB      #17
            DW      x1FF6
            DB      #18
            DW      x0405
            DB      #FF         ;  

; #28D8.     .    A   ,     .

x28D8       PUSH    AF          ;  
            CALL    x0405       ;  
            POP     AF          ;  
            JP      x0479       ; 

; #28E0.       #5CDD.  HL      .

x28E0       XOR     A           ;  (HL)  #5CDD
            JR      x28E5       ; 

; #28E3.     #5CDD    ,   HL.     #28E5 (  ,  HL -    ,  A -  : 0 -  ,  -  ).

x28E3       LD      A,#FF       ;  
x28E5       LD      DE,#5CDD    ;    LDIR
            LD      BC,#10      ;  
            OR      A           ;  
            JR      Z,x28EF
            EX      DE,HL
x28EF       LDIR                ;  
            RET                 ;

; #28F2.    .  #5CD1, #5CDD  #5CE5.

x28F2       CALL    x0405       ;  
            CALL    x1AC4       ;    
            JP      x1B27       ; 

; #28FB.  .      #5CDD,   DE,   HL.

x28FB       LD      (#5CD7),HL  ; 
            LD      (#5CD9),DE  ;   
            LD      (#5CDB),DE  ;    
            JP      SVNASTRDSK  ;#33E6
            CALL    x1AC4       ;     
            JP      SAVEFIL       ; 

; #290F. /    /  .  #5CDD, #5CE5, #5CD7 (  / )  #5CF9;  A       #E  HL  DE -    (   ).

x290F       OR      A
            LD      (#5CD6),A   ;  
            LD      (#5CD9),HL  ;  
            LD      (#5CDB),DE  ;  
            CALL    x1CB3       ; 
            CALL    x18A4       ;  ,    
            CALL    x18AB       ;  
            JP      x1921       ; 

; #2926.  .  #5CDD  #5CE5.     #5D07  #5D08.

x2926       CALL    x0405       ;  
            CALL    x1CB3       ; 
            JP      x07A0       ; 

; #292F.   .        #5D06.   ,   . C   #5D1E     Z,   Z  ,   C  #FF.

x292F       CALL    x1C57       ;  
            CALL    x0405       ;  
            JP      x1CB3       ;   

; #2938.     .  HL     .

x2938       PUSH    BC          ; BC
            LD      B,8         ;   8 
x293B       LD      A,(HL)      ;    
            RST     #10         ; 
            INC     HL          ;  
            DJNZ    x293B       ;  
            LD      A,"<"       ; "<"
            RST     #10
            LD      A,(HL)      ; 
            RST     #10
            LD      A,">"       ; ">"
            RST     #10
            POP     BC          ; BC
            RET                 ;

; #294A.  ,   .  #5D0C.

x294A       PUSH    HL          ; 
            PUSH    DE
            PUSH    BC
            PUSH    AF
            LD      HL,#5D0C    ; ?
            LD      A,(HL)
            OR      A
            JR      Z,x2992     ; ,     
            PUSH    HL          ;    
            LD      BC,#101     ; 
            PUSH    BC          ; 
            CALL    x19FD       ;   
            POP     BC          ;  
            POP     HL          ;   
            LD      (HL),0      ; 
            LD      HL,#5D25    ; 
            CALL    x1E32       ; 
            LD      HL,(#5D11)  ;    #101 
            LD      BC,#101
            ADD     HL,BC
            JR      x298F       ;      

; #2970.  ,   .  #5D0C.     #298F  #2992  #294A.

x2970       PUSH    HL          ; 
            PUSH    DE
            PUSH    BC
            PUSH    AF
            LD      HL,#5D0C    ; ?
            LD      A,(HL)
            OR      A
            JR      NZ,x2992    ; ,  
            LD      (HL),#FF    ; 
            LD      HL,#5D25    ; 
            LD      BC,#101     ; 
            CALL    x1E2E       ;  
            OR      A           ;    #101 
            LD      BC,#101     ;   
            LD      HL,(#5D11)
            SBC     HL,BC
x298F       LD      (#5D11),HL
x2992       POP     AF          ; 
            POP     BC
            POP     DE
            POP     HL
            RET                 ;

; #2997.   "40".  #5D11  #5C3B.    :
;#2998 (    ;    #2997   A  ).

x2997       XOR     A           ; 40- 

;!!! -,   ?; -,        .

x2998       LD      (#5CD7),A   ;  
            CALL    x1D75       ;    ,  
            CALL    x042B       ;   
            JP      Z,x1D1A     ;  ENTER,  *ERROR*
            CALL    x3E11       ;     
            LD      A,(#5CD7)   ;  
            LD      (HL),A
            JP      x03E1       ; O.K.

; #29AE.   "80".  #5D11  #5C3B.

x29AE       LD      A,#80       ; 80- 

;!!! -,   ?; -,        .

            JR      x2998       ; 

; #29B2.   TR-DOS.

x29B2       DB      #D
            DB      "*ERROR*"
            DB      #8D
x29BB       DB      #D
            DB      "No space"
            DB      #8D
x29C5       DB      #D
            DB      "File exists"
            DB      #8D
x29D2       DB      " Free"
            DB      #8D
x29D8       DB      #D
            DB      "Read Onl"
            DB      #F9
x29E2       DB      #D
            DB      "Disk Erro"
            DB      #F2
x29ED       DB      #D
            DB      "Rec.  O/"
            DB      #C6
x29F7       DB      "Title:"
            DB      #A0
x29FE       DB      #D
            DB      "Retry,Abort,Ignore?"
            DB      0
x2A13       DB      #D
            DB      "Trk"
            DB      #A0
x2A18       DB      " sec"
            DB      #A0
x2A1D       DB      " Del. File"
            DB      #8D
x2A28       DB      #D
            DB      "No"
x2A2B       DB      " File(s)"
            DB      #8D,#00

; #2A35.        #4080.

x2A35       LD      HL,x2A41    ;    
            LD      DE,#4080    ;   
            LD      BC,#20      ;  - #20 
            LDIR                ; 
            RET                 ;

; #2A41.    .  #5C01    48- .          .     :
;#2A53      .

x2A41       LD      A,(#3B5)    ;   
            CP      #F3         ; #F3?
            LD      A,#10       ; ,    48- 
            JR      Z,x2A4B
            XOR     A           ;   128- 
x2A4B       LD      (#5C01),A   ;  
            LD      BC,#7FFD    ;   
            LD      A,#10       ; 48- 
x2A53       OUT     (C),A       ; 
            RET                 ;

; #2A56.    .

x2A56       JP      MAGICER     ;#A1A
x2A59       PUSH    HL
            PUSH    IX
            PUSH    IY
            EXX
            PUSH    BC
            PUSH    DE
            PUSH    HL
            EX      AF,AF'
            PUSH    AF
            LD      A,I
            PUSH    AF
            LD      A,R
            PUSH    AF
            LD      HL,0
            ADD     HL,SP       ; SP
            PUSH    HL
            CALL    MAGSTOPDISK ;#A01 ;  OUT (#1F),#D0
            NOP
            LD      A,#3F       ;  I
            LD      I,A
            IN      A,(#1F)     ;  
            AND     #80
            RRCA
            RRCA
            RRCA
            LD      (#5C01),A   ; 

;!!!   .

            CALL    x2F65       ;
            CALL    x3EA0       ;  3135098 
            CALL    x3EA0       ; 
            LD      DE,#A       ; #A
            LD      HL,#4000    ;   #4000
            PUSH    HL          ;  #4000
            CALL    x2D73       ; 
            LD      HL,#4100    ;   #4100
            LD      DE,#B       ; #B
            CALL    x2D73       ; 
            POP     HL          ;  #4000
            PUSH    HL          ;  
            LD      DE,8        ; 8
            CALL    x2F1B       ; 
            LD      HL,#40E3    ;  
            LD      A,(HL)
            LD      (#5C00),A   ; 

;!!!   .

            INC     HL          ;    
            LD      A,(HL)
            INC     (HL)        ;  1 

;!!!        .

            INC     HL          ;     
            LD      E,(HL)
            INC     HL
            LD      D,(HL)
            OR      A           ;  C
            EX      DE,HL
            LD      DE,#C0      ;      #C0
            SBC     HL,DE       ;
            LD      (#40E5),HL  ;      
            LD      HL,#4000    ;   #4000
            LD      DE,8        ; 8
            CALL    x2D73       ; 
            POP     HL          ;  #4000
            LD      DE,(#40E1)  ;     
            PUSH    DE          ; 
            LD      DE,#A       ; #A
            CALL    x2F1B       ; 
            POP     DE          ;     
            CALL    x2D4C       ; 
            PUSH    DE          ;      
            LD      A,#3C       ;  A    
            OUT     (#FF),A
            CALL    x2F65       ;
            LD      HL,#4000    ;   #4000
            LD      DE,8        ; 8
            LD      B,1
            CALL    x2F1B       ; 
            POP     DE          ;      
            LD      HL,(#40E1)  ;      
            LD      (#40E1),DE  ;  
            PUSH    HL          ;  
            LD      HL,#4000    ;   #4000
            LD      DE,8        ; 8
            LD      B,1
            CALL    x2D73       ; 
            LD      A,(#40E4)   ;   
            DEC     A
            CALL    x2CE5       ;    
            LD      (HL),"@"    ;  - "@"
            INC     HL
            LD      B,7         ;7 
x2B09       LD      (HL)," "
            INC     HL
            DJNZ    x2B09
            LD      (HL),"C"    ;  - "C"
            POP     DE          ;      
            POP     BC          ;  SP   
            INC     HL          ;  SP  
            LD      (HL),C      ;    
            INC     HL
            LD      (HL),B
            INC     HL          ;   
            INC     HL
            INC     HL
            LD      (HL),#C0    ;  - #C0 
            INC     HL
            LD      (HL),E      ;    
            INC     HL
            LD      (HL),D
            LD      HL,#4000    ;   #4000
            LD      DE,0
            IN      A,(#5F)     ;  ,   
            DEC     A           ; 
            LD      E,A
            LD      B,1
            CALL    x2D73       ; 
            LD      HL,0        ; SP
            ADD     HL,SP
            LD      (#4140),HL
            LD      SP,#41FF    ;   
            CALL    x2A35       ;      
            LD      HL,#C000    ;  
            XOR     A           ;    
x2B3F       ADD     A,(HL)      ;    
            INC     HL          ;  
            LD      B,A         ;  
            LD      A,H         ;      
            OR      A           ; 0?
            LD      A,B         ;  
            JR      NZ,x2B3F    ; ,  
            LD      HL,#4100    ;   
            LD      (HL),A      ;
            PUSH    HL          ;  
            LD      HL,x2B58    ;  - #2B58
            PUSH    HL          ;   
            LD      HL,x3D2F    ;    TR-DOS
            PUSH    HL          ;   
            DI                  ; 
            JP      #4080       ;  
x2B58       POP     HL          ;     
            LD      BC,#7FFD    ;   
            LD      A,#AA       ; 
            LD      (#4130),A   ;   
            LD      D,5         ;  5
            LD      A,(#5C01)   ; 
            OR      D
            LD      D,A
            OUT     (C),D       ;  
            LD      A,(#C130)   ;   
            CP      #AA         ; #AA?
            JP      NZ,x2C1B    ; ,  
            LD      A,D         ; 0
            AND     #F8
            LD      D,A
            INC     HL          ;      
x2B77       LD      (HL),D      ; 
            OUT     (C),D       ; 
            XOR     A           ;    
            LD      HL,#C000    ;  
x2B7E       ADD     A,(HL)      ;    
            INC     HL          ;  
            LD      E,A         ;  
            LD      A,H         ;      
            OR      A           ; 0?
            LD      A,E         ;  
            JR      NZ,x2B7E    ; ,  
            LD      HL,#4100    ;      
            CP      (HL)        ; ?
            INC     HL          ;      
            JR      Z,x2B93     ; ,  
            INC     D           ;  
            BIT     3,D
            JR      Z,x2B77
            DEC     D           ;    
x2B93       LD      B,8         ; 8 
x2B95       PUSH    BC          ;  
            CALL    x2C37       ; 
            POP     BC          ;  
            DJNZ    x2B95       ;  
            LD      C,0         ; 0
            CALL    x2F3A       ;
            CALL    x2D2A       ;  8   #4000
            LD      A,(#40E4)   ;    
            LD      (#4102),A   ; 
            INC     A           ;  1 
            LD      (#40E4),A   ;   
            LD      HL,(#40E5)  ;     
            LD      DE,1        ;   1 
            SBC     HL,DE
            LD      (#40E5),HL  ;      
            RET     C           ;    ,  

;!!!  ?        R  F.

            LD      HL,(#40E1)  ;     
            LD      (#411E),HL  ; 
            CALL    x2D1E       ;  
            LD      A,"8"       ; 
            LD      (#4111),A
            LD      A,1         ;  - 1 
            LD      (#411D),A
            LD      HL,#4100    ;  - #4100
            LD      (#4119),HL
            LD      HL,#100     ; - #100 
            LD      (#411B),HL
            LD      DE,(#40E1)  ;     
            CALL    x2F65       ;
            LD      C,D         ;  
            CALL    x2F3A       ;
            LD      HL,#4100    ;   #4100
            LD      B,1         ;1 
            CALL    x2D58       ; 
            LD      (#40E1),DE  ;      
            LD      C,0         ; 0
            CALL    x2F3A       ;
            CALL    x2D34       ;  8   #4000
            LD      A,(#4102)   ;   
            CALL    x2CE5       ;    
            LD      DE,#4110    ;  
            LD      BC,#10
            EX      DE,HL
            LDIR
            IN      A,(#5F)     ;   
            DEC     A
            LD      E,A
            LD      D,0
            LD      HL,#4000    ;   #4000
            CALL    x2D73       ; 
            LD      BC,#7FFD    ;   
            LD      A,(#4101)   ;    
            OUT     (C),A       ; 
x2C1B       LD      HL,(#4140)  ; SP
            LD      SP,HL
            LD      HL,#4000    ;   #4000
            LD      DE,#A       ; #A
            CALL    x2F1B       ; 
            LD      HL,#4100    ;   #4100
            LD      DE,#B       ; #B
            CALL    x2F1B       ; 
            LD      A,#3C       ;    #3C
            PUSH    AF
            JP      x2EBC       ;   

; #2C37.   ,    .   B    1   #5C00  #4101.

x2C37       LD      A,B         ;  
            DEC     A
            LD      (#4103),A   ; 
            LD      B,A         ; 
            LD      A,(#4101)   ;   
            AND     7
            CP      B           ; ?
            RET     Z           ; ,  
            LD      A,2         ;  2?
            CP      B
            RET     Z           ; ,  
            LD      A,(#4101)   ;    
            AND     8           ;  0?
            JR      Z,x2C55     ; ,     5
            LD      A,B         ;  7?
            CP      7
            RET     Z           ; ,  
            JR      x2C59       ; 
x2C55       LD      A,B         ;  5?
            CP      5
            RET     Z           ; ,  
x2C59       CALL    x2C5D       ; 
            RET                 ;

; #2C5D.   ,    .   B     #5C00  #4101.

x2C5D       LD      HL,#4101    ;    
            LD      A,(HL)
            AND     #F8         ;   
            LD      C,A
            LD      A,B         ;    
            OR      C           ;
            PUSH    BC          ;    
            LD      BC,#7FFD    ;  
            OUT     (C),A       ;  
            POP     BC          ;   
            LD      HL,#C000    ; 
x2C70       LD      A,(HL)      ;   
            OR      A           ; 0?
            JR      NZ,x2C7A    ; ,   
            INC     HL          ; 
            LD      A,H         ; ?
            OR      A
            JR      NZ,x2C70    ; ,  
            RET                 ;
x2C7A       CALL    x2C7E       ; 
            RET                 ;

; #2C7E.   .  #4103  #5C00.

x2C7E       LD      C,0         ; 0
            CALL    x2F3A       ;
            CALL    x2D2A       ;  8   #4000
            LD      A,(#40E4)   ;    
            LD      (#4102),A   ; 
            INC     A           ; 1 
            LD      (#40E4),A
            LD      HL,(#40E5)  ;     
            LD      DE,#40      ;   #40 
            SBC     HL,DE
            LD      (#40E5),HL  ;    
            RET     C           ;  ,  
            LD      HL,(#40E1)  ;     
            LD      (#411E),HL  ;    
            CALL    x2D1E       ;  
            LD      A,#40       ;  - #40 
            LD      (#411D),A
            LD      HL,#C000    ;  - #C000
            LD      (#4119),HL
            LD      HL,#4000    ; - #4000 
            LD      (#411B),HL
            LD      DE,(#40E1)  ;     
            CALL    x2D3E       ; 
            LD      (#40E1),DE  ;    
            LD      C,0         ; 0
            CALL    x2F3A       ;
            CALL    x2D34       ;  8   #4000
            LD      A,(#4102)   ;  
            CALL    x2CE5       ;    
            LD      DE,#4110    ;  
            LD      BC,#10
            EX      DE,HL
            LDIR
            IN      A,(#5F)     ;   
            DEC     A
            LD      E,A
            LD      D,0
            LD      HL,#4000    ;   #4000
            CALL    x2D73       ; 
            RET                 ;

; #2CE5.    #4000     A.    HL    .

x2CE5       LD      C,A         ;  
            AND     #F0         ;     
            RRCA
            RRCA
            RRCA
            RRCA
            LD      B,A
            PUSH    BC
            LD      E,B
            LD      D,0
            LD      HL,#4000    ;   #4000
            PUSH    DE          ;  
            CALL    x2F1B       ; 
            POP     DE          ;  
            POP     BC          ;  
            LD      B,0
            LD      A,C         ;   
            AND     #F          ;  
            RLCA
            RLCA
            RLCA
            RLCA
            LD      HL,#4000    ;  
            ADD     A,L
            LD      L,A
            RET                 ;

; #2D09.      "@"CODE   #4110.

x2D09       LD      HL,#4110    ;  
            LD      B,9         ;  - 9 
x2D0E       LD      (HL)," "    ; 
            INC     HL
            DJNZ    x2D0E
            LD      A,"@"       ;  - "@"
            LD      (#4110),A
            LD      A,"C"       ;  - "C"
            LD      (#4118),A
            RET                 ;

; #2D1E.    .  #4103.       #4110.

x2D1E       CALL    x2D09       ;   
            LD      A,(#4103)   ;  
            ADD     A,"0"       ;   
            LD      (#4111),A   ;  
            RET                 ;

; #2D2A.   8   #4000.  .

x2D2A       LD      HL,#4000    ;   #4000
            LD      DE,8        ; 8
            CALL    x2F1B       ; 
            RET                 ;

; #2D34.   8   #4000.  .

x2D34       LD      HL,#4000    ;   #4000
            LD      DE,8        ; 8
            CALL    x2D73       ; 
            RET                 ;

; #2D3E.  #40-    #C000.    #2D4C.

x2D3E       CALL    x2F65       ;
            LD      C,D         ;   
            CALL    x2F3A       ;
            LD      HL,#C000    ;   #C000
            LD      B,#40       ;#40 
            JR      x2D58       ;   

; #2D4C.  #C0    #4000   MAGIC.  DE       #5C00.    :
;#2D58 ( ;  HL    ,  DE -   ,  B ?  ,  #5C00      ).

x2D4C       CALL    x2F65       ;
            LD      C,D         ;   
            CALL    x2F3A       ;
            LD      HL,#4000    ;   #4000
            LD      B,#C0       ;#C0 
x2D58       PUSH    BC          ;  
            PUSH    DE          ;   
            CALL    x2D73       ; 
            LD      DE,#100     ;    
            ADD     HL,DE
            POP     DE          ;   
            INC     E           ; 
            LD      A,E         ; ?
            CP      #10
            JR      NZ,x2D6F    ; , 
            LD      E,0         ;  0,
            INC     D           ; ,
            LD      C,D
            CALL    x2F3A       ;
x2D6F       POP     BC          ;  
            DJNZ    x2D58       ;  
            RET                 ;

; #2D73.     GO TO.  HL   ,  E -  .

x2D73       LD      A,E         ;  
            INC     A
            OUT     (#5F),A
            PUSH    HL          ;  
            LD      D,#14       ;20 
            PUSH    DE          ;  
x2D7B       DI                  ; 
            LD      C,#7F       ;   
            LD      A,#A0       ;  
            OUT     (#1F),A
            CALL    x3FCA       ; 
            POP     DE          ;  
            POP     HL          ;   
            IN      A,(#1F)     ;  
            AND     #7F         ;  ?
            RET     Z           ; ,  
            DEC     D           ; 
            PUSH    HL          ;   
            PUSH    DE          ;  
            JR      NZ,x2D7B    ;   ,  

;!!!   !!!        ,  , .      ZX-P #5F/4   #23.

            HALT                ; 

; #2D92.  .  #5CE6, #5CEB  #5CEA.

x2D92       LD      HL,(#5CE6)  ;  
            LD      DE,(#5CEB)  ;    
            LD      A,(#5CEA)   ;  
            LD      B,A
            CALL    x1E3D       ; 
            RET                 ;

; #2DA1.   GO TO.  #5D11  #5C3B.      #2E27 (GO TO  48; ,    #2DA1).     #2EBC       .

x2DA1       CALL    x1DDF       ;     
            CALL    x1D75       ;    ,  
            CALL    x102E       ;  

;  ?  MAGIC      C.

            CALL    x1C57       ;  
            LD      (#4020),BC  ;   
            LD      A,C         ;  8 ?
            CP      8
            JR      NC,x2DD2    ; ,    48
            CALL    x0405       ;  
            CALL    x1CB3       ; 
            JP      NZ,x03D9    ;  ,  NO FILE
            LD      HL,#5CDD    ;   
            LD      BC,(#4020)  ;  

;    ?          .

            ADD     HL,BC       ;    
            LD      (HL),"8"    ; "8"   
            PUSH    HL          ;   
            CALL    x1CB3       ; 
            POP     HL          ;    
            JR      Z,x2DD8     ;  ,   
            LD      (HL)," "    ;   
x2DD2       CALL    x1CB3       ; 
            JP      x2E33       ; 
x2DD8       CALL    x165D       ;  
            CALL    x2D92       ; 
            LD      SP,#40FF    ; 
            LD      B,8         ; 8 
x2DE3       PUSH    BC          ;   
            LD      A,B
            LD      BC,#7FFD    ;   
            DEC     A           ;   0
            PUSH    AF          ;  
            OR      #10         ; 0,  1
            OUT     (C),A       ; 
            POP     AF          ;  
            ADD     A,"0"       ;     
            LD      HL,#5CDD    ;    
            LD      BC,(#4020)
            ADD     HL,BC
            LD      (HL),A      ;     
            CALL    x1CB3       ; 
            JR      NZ,x2E05    ;  ,    
            CALL    x165D       ;  
            CALL    x2D92       ; 

;!!!   A  p "DISC ERROR. RETRY,ABORT,IGNORE?",    ,   ERR_SP  #C000,             .

x2E05       POP     BC          ;   
            DJNZ    x2DE3       ;  
            LD      A," "       ;   
            LD      HL,#5CDD
            LD      BC,(#4020)
            ADD     HL,BC
            LD      (HL),A
            CALL    x1CB3       ; 
            CALL    x165D       ;  
            PUSH    BC          ;  
            PUSH    AF          ; AF
            LD      BC,#7FFD    ;  
            LD      A,(#4101)   ;       (  )
            OUT     (C),A       ;   
            POP     AF          ;    AF
            POP     BC
            JR      x2E39       ;  
x2E27       CALL    x1DDF       ;     
            CALL    x1D75       ;    ,  
            CALL    x102E       ;  
            CALL    x292F       ; 
x2E33       JP      NZ,x03D9    ;   ,  NO FILE
            CALL    x165D       ;  
x2E39       LD      A,(#5CDD)   ;    
            CP      "$"         ; "$"?
            DI                  ; 
            JR      NZ,x2E43    ; , 
            IM      2           ;   
x2E43       LD      SP,#40F0    ; 
            CALL    x3E11       ;  
            LD      (#4010),A   ; 
            LD      A,(#5D16)   ;   ,
            LD      (#4011),A
            LD      HL,(#5CE6)  ;   ,
            PUSH    HL
            LD      DE,(#5CEB)  ;    
            PUSH    DE
            INC     E           ;     
            LD      A,E
            CP      #10
            JR      NZ,x2E64
            LD      E,0
            INC     D
x2E64       LD      C,D         ;   
            CALL    x2F07       ;   
            LD      A,(#4010)   ;  
            AND     2           ; ?
            CALL    NZ,x2F0F    ; ,    
            LD      A,C         ;   
            CALL    x2F50       ;
            LD      HL,#4100    ;   #4100
            LD      B,#BF       ;#BF 
x2E79       PUSH    BC          ;  
            PUSH    DE          ;     
            CALL    x2F1B       ; 
            LD      DE,#100     ;    
            ADD     HL,DE
            POP     DE          ;     
            INC     E           ; 
            LD      A,E         ; ?
            CP      #10
            JR      NZ,x2E9C    ; ,   
            LD      E,0         ; 0
            INC     D           ; 
            LD      C,D
            CALL    x2F07       ; ( )
            LD      A,(#4010)
            AND     2
            CALL    NZ,x2F0F
            LD      A,C
            CALL    x2F50
x2E9C       POP     BC          ;  
            DJNZ    x2E79       ;  
            POP     DE          ;    
            POP     HL          ;  
            LD      SP,HL       ; 
            LD      A,(#4011)   ;   
            PUSH    AF          ; 
            LD      C,D         ; ( )
            CALL    x2F07
            LD      A,(#4010)
            AND     2
            CALL    NZ,x2F0F
            LD      A,C
            CALL    x2F50
            LD      HL,#4000    ;    
            CALL    x2F1B       ; 
x2EBC       POP     AF          ;   
            EX      AF,AF'      ;  
            POP     AF          ;  R  I
            JP      MAGregR     ;#A0A ;LD (#5C01),A:POP AF
x2EC2       LD      I,A
            DI                  ; 
            LD      A,#FF       ;  
            JP      PO,x2ECC
            LD      A,0
x2ECC       LD      (#5C00),A
            POP     AF          ; 
            POP     HL
            POP     DE
            POP     BC
            EXX
            EX      AF,AF'
            POP     IY
            POP     IX
            POP     HL
            POP     DE
            POP     BC
            LD      A,(#5C48)   ;  
            AND     #38
            RRCA
            RRCA
            RRCA
            OUT     (#FE),A
            LD      A,(#5B08)   ;   #5B08
            CP      #EE         ; #EE?
            JR      NZ,x2EF7    ; ,    128 

;!!!  #EE   #5B08      p.

            PUSH    BC          ; BC
            LD      BC,#7FFD    ;  
            LD      A,(#5B5C)   ;   BANK_M
            OUT     (C),A       ;  
            POP     BC          ; BC
x2EF7       LD      A,(#5C00)   ;  
            OR      A           ; ?
            LD      A,#C9       ;    
            LD      (#5C00),A
            JR      NZ,x2F03    ;  #5C00  0, 
            EI                  ; 
x2F03       JP      MAGsetR     ;#A11 ;R=(#5C01)
            NOP

; #2F07.       GO TO.  #4011.     :
;#2F0C      #FF.

x2F07       LD      A,(#4011)   ;   
            OR      #3C         ; - 
x2F0C       OUT     (#FF),A     ;  
            RET                 ;

; #2F0F.       GO TO. :  #4011,   C        . :  C        .

x2F0F       LD      A,C         ;    2
            OR      A
            RRA
            LD      C,A
            RET     NC          ;  ,  
            LD      A,(#4011)   ;   
            AND     #6F         ; - 
            JR      x2F0C       ;    

;p #2F1B.     GO TO.  HL   ,  E -  .

x2F1B       LD      A,E         ;  
            INC     A
            OUT     (#5F),A
            PUSH    HL          ;  
            LD      D,#14       ;20 
            PUSH    DE          ;  
x2F23       DI                  ; 
            LD      C,#7F       ;   
            LD      A,#80       ;  
            OUT     (#1F),A
            CALL    x3FE5       ; 
            POP     DE          ;  
            POP     HL          ;   
            IN      A,(#1F)     ;  
            AND     #7F         ;  ?
            RET     Z           ; ,  
            DEC     D           ; 
            PUSH    HL          ;   
            PUSH    DE          ;  
            JR      NZ,x2F23    ;   ,  
            HALT                ; 

; #2F3A.    MAGIC.      C   #5C00.    :
;#2F50 -    GO TO.   A   .
;#2F57 -     INTRQ.    A.

x2F3A       LD      A,#3C       ;   
            OUT     (#FF),A
            LD      A,(#5C00)   ;  
            AND     8           ; ?
            JR      NZ,x2F4F    ; ,  
            LD      A,C         ;    2
            OR      A
            RRA
            LD      C,A
            JR      NC,x2F4F    ;  ,  
            LD      A,#2C       ;   
            OUT     (#FF),A
x2F4F       LD      A,C
x2F50       OUT     (#7F),A     ;     
            CALL    x3D30       ;RET
            LD      A,#18       ; 
x2F57       OUT     (#1F),A
x2F59       IN      A,(#FF)     ;  INTRQ
            AND     #80
            JR      Z,x2F59
            PUSH    BC          ; BC
            CALL    x3DFD       ;  725779 
            POP     BC          ; BC
            RET                 ;

; #2F65.    MAGIC.

x2F65       LD      A,8         ; 
            JR      x2F57       ; ,  INTRQ  

; #2F69.   ,    .  #5C3A     #1D3.

x2F69       LD      HL,(#5D1C)  ; 
            DEC     HL
            DEC     HL
            LD      SP,HL
            JP      x1D2F       ;   

; #2F72.     .       CALL #2F72:
;CALL #2F72
;DW #0D6B

x2F72       LD      (#5D02),HL  ; HL  DE
            LD      (#5D04),DE
            POP     HL          ;        
            LD      E,(HL)      ;  
            INC     HL
            LD      D,(HL)
            INC     HL
            PUSH    HL          ;      ,  #2F72
            LD      HL,x3D2F    ;       TR-DOS
            PUSH    HL
            PUSH    DE          ;     
            LD      HL,#5CC2    ;     RET  
            PUSH    HL
            LD      HL,(#5D02)  ; HL  DE
            LD      DE,(#5D04)
            RET                 ;   RET  

; #2F90.     p TR-DOS.   :
; #5CFA - #5CFD, #5CC8 - #5CCB, #5C3A, #5D16, #5D0C - #FF; #5D17 - #5D19, #5D1F - 0; #5CC2 - #C9;     #FF    .      :
;#2FC3      #1F.

x2F90       LD      HL,#FFFF
            LD      (#5CFA),HL  ;  
            LD      (#5CFC),HL
            LD      (#5CC8),HL  ;   
            LD      (#5CCA),HL  ;
            XOR     A
            LD      (#5D17),A   ; 
            LD      (#5D19),A   ;   - A:
            LD      (#5D18),A   ;  
            LD      (#5D0F),A   ;p   TR-DOS
            LD      (#5D1F),A
            LD      A,#FF       ;  
            OUT     (#FF),A
            LD      (#5C3A),A   ; 
            LD      (#5D16),A   ;   
            LD      (#5D0C),A   ; 
            LD      A,#C9       ;    RET
            LD      (#5CC2),A
            LD      A,#D0       ; 
x2FC3       OUT     (#1F),A     ; 
            RET                 ;

; #2FC6.       .

x2FC6       CALL    x050C       ;     
            LD      A,(HL)      ;    
            OR      A           ; ?
            JP      Z,x03AC     ; ,   
            CP      1           ; ?
            CALL    Z,x0507     ; ,   
            RET     NZ          ; 
            JR      x2FC6       ;

; #2FD6.    .  DE     .

x2FD6       LD      B,1         ; 1 
            LD      HL,#5D25    ;  
            JP      x1E67       ; 

; #2FDE.   .  HL -  ,  #5CDC - ,  #5CF4 -  .

x2FDE       PUSH    HL          ;  
            LD      DE,(#5CF4)  ;    
            CALL    x2FD6       ;   
            LD      A,(#5CDB)   ;    
            POP     DE          ;  
            OR      A           ; 0 ?
            RET     Z           ; ,  
            LD      C,A         ;      
            LD      HL,#5D25    ;   
            LDIR
            RET                 ;

; #2FF3.   TR-DOS.

x2FF3       DB      #CF,"*",#D0,#D1,#E6,#D2,#EF,#F8,#FE,#BE,#F4,#D5,#F7
            DB      #D3,#D4,#FF,"4",#EC,"8",#F0,#D6

; #3008.   ,   TR-DOS.

x3008       DW      x0433,x1018,x1EC2,x16AB,x053A,x0787,x1815,x1AD0,x1CFB,x19A5
            DW      x19A9,x19B1,x1D4D,x2182,x2656,x0690,KILLREZ,x2DA1
            DW      x29AE
            DW      x11CE,x1810

; #3032.   .     .   #5CD6 #FF   #5D11.

x3032       LD      HL,(#5C59)  ;   
            LD      (#5D11),HL  ;   
            LD      (#5CD9),HL  ;   
            LD      A,#FF       ;  
            LD      (#5CD6),A
            LD      HL,#5CDB    ; 
            LD      (#5CD7),HL
            JR      x3057       ;   

; #3048.   .  HL   .  #5CD6  #5D11.    :
;#3057 ( ;  #5CD6, #5CD7  #5CD9).

x3048       LD      (#5D11),HL  ;  
            LD      (#5CD9),HL  ;    
            CALL    x30E1       ;,   
            RET     NZ          ;   ,  
            INC     HL          ;    
            INC     HL
            LD      (#5CD7),HL  ;    
x3057       CALL    x30A9       ;   
            JR      NZ,x3087    ;    ,   
            EX      DE,HL       ;       DE
            INC     DE          ;     
            LD      B,0         ;     2-  
            LD      HL,x31C8    ;    
            ADD     HL,BC       ;    
            LD      A,(HL)      ;  
            LD      HL,(#5CD9)  ;   
            LD      (HL),A      ;   
            INC     HL          ;     
            EX      DE,HL       ;   DE
            RST     #20         ;   
            DW      #19DD
            PUSH    BC          ; 
            RST     #20         ;  
            DW      #19E8
            POP     BC          ;   
            LD      A,(#5CD6)   ;     ?
            OR      A
            JR      NZ,x3087    ; ,      
            LD      HL,(#5CD7)  ;    
            LD      E,(HL)      ;  
            INC     HL
            LD      D,(HL)
            EX      DE,HL       ;   HL
            OR      A
            SBC     HL,BC       ; 
            EX      DE,HL       ;  DE
            LD      (HL),D      ;  
            DEC     HL
            LD      (HL),E
x3087       LD      HL,(#5CD9)  ;   
            LD      A,(HL)      ;  
            CP      #D          ; ENTER?
            RET     Z           ; ,  
            INC     HL          ; 
            LD      (#5CD9),HL
            LD      A,(HL)      ; 
            CP      #D          ; ENTER?
            RET     Z           ; ,  
            CP      #22         ; ?
            JR      NZ,x3057    ; ,  
x309A       INC     HL          ; 
            LD      A,(HL)      ; 
            CP      #D          ; ENTER?
            RET     Z           ; ,  
            CP      #22         ; ?
            JR      NZ,x309A    ; ,   
            INC     HL          ; 
            LD      (#5CD9),HL
            JR      x3057       ;

; #30A9.    .  #5CD9.     Z ,   C    ,   HL -     ;      ,   HL    #5CD9.

x30A9       LD      HL,(#5CD9)  ;     
            LD      DE,x30FD    ;   
            LD      C,0         ;   0
x30B1       LD      A,(HL)      ;     
            AND     #DF         ; 
            LD      B,A         ;   B
            OR      A           ; CHR$ 0?
            JR      NZ,x30BB    ; , 
            INC     HL          ; 
            JR      x30B1       ; 
x30BB       LD      A,(DE)      ;   
            AND     #80         ;  7 ?
            JR      NZ,x30C8    ; ,    
            LD      A,(DE)      ;    
            CP      B           ; 
            JR      NZ,x30D9    ;   ,    
            INC     HL          ;  
            INC     DE
            JR      x30B1       ;
x30C8       LD      A,(DE)      ;   
            AND     #7F         ;  7
            CP      B           ; 
            RET     Z           ;  ,  
x30CD       INC     C           ;  
            LD      HL,(#5CD9)  ;     
            INC     DE          ;   
            LD      A,(DE)
            CP      #FF         ; ?
            JR      NZ,x30B1    ; ,  
            OR      A           ;  Z
            RET                 ;
x30D9       INC     DE          ;   
            LD      A,(DE)
            AND     #80         ;  7 ?
            JR      Z,x30D9     ; ,   
            JR      x30CD       ;   

; #30E1.   .  #5CD6,   HL       2.

x30E1       LD      HL,(#5C45)  ;   
            INC     HL          ;  ?
            INC     HL
            LD      A,H
            OR      L
            JR      Z,x30F4     ; ,   
            XOR     A           ;      
            LD      (#5CD6),A
            DEC     HL          ;  
            DEC     HL
            RST     #20         ;  
            DW      #196E
            RET                 ;
x30F4       LD      A,#FF       ;  
            LD      (#5CD6),A
            LD      HL,(#5C59)  ; 
            RET                 ;

; #30FD.    TR-DOS.

x30FD       DB      "SAVE"
            DB      #80
            DB      "SAV"
            DB      #C5
            DB      "LOAD"
            DB      #80
            DB      "LOA"
            DB      #C4
            DB      "RUN"
            DB      #80
            DB      "RU"
            DB      #CE
            DB      "CAT"
            DB      #80
            DB      "CA"
            DB      #D4
            DB      "ERASE"
            DB      #80
            DB      "ERAS"
            DB      #C5
            DB      "NEW"
            DB      #80
            DB      "NE"
            DB      #D7
            DB      "MOVE"
            DB      #80
            DB      "MOV"
            DB      #C5
            DB      "MERGE"
            DB      #80
            DB      "MERG"
            DB      #C5
            DB      "PEEK"
            DB      #80
            DB      "PEE"
            DB      #CB
            DB      "POKE"
            DB      #80
            DB      "POK"
            DB      #C5
            DB      "OPEN"
            DB      #83
            DB      "CLOSE"
            DB      #83
            DB      "CODE"
            DB      #80
            DB      "COD"
            DB      #C5
            DB      "RND"
            DB      #80
            DB      "RN"
            DB      #C4
            DB      "DATA"
            DB      #80
            DB      "DAT"
            DB      #C1
            DB      "SCREEN"
            DB      4,#84
            DB      "SCREEN"
            DB      #84
            DB      "COPY"
            DB      #80
            DB      "COP"
            DB      #D9
            DB      "FORMAT"
            DB      #80
            DB      "FORMA"
            DB      #D4
            DB      "GOTO"
            DB      #80
            DB      "GOT"
            DB      #CF
            DB      "LIST"
            DB      #80
            DB      "LIS"
            DB      #D4
            DB      "LINE"
            DB      #80
            DB      "LIN"
            DB      #C5
            DB      "VERIFY"
            DB      #80
            DB      "VERIF"
            DB      #D9
            DB      #FF,#FF

; #31C8.     TR-DOS.

x31C8       DB      #F8,#F8,#EF,#EF,#F7,#F7,#CF,#CF,#D2,#D2,#E6,#E6,#D1
            DB      #D1,#D5,#D5,#BE,#BE,#F4,#F4,#D3,#D4,#AF,#AF,#A5,#A5
            DB      #E4,#E4,#AA,#AA,#FF,#FF,#D0,#D0,#EC,#EC,#F0,#F0,#CA
            DB      #CA,#D6,#D6,0

; #31F3.     TR-DOS.   ,   C  ,  .

x31F3       LD      HL,(#5C4F)  ;    
            OR      A           ;  
            LD      BC,#5D25    ;        TR-DOS.
            SBC     HL,BC       ;  C
            RET                 ;

KILLREZ     CALL    CLEAR
            JP      x03E1       ;"O.K."

CLEAR       LD      A,#D7
            LD      BC,#7FFD
            OUT     (C),A
            LD      (#C000),A
            LD      (#FFF0),A
            LD      A,#10
            OUT     (C),A
            RET

            DISPLAY "Free space at ",$,": ",/D,#321C-$," byte(s)"
            DS      #321C-$,#FF

SETERRAD    LD      A,#0D       ;call  #246 ; #21D
            LD      (#5D20),A
            JP      x021D

POSIT       PUSH    HL          ;call  #20CC ; #3E44
            PUSH    BC
            PUSH    AF
            PUSH    DE
            LD      A,#ED
            LD      (#5C86),A
            LD      A,#0C
            LD      (#5C8A),A
            LD      A,E
            JR      LL323d
LL3235      LD      A,(HL)
            CP      #FF
            RET     Z
            RST     #10
            INC     HL
            JR      LL3235
LL323d      LD      B,"0"
LL323f      SUB     10
            JR      C,LL3246
            INC     B
            JR      LL323f
LL3246      PUSH    AF
            LD      A,B
            RST     #10
            POP     AF
            ADD     A,"0"+10
            RST     #10
            POP     DE
            POP     AF
            POP     BC
            POP     HL
            EI
            JP      x3E44       ;

TFormTS     DB      "Format track       Side",0
TFile       DB      #16,0,0
            DB      "File ",34
            DB      #13,1,#FF
TExists     DB      #13,0
            DB      34,#D
            DB      "Exists!Overwrite?(Y/N/Add)"
            DB      #FF
TComplete   DB      "Complete"
            DB      #D
            DB      "Name:",0
TFORMAT     DB      "FORMAT:   1 - Normal   "
            DB      #D,#17,#A
            DB      " 2 - Turbo"
            DB      #D,#17,#A
            DB      " 3 - Fast turbo"
            DB      0

CHECKON     INC     HL          ;call  #20C1 ; XOR A:INC HL:LD (HL),A ;#5CD8
            LD      A,(#5CE8)
            LD      (HL),A
            XOR     A
            RET

PRHD1       PUSH    AF          ;call  #20DE ; #330F
            LD      A,"1"
            JR      LL32f9
PRHD0       PUSH    AF          ;call  #20D2 ; #32DD
            LD      A,"0"
LL32f9      PUSH    AF
            LD      A,#F8
            LD      (#5C86),A
            LD      A,#17
            LD      (#5C8A),A
            POP     AF
            RST     #10
            POP     AF
            JP      x1FFD       ; 
LL330a      CALL    x1D9F       ;  Overwrite ;  
            LD      HL,TFile
            CALL    LL3235
            CALL    LL3329
            LD      HL,TExists
            CALL    LL3235
            LD      HL,#4000
LL331f      DEC     HL
            LD      A,H
            OR      L
            JR      NZ,LL331f
            CALL    x1052       ;   
            JR      LL3338
LL3329      LD      A,(#5CF6)
            ADD     A,"A"
            RST     #10
            LD      A,":"
            RST     #10
            LD      HL,#5CDD    ; 
            JP      x2938       ;   
LL3338      PUSH    AF
            CALL    x1D9F       ;  
            POP     AF
            CP      "Y"
            RET     Z
            CP      "A"         ;#D
            RET
LL3343      CALL    x165D       ;      ; 1AC1, SVNASTRDSK ;     
            LD      HL,#5CE5
            SET     7,(HL)      ; overwrite=ON
            RET

FORMDISK    CALL    x1D9F       ;call  #1F1B ; #20BD ;  
            LD      HL,TFormTS
            RST     #18
            CALL    x20BD       ; 
            CALL    x1D9F       ;  
            LD      HL,TComplete
            RST     #18
            RET

TPressR     DB      "Press R to repeat",("."+#80),0   ; ASKREPFORM

SAVEFIL     CALL    x1D9F       ;   ;jp  #290C ; jr  ; #1B53
            CALL    x3E11       ;  
            RET

SELFORMAT   CALL    x1D9F       ;   ;call  #1EDD ; #3200
            LD      HL,TFORMAT
            RST #18
LL337f      CALL    x1052       ;   
            CP      #11
            JR      Z,LL3395
            CP      #12
            JR      Z,LL33a1
            CP      #13
            JR      Z,LL33a6
            CP      0
            JP      Z,x01D3     ;/ 
            JR      LL337f
LL3395      LD      HL,x1FB9    ;. SLOW 
LL3398      XOR     A
LL3399      LD      (#5CE8),A
            LD      (#5CE6),HL
            JR      SAVEFIL
LL33a1      LD      HL,LL33ad   ;..FAST
            JR      LL3398
LL33a6      LD      A,#01
            LD      HL,LL33ad   ;..FAST
            JR      LL3399

LL33ad      DB  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,1 ; #325A

SUB14       LD      A,L
            SUB     #0E
            LD      L,A
            RET     NC
            DEC     H
            RET

PARAMZAG    LD      A,(#5CE5)   ;call  #18AB ; a,(#5CD6) ;  PEEK,   Wolfed
            CP      "B"
            JR      Z,LL33e2
            CP      "D"
            JR      Z,LL33e2
            CP      "#"
            JR      Z,LL33e2
            LD      A,"C"
LL33e2      LD      A,(#5CD6)
            RET

SVNASTRDSK  CALL    x1CF0       ; 
            CALL    Z,LL3343    ; . . . .Overwr=ON
LL33ec      CALL    x0405       ;. . -   -
            CALL    x1AC4       ; =128 
            JP      x1B53       ;     

SAVER       LD      HL,#5CE5    ;  + "file exist" flag ;call  #1B53 ; #1B59
            BIT     7,(HL)
            RES     7,(HL)
            JP      Z,x1B59
LL33ff      CALL    LL330a      ;Y/N
            JP      NZ,x01D3    ;/ 
            CP      "A"
            JP      Z,x1B59
            LD      DE,(#5CD9)
            DEC     DE
            INC     D
            LD      A,(#5CEA)
            CP      D
            JR      Z,LL341b
            CALL    x2926       ; 
            JR      LL33ec
LL341b      LD      B,D
            LD      HL,(#5C59)
            LD      (HL),#AA
            INC     HL
            LD      DE,(#5CD1)
            LD      (HL),E
            INC     HL
            LD      (HL),D
            LD      C,#06
            LD      HL,(#5CDB)
            LD      (#5CE8),HL
            LD      HL,(#5CD7)
            LD      (#5CE6),HL
            LD      DE,(#5CEB)
            CALL    x1E4D
            LD      BC,(#5D1E)
            CALL    x1BBF
            CALL    x1665
            RET

OBROSH      EI                  ;jp  #3D17 ; #2F69
            JP      x2F69

POSITPP     PUSH    AF          ;jp  #3E4E
            LD      A,(#5CCE)   ;0=READ,#FF=WRITE
            OR      A
            JR      Z,POSppRD
            POP     AF
            PUSH    BC
            LD      B,A
            IN      A,(#3F)
            CP      B           ; #3E52   !
            POP     BC
            JP      POSITCONT   ;#3E54
POSppRD     POP     AF
            IN      A,(#1F)
            AND     #80
            JP      POSITCONT   ;#3E54

PPNORESC000 LD      HL,#FFF0    ;   #C000 ;jp  #3C48 ;  #FFF0
            XOR     A
LL379e      XOR     (HL)
            ADC     A,H
            INC     L
            JR      NZ,LL379e
            CP      #06         ;"RESIDENTPRESENT!" ; -  8bit!
            JP      Z,#C000
            XOR     A
            CALL    MEMDRV_
            LD      B,#13       ;   #5B00
            LD      H,#5B
            XOR     A
LL37b1      XOR     (HL)
            ADC     A,L
            ADC     A,(HL)
            INC     L
            DJNZ    LL37b1
            CP      #68         ; -  8bit!
            LD      A,7
            JP      NZ,x0009
            XOR     A
            LD      (#5B04),A
            LD      (#5B0D),A

            IFDEF   COMPILE_FOR_MADROM
                LD      HL,#FE00
            ELSE
                LD      HL,#00C7
            ENDIF
            
            LD      (#5B11),HL
            JP      #5B00

USEmovSPD   PUSH    HL          ; #3E44 ;call  #3EBF
            PUSH    AF
            CALL    x3E08       ;  . .
            LD      B,A
            POP     AF
            POP     HL
            JP      x3E44
NEWER       LD      HL,(#5D11)  ; #1DCD
            INC     HL
            LD      A,(HL)
            CP      #D
            JR      Z,NEWRel
            CALL    x1DCD       ;NEW new,old
            JP      L53D
NEWRel      LD      HL,TRel
            RST     #18
            JP      x01D3       ;/ 

TRel        DB      "Rel: 03.04.10",#D,0

TCH1        LD      A,(#5CF6)   ;1-   
            CP      RMD_DRIVE;#03
            JR      Z,L1
            LD      A,(#5CCE)
            CALL    x1E36       ;  
            JP      TCH1Q       ;#1E70
L1          PUSH    DE
            CALL    TEST_R
            JP      NZ,x3EE1    ;NO DISK
            POP     DE,HL,BC
            XOR     A
            OR      B
            RET     Z
RD_SV       PUSH    BC,HL
            CALL    SECTR
            POP     HL
            INC     H
            PUSH    HL
            LD      HL,#5CF4
            LD      A,#10
            INC     (HL)
            CP      (HL)
            JR      NZ,LL3838
            LD      (HL),#00
            INC     HL,(HL)
LL3838      POP     HL,BC
            DJNZ    RD_SV
            RET

;  Ram-Disk'
;,   
; 128K -    D

TEST_R      DI
            LD      A,#08
            LD      B,#83
L2          PUSH    AF
            LD      (#5CFD),A
            LD      A,B
            LD      (#5CCB),A
            XOR     A
            OUT     (#FF),A
            LD      A,(#5CF6)
            ADD     A,#3C
            LD      (#5D16),A
            OUT     (#FF),A
            LD      A,#D0
            OUT     (#1F),A
            POP     AF
            EI
            RET

SECTR       LD      DE,(#5CF4)
            LD      A,H
            CP      #BF
            JR      C,RED_SAV
            LD      A,#FF
            CALL    LL38A6
            LD      A,(#5CCE)
            AND     A
            JR      Z,LL38C0
            LD      DE,#5D25,BC,#0100
            LDIR
            LD      HL,#5D25,DE,(#5CF4)
            CALL    RED_SAV
LL38A4      LD      A,#00
LL38A6      EXA
            LD      A,(#5CCE)
            EXA
            LD      (#5CCE),A
            PUSH    HL,DE
            LD      HL,#5D25,DE,#000F
            CALL    RED_SAV
            POP     DE,HL
            EX      AF,AF'
            LD      (#5CCE),A
            RET
LL38C0      PUSH    HL
            LD      HL,#5D25
            CALL    RED_SAV
            LD      HL,#5D25
            POP     DE
            LD      BC,#0100
            LDIR
            JR      LL38A4

RED_SAV     DI                  ; - / RAM-DISK
            CALL    FPG         ; .   ...
            LD      A,D         ;.
            CPL                 ; 
            RRCA
            AND     #FE
            LD      C,A
            LD      B,0
            PUSH    IX
            LD      IX,PG_TAB
            ADD     IX,BC
;            LD      BC,#1FFD  ;(VELESOFT - zxm phoenix 2048 port 1FFD)
                IFDEF      RAM_ZX_PROFI_1024
                LD      BC,#0DFFD  ;(VELESOFT - ZX PROFI 1024 port DFFD)
                ENDIF
                IFDEF      RAM_PENTAGON_1024
                LD      BC,#7FFD  ;(VELESOFT - PENTAGON 1024 port 7FFD)
                ENDIF
                IFDEF      RAM_SCORPION_1024
                LD      BC,#1FFD  ;(VELESOFT - SCORPION 1024 port 1FFD)
                ENDIF
                IFDEF      RAM_ZXM_PHOENIX
                LD      BC,#1FFD  ;(VELESOFT - ZXM PHOENIX port 1FFD)
                ENDIF
            LD      A,(IX)
            OUT     (C),A
            INC     IX
;            LD      B,#7F     ;(VELESOFT - remove this instruction)
            LD      BC,#7FFD   ;(VELESOFT - BC = full 16bit adress)
            LD      A,(IX)
            OUT     (C),A
            LD      A,D
            RLCA
            RLCA
            RLCA
            RLCA
            AND     #30
            ADD     A,E
            OR      #C0
            LD      D,A,E,#00
            LD      A,(#5CCE)
            AND     A
            JR      NZ,LL38F9
            EX      DE,HL
LL38F9      LD      BC,#0100
            LDIR
            LD      D,0
            LD      A,(#5C81)
            LD      E,A
            LD      HL,PG_TAB
            ADD     HL,DE
;            LD      BC,#1FFD  ;(VELESOFT - zxm phoenix 2048 port 1FFD)
                IFDEF      RAM_ZX_PROFI_1024
                LD      BC,#0DFFD  ;(VELESOFT - ZX PROFI 1024 port DFFD)
                ENDIF
                IFDEF      RAM_PENTAGON_1024
                LD      BC,#7FFD  ;(VELESOFT - PENTAGON 1024 port 7FFD)
                ENDIF
                IFDEF      RAM_SCORPION_1024
                LD      BC,#1FFD  ;(VELESOFT - SCORPION 1024 port 1FFD)
                ENDIF
                IFDEF      RAM_ZXM_PHOENIX
                LD      BC,#1FFD  ;(VELESOFT - ZXM PHOENIX port 1FFD)
                ENDIF
            LD      A,(HL)
            OUT     (C),A
            INC     HL
            LD      A,(HL)
;            LD      B,#7F     ;(VELESOFT - remove this instruction)
            LD      BC,#7FFD   ;(VELESOFT - BC = full 16bit adress)
            OUT     (C),A
            POP     IX
            EI
            RET

;  ( HONEY  /  /)
;6.05 %00abcdef
;6.11 %bca0?def

MEMDRV_     OR      #10
            LD      BC,#7FFD
            OUT     (C),A
            RET

TCH2        LD      (#5CF6),A   ;2-   - 
            CP      RMD_DRIVE;#03
            JP      NZ,TCH2Q    ;#3DCE
            CALL    TEST_R
            JP      NZ,x3EE1    ; ?etc
            RET

TCH3        CALL    x1C57 ;3-   -  ;  
            LD      A,(#5CF6)
            CP      RMD_DRIVE;#03
            RET     NZ
            POP     AF
            CALL    FILL
            LD      DE,#0000
            LD      (#5CF4),DE
            LD      BC,#0010
FORMT       PUSH    BC
            LD      A,#FF
            LD      (#5CCE),A,HL,#5D25,B,#01
            CALL    RD_SV
            POP     BC
            DEC     BC
            LD      A,B
            OR      C
            JR      NZ,FORMT
            ;free=...
;            LD      HL,#0DF0   ; 896 (#0DF0 = number of free 256B sectors in ramdisc = 892kB)
            LD      HL,RMD_SIZE ; (VELESOFT - number of free 256B sectors in ramdisc)
            LD      A,#16
            JP      x1F55       ;.FORMAT  LD HL,2544

FILL        LD      HL,#5D25,DE,#5D26
            LD      BC,#00FF,(HL),B
            LDIR
            RET

FPG         PUSH    DE,HL       ;  PAGE 0-128 
            EX      AF,AF
            PUSH    AF
            LD      DE,(#C000)
            LD      HL,(#FFFD)
            PUSH    HL
            LD      BC,#7FFD
            LD      (#C000),BC
            LD      (#FFFD),BC
            XOR A
FPG1        DEC     A
            DEC     A
            LD      HL,PG_TAB
            LD      B,0
            LD      C,A
            ADD     HL,BC
;            LD      BC,#1FFD  ;(VELESOFT - zxm phoenix 2048 port 1FFD)
                IFDEF      RAM_ZX_PROFI_1024
                LD      BC,#0DFFD  ;(VELESOFT - ZX PROFI 1024 port DFFD)
                ENDIF
                IFDEF      RAM_PENTAGON_1024
                LD      BC,#7FFD  ;(VELESOFT - PENTAGON 1024 port 7FFD)
                ENDIF
                IFDEF      RAM_SCORPION_1024
                LD      BC,#1FFD  ;(VELESOFT - SCORPION 1024 port 1FFD)
                ENDIF
                IFDEF      RAM_ZXM_PHOENIX
                LD      BC,#1FFD  ;(VELESOFT - ZXM PHOENIX port 1FFD)
                ENDIF
            EX      AF,AF
            LD      A,(HL)
            OUT     (C),A
            INC     HL
            LD      A,(HL)
;            LD      B,#7F     ;(VELESOFT - remove this instruction)
            LD      BC,#7FFD   ;(VELESOFT - BC = full 16bit adress)
            OUT     (C),A
            EX      AF,AF
            LD      HL,(#C000)
            SBC     HL,BC
            JR      NZ,FPG1
            LD      HL,(#FFFD)
            SBC     HL,BC
            JR      NZ,FPG1
            LD      (#C000),DE
            LD      (#5C81),A
            POP     HL
            POP     AF
            EX      AF,AF
            LD      (#FFFD),HL
            POP     HL,DE
            RET

;   80DS (- 5.04)
;,   (- 5.03)

TCH4        LD      HL,#8383
            LD      (#5CC8),HL,(#5CCA),HL
            LD      A,#F7       ;   
            IN      A,(#FE)
            LD      B,0
            RRA
            JR      NC,DRV11
            INC     B
            RRA
            JR      NC,DRV11
            INC     B
            RRA
            JR      NC,DRV11
            INC     B
            RRA
            JR      NC,DRV11
            JR      L3
DRV11       LD      A,B,(#5CF6),A,(#5D19),A
            OR      #3C
            LD      (#5D16),A
            OUT     (#FF),A
L3          JP      x106E       ;    

MOVEPP      LD      HL,(#5CE1)
LL3b03      LD      A,(HL)
            CP      #00
            RET     Z
            CP      #01
            JR      Z,LL3b0e
            CALL    LL3b14
LL3b0e      LD      DE,#0010
            ADD     HL,DE
            JR      LL3b03
LL3b14      PUSH    HL
            LD      DE,#000D
            ADD     HL,DE
            LD      C,(HL)
            INC     HL
            LD      E,(HL)
            INC     HL
            LD      D,(HL)
            LD      HL,(#5CD7)
            AND     A
            SBC     HL,DE
            ADD     HL,DE
            JR      Z,LL3b56
            LD      (#5CD5),DE
            LD      A,C
            LD      (#5CD3),A
            CALL    x17A5       ; 
LL3b32      POP     HL
            PUSH    HL
            LD      DE,(#5CDF)
            LD      BC,#0010
            LDIR
            LD      (#5CDF),DE
            EXD
            LD      DE,(#5CDD)
            DEC     HL
            LD      (HL),D
            DEC     HL
            LD      (HL),E
            LD      HL,(#5CD7)
            LD      (#5CDD),HL
            LD      HL,#5CE3
            INC     (HL)
            POP     HL
            RET

LL3b56      LD      A,C
            AND     #0F
            ADD     A,E
            BIT     4,A
            RES     4,A
            LD      E,A
            JR      Z,$+3
            INC     D
            LD      A,C
            RRC     A
            RRC     A
            RRC     A
            RRC     A
            AND     #0F
            ADD     A,D
            LD      D,A
            LD      (#5CD7),DE
            JR      LL3b32

GETCOM      RES     5,(IY+#01)  ;jp  #2154 ; #1D90 - ???
            RST     #20
            DW      #15D4       ;WAIT_KEY
            CP      7
            JR      NZ,LL3bad
            LD      HL,#00C8
            LD      D,H
            LD      E,(IY-#01)
            RST     #20
            DW      #03B5       ;beep
            CALL    x212A       ;  
            LD      HL,(#5C59)
            LD      A,#0D
            LD      BC,0
            CPIR
            DEC     HL
            LD      (#5C5B),HL
            INC     HL
            INC     HL
            LD      (HL),#80
LL3baa      RST     #20
            DW      #15D4       ;WAIT_KEY
LL3bad      PUSH    AF
            LD      HL,#00C8
            LD      D,H
            LD      E,(IY-#01)
            RST     #20
            DW      #3B5        ;beep
            POP     AF
            CP      #18
            JR      NC,LL3bca
            CP      #07
            JR      C,LL3bca
            CP      #10
            JR      C,LL3bcf
            RST     #20
            DW      #F58        ; ED_LOOP: sym>=16
            JR      LL3baa
LL3bca      RST     #20
            DW      #F81        ;ADD_CHAR
            JR      LL3baa
LL3bcf      CP      #07
            JR      Z,LL3baa
            CP      #0D
            RET     Z
            CP      #0A
            JR      Z,LL3baa
            CP      #0B
            JR      Z,LL3baa
            RST     #20
            DW      #F92        ;ED_KEYS
            JR      LL3baa

WHOD        CALL    x1D9F       ;  TR-DOS ;jp  #3D35 ; #239 ;  
            JP      x0239       ;   

OUTDE       LD      C,D
            OUT     (C),E
            RET

INED        LD      C,D
            IN      E,(C)
            RET

JPWRITE     LD      C,#7F
            JP      x3FBA
JPREAD      LD      C,#7F
            JP      x3FD5

;Free space for new routines
            
;--- FIXED HL' BY VELESOFT ---
            IFDEF   FIX_HL
PATCH_HL    EXX
            LD HL,#2758
            EXX
            JR NZ,END_HL
            DEC HL
            LD (#5C3D),HL
END_HL      RET
            ENDIF
;--- END OF FIXED HL' ---


;--- tables for memory paging for ramdisc support ---

        IFDEF      RAM_ZX_PROFI_1024
;(VELESOFT) table of values for paging ports (DW #1000 = OUT #7FFD,#10 + OUT #DFFD,#00) - values for ZX PROFI 1024 kB
PG_TAB      DW      #1000,#1100,#1200,#1300,#1400,#1500,#1600,#1700
            DW      #1001,#1101,#1201,#1301,#1401,#1501,#1601,#1701
            DW      #1002,#1102,#1202,#1302,#1402,#1502,#1602,#1702
            DW      #1003,#1103,#1203,#1303,#1403,#1503,#1603,#1703
            DW      #1004,#1104,#1204,#1304,#1404,#1504,#1604,#1704
            DW      #1005,#1105,#1205,#1305,#1405,#1505,#1605,#1705
            DW      #1006,#1106,#1206,#1306,#1406,#1506,#1606,#1706
            DW      #1007,#1107,#1207,#1307,#1407,#1507,#1607,#1707
            
            DW      #1000,#1100,#1200,#1300,#1400,#1500,#1600,#1700
            DW      #1001,#1101,#1201,#1301,#1401,#1501,#1601,#1701
            DW      #1002,#1102,#1202,#1302,#1402,#1502,#1602,#1702
            DW      #1003,#1103,#1203,#1303,#1403,#1503,#1603,#1703
            DW      #1004,#1104,#1204,#1304,#1404,#1504,#1604,#1704
            DW      #1005,#1105,#1205,#1305,#1405,#1505,#1605,#1705
            DW      #1006,#1106,#1206,#1306,#1406,#1506,#1606,#1706
            DW      #1007,#1107,#1207,#1307,#1407,#1507,#1607,#1707
        ENDIF

        IFDEF      RAM_ZXM_PHOENIX
;table of values for paging ports (DW #1000 = OUT #7FFD,#10 + OUT #1FFD,#00) - values for ZXM PHOENIX 2048 kB
PG_TAB      DW      #1000,#1100,#1200,#1300,#1400,#1500,#1600,#1700
            DW      #1080,#1180,#1280,#1380,#1480,#1580,#1680,#1780
            DW      #1010,#1110,#1210,#1310,#1410,#1510,#1610,#1710
            DW      #1090,#1190,#1290,#1390,#1490,#1590,#1690,#1790
            DW      #9000,#9100,#9200,#9300,#9400,#9500,#9600,#9700
            DW      #9080,#9180,#9280,#9380,#9480,#9580,#9680,#9780
            DW      #9010,#9110,#9210,#9310,#9410,#9510,#9610,#9710
            DW      #9090,#9190,#9290,#9390,#9490,#9590,#9690,#9790

            DW      #1040,#1140,#1240,#1340,#1440,#1540,#1640,#1740
            DW      #10C0,#11C0,#12C0,#13C0,#14C0,#15C0,#16C0,#17C0
            DW      #1050,#1150,#1250,#1350,#1450,#1550,#1650,#1750
            DW      #1090,#1190,#1290,#1390,#1490,#1590,#1690,#1790
            DW      #9040,#9140,#9240,#9340,#9440,#9540,#9640,#9740
            DW      #90C0,#91C0,#92C0,#93C0,#94C0,#95C0,#96C0,#97C0
            DW      #9050,#9150,#9250,#9350,#9450,#9550,#9650,#9750
            DW      #90D0,#91D0,#92D0,#93D0,#94D0,#95D0,#96D0,#97D0
        ENDIF
        
        IFDEF      RAM_PENTAGON_1024
;(VELESOFT) table of values for paging ports (DW #1000 = OUT #7FFD,#10 + next byte are ignored) - values for PENTAGON 1024 kB
PG_TAB      DW      #1010,#1111,#1212,#1313,#1414,#1515,#1616,#1717
            DW      #5050,#5151,#5252,#5353,#5454,#5555,#5656,#5757
            DW      #9090,#9191,#9292,#9393,#9494,#9595,#9696,#9797
            DW      #D0D0,#D1D1,#D2D2,#D3D3,#D4D4,#D5D5,#D6D6,#D7D7
            DW      #3030,#3131,#3232,#3333,#3434,#3535,#3636,#3737
            DW      #7070,#7171,#7272,#7373,#7474,#7575,#7676,#7777
            DW      #B0B0,#B1B1,#B2B2,#B3B3,#B4B4,#B5B5,#B6B6,#B7B7
            DW      #F0F0,#F1F1,#F2F2,#F3F3,#F4F4,#F5F5,#F6F6,#F7F7
            
            DW      #1010,#1111,#1212,#1313,#1414,#1515,#1616,#1717
            DW      #5050,#5151,#5252,#5353,#5454,#5555,#5656,#5757
            DW      #9090,#9191,#9292,#9393,#9494,#9595,#9696,#9797
            DW      #D0D0,#D1D1,#D2D2,#D3D3,#D4D4,#D5D5,#D6D6,#D7D7
            DW      #3030,#3131,#3232,#3333,#3434,#3535,#3636,#3737
            DW      #7070,#7171,#7272,#7373,#7474,#7575,#7676,#7777
            DW      #B0B0,#B1B1,#B2B2,#B3B3,#B4B4,#B5B5,#B6B6,#B7B7
            DW      #F0F0,#F1F1,#F2F2,#F3F3,#F4F4,#F5F5,#F6F6,#F7F7
        ENDIF
        
        IFDEF      RAM_SCORPION_1024
;(VELESOFT) table of values for paging ports (DW #1000 = OUT #7FFD,#10 + OUT #1FFD,#00) - values for SCORPION 1024 kB
PG_TAB      DW      #1000,#1100,#1200,#1300,#1400,#1500,#1600,#1700
            DW      #1010,#1110,#1210,#1310,#1410,#1510,#1610,#1710
            DW      #1040,#1140,#1240,#1340,#1440,#1540,#1640,#1740
            DW      #1050,#1150,#1250,#1350,#1450,#1550,#1650,#1750
            DW      #1080,#1180,#1280,#1380,#1480,#1580,#1680,#1780
            DW      #1090,#1190,#1290,#1390,#1490,#1590,#1690,#1790
            DW      #10C0,#11C0,#12C0,#13C0,#14C0,#15C0,#16C0,#17C0
            DW      #10D0,#11D0,#12D0,#13D0,#14D0,#15D0,#16D0,#17D0
            
            DW      #1000,#1100,#1200,#1300,#1400,#1500,#1600,#1700
            DW      #1010,#1110,#1210,#1310,#1410,#1510,#1610,#1710
            DW      #1040,#1140,#1240,#1340,#1440,#1540,#1640,#1740
            DW      #1050,#1150,#1250,#1350,#1450,#1550,#1650,#1750
            DW      #1080,#1180,#1280,#1380,#1480,#1580,#1680,#1780
            DW      #1090,#1190,#1290,#1390,#1490,#1590,#1690,#1790
            DW      #10C0,#11C0,#12C0,#13C0,#14C0,#15C0,#16C0,#17C0
            DW      #10D0,#11D0,#12D0,#13D0,#14D0,#15D0,#16D0,#17D0
        ENDIF
        
;--- end of table for memory paging (ramdisc) ---

;--- show new text info about memory mode ---
SHOW_TXT    LD      HL,NEW_TEXT
            RST     #18
            JP      TCH4
NEW_TEXT    
            IFDEF   RAM_ZX_PROFI_1024
            DB      #16,7,5
            DB      "ZX Profi 1024"
            ENDIF
            
            IFDEF   RAM_PENTAGON_1024
            DB      #16,7,5
            DB      "Pentagon 1024"
            ENDIF
            
            IFDEF   RAM_SCORPION_1024
            DB      #16,7,5
            DB      "Scorpion 1024"
            ENDIF

            IFDEF   RAM_ZXM_PHOENIX
            DB      #16,7,5
            DB      "ZXM Phoenix"
            ENDIF

            DB      #16,8,5
            DB      "Ramdisk on drive : "
            DB      65+RMD_DRIVE
            DB      0
;--- end of text info ... ---


;end of free space for new routines

            DISPLAY "Free space for expansions ",$,": ",/D,#3C30-$," byte(s)"
            DS      #3C30-$,#FF

            IN      A,(#1F)
            RET

NACALO      LD      SP,#5BFF    ;  (3 )
            LD      A,#C7       ;1F ;   #C000
            CALL    MEMDRV_
            LD      HL,#C000
            LD      A,(HL)
            CP      #C3
NORESC000   JP      NZ,PPNORESC000
            XOR     A
LL3c61      ADD     A,(HL)
            ADC     A,0
            INC     HL
            BIT     7,H
            JR      NZ,LL3c61
            DEC     A
            JR      NZ,NORESC000
            LD      A,#AA
            DEC     HL
            CP      (HL)
            JR      NZ,NORESC000
            CPL
            DEC     HL
            CP      (HL)
            JR      NZ,NORESC000
            LD      HL,#D000
            LD      DE,#5B00
            LD      BC,#2500
            LDIR
            LD      SP,#5F00
            LD      A,#C6       ;1E
            CALL    LDIfrC0
            LD      A,#03
            CALL    LDItoC0
            LD      A,#C5       ;1D
            CALL    LDIfrC0
            LD      A,#01
            CALL    LDItoC0
            LD      A,#C4       ;1C
            CALL    LDIfrC0
            XOR     A
            CALL    LDItoC0
            LD      A,#C3       ;1B
            CALL    LDIfrC0
            XOR     A
            CALL    MEMDRV_
            LD      SP,(#5B73)
            RET

LDItoC0     CALL    MEMDRV_
            SCF
            JR      LDIR40

LDIfrC0     CALL    MEMDRV_
            XOR     A
LDIR40      LD      HL,#C000
            LD      DE,#8000
            LD      BC,#4000
            JR      NC,$+3
            EXD
            LDIR
            RET

            DISPLAY "Free space at ",$,": ",/D,#3CFA-$," byte(s)"
            DS      #3CFA-$,#FF

; #3CFA.  ,   #20F1.

x3CFA       JP      x20F1

; #3CFD.  ,   #3D13,    .

x3CFD       JP      x283C

; #3D00.   TR-DOS.  .

x3D00       NOP
            JR      x3D31

; #3D03.   TR-DOS  .  CH_ADD   :REM:  .   BC  .  .

x3D03       NOP
            JR      x3D1A

; #3D06.     .  .            ,    A   .

x3D06       NOP
            JP      x25EF

; #3D0A.  ,   #3D0D,    .

x3D0A       JP      x244A

; #3D0D.     .    .     #3D0E.     .

x3D0D       NOP
x3D0E       JR      x3D0A

; #3D10.  ,   #20F1.  .

x3D10       NOP
            JR      x3CFA

; #3D13.      TR-DOS   .   .

x3D13       NOP
            JR      x3CFD

; #3D16.     .   .

x3D16       NOP
            JP      OBROSH      ;#3449

; #3D1A.  ,   #3D03,    .

x3D1A       CALL    x3D21       ;   TR-DOS
            PUSH    HL          ;       
            JP      x016C       ; 

; #3D21.     TR-DOS,   .  HL  #5CC2.

x3D21       CALL    x31F3       ;    
            NOP
            NOP
            CALL    C,x3D4C     ;  ,   
            LD      HL,#5CC2    ;  HL     
            RET                 ;

            NOP
            NOP

; #3D2F.    TR-DOS     .    .

x3D2F       NOP
x3D30       RET

; #3D31.   TR-DOS.

x3D31       CALL    x3D21       ;   
            PUSH    HL          ;       
            JP      WHOD        ;#3BF0 ;  TR-DOS

; #3D38.   -1.            #5CF1  1.          .

x3D38       XOR     A           ;-1 ?
            OUT     (#F7),A
            IN      A,(#F7)
            CP      #1E
            JR      Z,x3D44     ; ,     
            CP      #1F
            RET     NZ          ; ,  
x3D44       RST     8           ;   -1
            DB      #31
            LD      A,1         ;  SAVE  1 
            LD      (#5CEF),A
            RET                 ;

; #3D4C.    TR-DOS.   -1    TR-DOS      #5CEF  1.   TR-DOS :  #5CFA - #5CFC, #5CC8 - #5CCA, #5C3A, #5D16  #5D0C - #FF;  #5D17, #5D19, #5D18, #5D0F  #5D1F - 0;  #5CC2 - #C9.      #FF,   93   .     .

x3D4C       XOR     A           ;  A:   93
            OUT     (#FF),A
            IN      A,(#F6)     ;   
            LD      HL,x3D38    ;    -1
            LD      DE,#5C92    ;  , 
            LD      BC,#14      ; 
            LDIR                ;   
            LD      HL,x3D67    ;   
            PUSH    HL          ;   
            LD      HL,x3D2F    ;    TR-DOS
            PUSH    HL          ;   
            JP      #5C92       ; 

; #3D67.    TR-DOS.   :  #5CFA - #5CFD, #5CC8 - #5CCB, #5C3A, #5D16  #5D0C - #FF;  #5D17, #5D19, #5D18, #5D0F  #5D1F - 0;  #5CC2 - #C9.      #FF,   93   .

x3D67       LD      HL,x2F90    ;    
            PUSH    HL          ;   
            LD      HL,x3D2F    ;    TR-DOS
            PUSH    HL          ;   
            LD      HL,#1655    ;  MAKE_ROOM   
            PUSH    HL          ;   
            LD      HL,#5BFF    ;    
            PUSH    HL          ;   
            LD      (HL),#C9    ;    RET
            LD      HL,#5CB5    ;    
            LD      BC,#70      ; 
            RET                 ;  MAKE_ROOM

; #3D80.  .     #3D82 (   ).        #3D8B  #4F6.

x3D80       LD      A,#D        ; ENTER
x3D82       JP      DOSSYM      ;#805

            DS      9,#FF
            DB      #FF,0,0,#FF,#FF,#FF

; #3D94.     .    .

x3D94       RST     #20
            DW      #0010
            RET

; #3D98.    INTRQ.     #3D9A (   .A   INTRQ).

x3D98       LD      A,8         ;
x3D9A       OUT     (#1F),A
x3D9C       PUSH    HL          ; HL
            RST     #20         ;  BREAK
            DW      #1F54
            JR      C,x3DA5     ; ,   *BREAK*
            RST     #20
            DW      #1B7B
x3DA5       POP     HL          ; HL
            IN      A,(#FF)     ;INTRQ ?
            AND     #80
            JR      Z,x3D9C     ; ,  
            RET                 ;

; #3DAD.     .    .

x3DAD       LD      A,8         ; 
            CALL    x3D9A       ;    INTRQ
            LD      DE,0        ; #10000     
            IN      A,(#1F)     ;    
            AND     2
            LD      B,A         ; 
x3DBA       IN      A,(#1F)     ;  
            AND     2
            CP      B           ; ?
            RET     NZ          ; ,  
            INC     DE          ; 
            LD      A,E         ; 
            OR      D
            JR      NZ,x3DBA    ; ,  
            JP      x3EE7       ;  NO DISC

; #3DC8.  ,   . :            #01. :        .    :
;#3DCB -  .    .A,      .
;#3DFD -   725779 .
;#3DFF -    .  .A  ,   .

x3DC8       LD      A,(#5D19)   ;    
x3DCB       JP      TCH2        ;  
TCH2Q       LD      HL,#5D16    ; 
            LD      C,A
            LD      A,#3C
            OR      C
            OUT     (#FF),A
            LD      (HL),A
            CALL    x3E08       ;    
            AND     #80         ; 7 ?
            JR      Z,x3DFA     ; ,    
            CALL    x3DAD       ;    
            CALL    x3E16       ;    
            CALL    x3E11       ;  
            CP      #FF         ;   #FF?
            JR      NZ,x3DFA    ; ,    
            PUSH    HL          ;     
            CALL    x1FCA       ;   
            POP     HL          ;   
            CP      #50         ;  
            LD      A,0
            JR      NZ,x3DF9
            LD      A,#80
x3DF9       LD      (HL),A

;, !!!       ,   .

x3DFA       CALL    x1E36       ;   
x3DFD       LD      A,#50       ;  327842 
x3DFF       LD      C,#FF
x3E01       DEC     C
            JR      NZ,x3E01
            DEC     A
            JR      NZ,x3DFF
            RET                 ;

; #3E08.      .  #5CF6.    A     ,   HL - ,    .     #3E0B (  ;  DE       #5CF6;    A  ,  HL -   ).

x3E08       LD      DE,#5CFA    ;     
x3E0B       LD      HL,(#5CF6)  ;   
            ADD     HL,DE       ;    
            LD      A,(HL)      ;  
            RET                 ;

; #3E11.   . :  #5CF6. :  A  ,  HL -   .

x3E11       LD      DE,#5CC8    ;    
            JR      x3E0B       ;   

; #3E16.     .

x3E16       CALL    x3E08       ;      
            LD      B,8         ;  
            LD      C,4         ;4 
x3E1D       LD      (HL),B      ;   
            LD      A,8         ;
            CALL    x3D9A
            
            IFDEF   TEST_DRIVES
                LD      A,#10   ;???????????????? ?? ??????? #10
            ELSE
                RET
                DB      #20     ;
            ENDIF
            
            LD      B,#B
            CALL    x3E44
            LD      B,(HL)      ;   
            LD      A,1         ;   1   
            CALL    x3E44
            IN      A,(#1F)     ;   0?
            AND     4
            JR      NZ,x3E3F    ; ,  
            XOR     A           ;   0
            CALL    x3E44
            IN      A,(#1F)     ;   0?
            AND     4
            RET     NZ          ; ,  
x3E3F       INC     B           ;     1
            DEC     C           ; 
            RET     Z           ;  ,  
            JR      x3E1D       ;

; #3E44. .  A    ,  B -      .

x3E44       OUT     (#7F),A     ;     
            LD      A,B         ;  
            OR      #18
            JP      x0800       ;   

;!!!   JP #3D9A, .. #800      ,       .

; #3E4C. .    A     ,   B -    .

x3E4C       OUT     (#7F),A     ;     
            JP      POSITPP     ;#3780
            CCF
            CP      B
            POP     BC          ;   
POSITCONT   PUSH    AF          ;  
            LD      A,B         ;  
            OR      #18
            CALL    x0800       ;      INTRQ

;!!!        , ..  #800  AND #FC.       JP #3D9A.

            POP     AF          ;    
            RET     Z           ;   ,  
            PUSH    BC          ;   ?
            CALL    x3DFD       ;  725779 
            POP     BC          ;   
            RET                 ;

; #3E63.   . :  .A        #5CCD.   #5CCD .    :
;#3EA0 (  3135098 ).

x3E63       LD      C,A         ;     C
            CALL    x1FEB       ;   
            CALL    x3E11       ;  
            AND     2           ; ?
            CALL    NZ,x3EAA    ; ,   
            PUSH    BC          ;  
            BIT     7,(HL)      ; 40-?
            JR      Z,x3E83     ; ,     
            BIT     0,(HL)      ;  40 ?
            JR      NZ,x3E83    ; ,     
            IN      A,(#3F)     ;   
            CP      C           ;  ?
            JR      Z,x3E82     ; ,     
            RLCA                ;     2
            OUT     (#3F),A
            LD      A,C         ;     2
            RLCA
x3E82       LD      C,A
x3E83       CALL    x3E08       ;    
            LD      B,A
            IN      A,(#3F)     ;  ?
            CP      C
            PUSH    BC          ;   
            CALL    NZ,x3D30    ;RET( CALL  )
            POP     BC          ;   
            LD      A,C
            CALL    x3E4C       ;
            POP     BC          ;   
            LD      A,C         ;  
            OUT     (#3F),A
            LD      A,(#5CCD)   ;   ?
            OR      A
            RET     Z           ; ,  
            XOR     A           ;     
            LD      (#5CCD),A
x3EA0       LD      B,3         ;  3135098 
x3EA2       LD      A,#FF
            CALL    x3DFF
            DJNZ    x3EA2
            RET                 ;

; #3EAA.    . :  C         . :   ,   C    .

x3EAA       LD      A,C         ;    2
            OR      A
            RRA
            LD      C,A
            RET     NC          ;    ,  
            JP      x1FF6       ;    

; #3EB2.    .  #5CD1    B    .        #5D17  #FF.   H    .    :
;#3EE7 (  NO DISC).

x3EB2       CALL    x1FEB       ;   
x3EB5       IN      A,(#1F)     ;  
            AND     #80         ;  
            LD      (#5CCD),A
            IN      A,(#3F)     ;   
            LD      H,A         ;  
            CALL    USEmovSPD   ;#37CD
            LD      C,#7F       ;  
            LD      D,1         ;,   
            DI                  ; 
            LD      A,#C0       ;  
            OUT     (#1F),A
            PUSH    BC          ;   
            LD      B,3         ;  
x3ECE       IN      A,(#FF)     ;   DRQ  INTRQ
            AND     #C0
            JR      NZ,x3EF2    ; -  ,   
            INC     DE          ; 
            LD      A,E
            OR      D
            JR      NZ,x3ECE
            DJNZ    x3ECE       ;   
            POP     BC          ;   
            EI                  ; 
            LD      A,#D0       ; 
            OUT     (#1F),A
x3EE1       LD      A,(#5CD1)   ; ?

;!!!  LD A,(#5D17).

            CP      #FF
            RET     Z           ; ,  
x3EE7       CALL    x272B       ; TAPE LOADING ERROR
            LD      A,#FF       ;    
            LD      (#5D17),A
            JP      x271B       ;  NO DISC
x3EF2       POP     BC          ;   
            IN      H,(C)       ;  
x3EF5       IN      A,(#FF)     ; - 
            AND     #C0
            JR      Z,x3EF5
            EI                  ;  

;!!!      .

            RET     M           ;  INTRQ,  
            DI                  ; 
            IN      A,(#7F)     ; 
            JR      x3EF5       ;

; #3F02.    .

x3F02       LD      (#5CFF),A
            RET

; #3F06.   .

x3F06       LD      (#5D00),HL
            RET

; #3F0A.  .     #5CFF  #5D00.

x3F0A       LD      A,#A0       ;  
            JR      x3F10       ;    /  

; #3F0E.  .  #5CFF  #5D00   .    :
;#3F10 (/ ;    #3F0E   A      ).

x3F0E       LD      A,#80       ;  
x3F10       LD      (#5CFE),A   ; 
x3F13       LD      D,#A        ;10 
x3F15       PUSH    DE          ;  
            DI                  ; 
            LD      A,(#5CFF)   ; 
            INC     A
            OUT     (#5F),A
            LD      HL,(#5D00)  ;  /
            LD      C,#7F       ;   
            LD      A,(#5CFE)   ; 
            OUT     (#1F),A
            CP      #A0         ;   ?
            PUSH    AF
            CALL    Z,x3FBA     ; ,   
            POP     AF
            CALL    NZ,x3FD5    ;  
            POP     DE          ;  
            EI                  ; 
            IN      A,(#1F)     ;  
            LD      B,A         ; 
            AND     #7F         ;  ?
            RET     Z           ; ,  
x3F39       LD      HL,x29D8    ;  READ ONLY
            AND     #40         ; ?
            JR      NZ,x3F4B    ; ,     
            LD      A,B         ;  
            AND     4           ;  ?
            JR      Z,x3FA0     ; ,    
            DEC     D           ; 
            JR      NZ,x3F15    ;   ,  
x3F48       LD      HL,x29E2    ;  DISC ERROR
x3F4B       LD      A,#D0       ; 
            OUT     (#1F),A
            LD      A,B         ;  
            AND     1           ;  ?
            JP      NZ,x3EE7    ; ,    NO DISC
            IN      A,(#3F)     ;     #A 
            OR      A           ;0,   ()
            JR      NZ,x3F5F
            IN      A,(#5F)
            CP      #A
            RET     Z
x3F5F       PUSH    HL          ;  
            CALL    x1D97       ; 
            POP     HL          ;  
            RST     #18         ; 
            LD      HL,x2A13    ; TRK:
            RST     #18
            IN      A,(#3F)     ;  
            CALL    x1DA3
            LD      HL,x2A18    ; SEC:
            RST     #18
            IN      A,(#5F)     ;  
            CALL    x1DA3
            LD      HL,x29FE    ; RETRY,ABORT,IGNORE?
            RST     #18
x3F7B       CALL    x1052       ; 
            CP      "I"         ; I?
            RET     Z           ; ,  
            CP      "R"         ; R?
            JR      Z,x3F94     ; ,    
            CP      "A"         ; A?
            JR      NZ,x3F7B    ; ,    
            CALL    x272B       ; TAPE LOADING ERROR
            LD      A,7         ; 
            LD      (#5D0F),A
            JP      x01D3       ;
x3F94       LD      A,(#5CF5)   ;
            CALL    x3E63
            CALL    x3EA0       ;  3135098 
            JP      x3F13       ;
x3FA0       DEC     D           ; 
            JP      Z,x3F48     ;  ,   DISC ERROR
            PUSH    DE          ;  
            CALL    x3E08       ;    
            AND     2           ;  #A?
            JR      NZ,x3FAD
            INC     (HL)        ; ,     1
x3FAD       CALL    x3D98       ;
            LD      A,(#5CF5)   ;
            CALL    x3E63
            POP     DE          ;  
            JP      x3F15       ;

; #3FBA.    .   HL   ,  DE - ,   ,     ,  C -        .     #3FCA ( ,   #3FBA,    NO DISC).

x3FBA       LD      B,4         ;  
x3FBC       IN      A,(#FF)     ; - ?
            AND     #C0
            JR      NZ,x3FD1    ; ,   
            INC     DE          ; 
            LD      A,E
            OR      D
            JR      NZ,x3FBC
            DJNZ    x3FBC
            RET                 ;  ,  
x3FCA       IN      A,(#FF)     ; - ?
            AND     #C0
            JR      Z,x3FCA     ; ,   
            RET     M           ;  INTRQ,  
x3FD1       OUTI                ;       
            JR      x3FCA       ;

; #3FD5.    .     #3FBA,     .    p #3FE5 ( ,   #3FD5,    NO DISC).

x3FD5       LD      B,4         ;  
x3FD7       IN      A,(#FF)     ; -?
            AND     #C0
            JR      NZ,x3FEC    ; ,   
            INC     DE          ; 
            LD      A,E
            OR      D
            JR      NZ,x3FD7
            DJNZ    x3FD7
            RET                 ;  ,  
x3FE5       IN      A,(#FF)     ; - ?
            AND     #C0
            JR      Z,x3FE5     ; ,   
            RET     M           ;  INTRQ,  
x3FEC       INI                 ; 
            JR      x3FE5       ;

x3FF0       OUT     (C),A       ;"",    ,
            RET                 ; ...

x3FF3       IN  A,(C)           ;  ,     ,
            RET                 ;    #3DXX.   ...

            DISPLAY "Free space at ",$,": ",/D,#4000-$," byte(s)"
            DS      #4000-$,#FF

            IFDEF   RAM_ZX_PROFI_1024
            SAVEBIN "TR-DOS_6.11Q_ZX_PROFI1024.ROM",0,#4000
            ENDIF
            
            IFDEF   RAM_PENTAGON_1024
            SAVEBIN "TR-DOS_6.11Q_PENTAGON1024.ROM",0,#4000
            ENDIF
            
            IFDEF   RAM_SCORPION_1024
            SAVEBIN "TR-DOS_6.11Q_SCORPION1024.ROM",0,#4000
            ENDIF
            
            IFDEF   RAM_ZXM_PHOENIX
            SAVEBIN "TR-DOS_6.11Q_ZXM_PHOENIX.ROM",0,#4000
            ENDIF
            
            
            